'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	COMPRESSBANK
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem	
Function CompressBank:TBank ( SourceBank:TBank, CompressionLevel:Int = 9 )
	
	Local	SourceSize:Int 							=	SourceBank.Size ( )
	Local	DestinationSize:Int						=	( SourceSize + SourceSize / 10 + 32 )
	Local	DestinationBank:TBank						=	TBank.Create ( DestinationSize )
	
	compress2 ( DestinationBank.Buf ( ) + 4, DestinationSize, SourceBank.Buf ( ), SourceSize, CompressionLevel )
	
	DestinationBank.PokeByte( 0, SourceSize )
	DestinationBank.PokeByte( 1, SourceSize Shr 8 )
	DestinationBank.PokeByte( 2, SourceSize Shr 16 )
	DestinationBank.PokeByte( 3, SourceSize Shr 24 )
	
	DestinationBank.Resize ( DestinationSize + 4 ) 

	Return ( DestinationBank )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	UNCOMPRESSBANK
'---------------------------------------------------------------------------------------------------------------------------------------------------------


Rem
bbdoc:
End Rem		
Function UncompressBank:TBank ( SourceBank:TBank )

	Local	SourceSize:Int 							=	SourceBank.Size ( )
	Local	DestinationSize:Int						=	0
	
	DestinationSize :| SourceBank.PeekByte ( 0 )
	DestinationSize :| SourceBank.PeekByte ( 1 ) Shl 8
	DestinationSize :| SourceBank.PeekByte ( 2 ) Shl 16
	DestinationSize :| SourceBank.PeekByte ( 3 ) Shl 24

	Local	DestinationBank:TBank						=	TBank.Create ( DestinationSize )

	uncompress ( DestinationBank.Buf ( ), DestinationSize, SourceBank.Buf ( ) + 4, SourceSize - 4 )

	Return ( DestinationBank )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FINISHED
'---------------------------------------------------------------------------------------------------------------------------------------------------------


