'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ShuffleStringArray:String [ ] ( Source:String [ ] )

	Local	Result:String [ Source.Length ], i:Int
	
		For	Local t:String = EachIn Source
		
			Repeat
			
				i							=	Rand ( 0, Source.Length - 1 ) 			
			
			Until Result [ i ] = ""
		
			Result [ i ]						=	t
		
		Next
		
	Return ( Result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PrintStringArray ( Source:String [ ] )

		For	Local t:String = EachIn Source
		
			Print ( t )
		
		Next	

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StringArrayToString:String ( Source:String [ ], Seperator:String = "~n" )

	Local	Result:String
	
		For	Local t:String = EachIn Source
		
			Result							:+	( t + Seperator )
		
		Next	
	
	Return ( Result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StringArrayToIntArray:Int [ ] ( Source:String [ ] )

	Local	Result:Int [ ]
	
		For	Local t:String = EachIn Source
		
			Result							:+	[ Int ( t ) ]
		
		Next	
	
	Return ( Result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StringArrayToFloatArray:Float [ ] ( Source:String [ ] )

	Local	Result:Float [ ]
	
		For	Local t:String = EachIn Source
		
			Result							:+	[ Float ( t ) ]
		
		Next	
	
	Return ( Result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StringToArray:String [ ] ( Source:String )

	Local	Result:String [ ]
	
		For	Local i:Int = 0 Until Source.Length
		
			Result							:+	[ Chr ( Source [ i ] ) ]
		
		Next	
	
	Return ( Result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StringArrayRemove:String [ ] ( Source:String [ ], Content:String )

	Local	Result:String [ ]
	
		For	Local i:Int = 0 Until Source.Length
			
			If	Source [ i ] <> Content
			
				Result						:+	[ Source [ i ] ]
		
			EndIf
			
		Next	
	
	Return ( Result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StringArrayReplace:String [ ] ( Source:String [ ], Content:String, Content2:String )

	Local	Result:String [ ]
	
		For	Local i:Int = 0 Until Source.Length
			
			If	Source [ i ] <> Content
			
				Result						:+	[ Source [ i ] ]
			
			Else
			
				Result						:+	[ Content2 ]
		
			EndIf
			
		Next	
	
	Return ( Result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MinFloatArray:Float ( Array:Float [ ] )
	
	If	Array
	
		Local	Result:Float						=	Array [ 0 ]

		For	Local Value:Float = EachIn Array

			Result							=	Min ( Result, Value )

		Next

		Return ( Result )
		
	Else
	
		Return ( 0.00 )
	
	EndIf
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MaxFloatArray:Float ( Array:Float [ ] )
	
	If	Array
	
		Local	Result:Float						=	Array [ 0 ]

		For	Local Value:Float = EachIn Array

			Result							=	Max ( Result, Value )

		Next

		Return ( Result )
		
	Else
	
		Return ( 0.00 )
	
	EndIf
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MinIntArray:Int ( Array:Int [ ] )
	
	If	Array
	
		Local	Result:Int						=	Array [ 0 ]

		For	Local Value:Int = EachIn Array

			Result							=	Min ( Result, Value )

		Next

		Return ( Result )
		
	Else
	
		Return ( 0 )
	
	EndIf
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MaxIntArray:Int ( Array:Int [ ] )
	
	If	Array
	
		Local	Result:Int							=	Array [ 0 ]

		For	Local Value:Int = EachIn Array

			Result							=	Max ( Result, Value )

		Next

		Return ( Result )
		
	Else
	
		Return ( 0 )
	
	EndIf
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MinByteArray:Byte ( Array:Byte [ ] )
	
	If	Array
	
		Local	Result:Byte 						=	Array [ 0 ]

		For	Local Value:Byte = EachIn Array

			Result							=	Min ( Result, Value )

		Next

		Return ( Result )
		
	Else
	
		Return ( 0 )
	
	EndIf
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MaxByteArray:Byte ( Array:Byte [ ] )
	
	If	Array
	
		Local	Result:Byte 						=	Array [ 0 ]

		For	Local Value:Byte = EachIn Array

			Result							=	Max ( Result, Value )

		Next

		Return ( Result )
		
	Else
	
		Return ( 0 )
	
	EndIf
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function IntArrayContains:Int ( Array:Int [ ], Value:Int )

		For	Local i:Int = 0 Until Array.Length
		
			If	Array [ i ] = Value
			
				Return ( i + 1 )
			
			EndIf
		
		Next
		
		Return ( 0 )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FloatArrayContains:Int ( Array:Float [ ], Value:Float )

		For	Local i:Int = 0 Until Array.Length
		
			If	Array [ i ] = Value
			
				Return ( i + 1 )
			
			EndIf
		
		Next
		
		Return ( 0 )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StringArrayContains:Int ( Array:String [ ], Value:String )

		For	Local i:Int = 0 Until Array.Length
		
			If	Array [ i ] = Value
			
				Return ( i + 1 )
			
			EndIf
		
		Next
		
		Return ( 0 )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FilledIntArray:Int [ ] ( Value:Int, Num:Int )
		
		Local Array:Int [ ]
		
		For	Local i:Int = 0 Until Num
		
			Array								:+	[ Value ]
		
		Next
		
		Return ( Array )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FilledFloatArray:Float [ ] ( Value:Float , Num:Int )
		
		Local Array:Float [ ]
		
		For	Local i:Int = 0 Until Num
		
			Array								:+	[ Value ]
		
		Next
		
		Return ( Array )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FilledStringArray:String [ ] ( Value:String , Num:Int )
		
		Local Array:String [ ] 
		
		For	Local i:Int = 0 Until Num
		
			Array								:+	[ Value ]
		
		Next
		
		Return ( Array )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function IntArrayRand:Int ( Array:Int [ ] )

		Return ( Array [ Rand ( 0, Array.Length - 1 ) ] )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FloatArrayRand:Float ( Array:Float [ ] )

		Return ( Array [ Rand ( 0, Array.Length - 1 ) ] )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function StringArrayRand:String ( Array:String [ ] )

		Return ( Array [ Rand ( 0, Array.Length - 1 ) ] )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GatherIntArray:Int ( Array:Int [ ] )

	Local	Result:Int
	
		For	Local n:Int = EachIn Array
		
			Result :+ n
		
		Next

	Return ( Result )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GatherFloatArray:Float ( Array:Float [ ] )

	Local	Result:Float
	
		For	Local n:Float = EachIn Array
		
			Result :+ n
		
		Next

	Return ( Result )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GatherStringArray:String ( Array:String [ ] )

	Local	Result:String
	
		For	Local n:String = EachIn Array
		
			Result :+ n
		
		Next

	Return ( Result )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------------------------------------------------

