'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	MODULE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

SuperStrict

Rem
bbdoc: AVA.Core
End Rem
Module AVA.Core

ModuleInfo	"Version: 1.10"
ModuleInfo	"Authors: Ava Vanessa Poldrack"
ModuleInfo	"Copyright: Ava Vanessa Poldrack"

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	IMPORTS
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
Import BRL.System
Import BRL.Math
Import BRL.Retro
Import BRL.Map
Import BRL.LinkedList
Import BRL.Pixmap

Import AVA.BankExt

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	INCLUDES
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Include "error.bmx"
Include "list.bmx"
Include "math.bmx"
Include "pixmap.bmx"
Include "string.bmx"
Include "swap.bmx"
Include "array.bmx"
Include "random.bmx"

Include "stack\stack.bmx"

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

SeedRnd ( MilliSecs ( ) )

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: AVA.Core
End Rem
Function StringToKeyCode:Int ( KeyString:String )
		
		KeyString								=	Upper ( KeyString )
		
		Select KeyString
		
			Case	"KEY_1"							Return ( KEY_1 )
			Case	"KEY_2"							Return ( KEY_2 )
			Case	"KEY_3"							Return ( KEY_3 )
			Case	"KEY_4"							Return ( KEY_4 )
			Case	"KEY_5"							Return ( KEY_5 )
			Case	"KEY_6"							Return ( KEY_6 )
			Case	"KEY_7"							Return ( KEY_7 )
			Case	"KEY_8"							Return ( KEY_8 )
			Case	"KEY_9"							Return ( KEY_9 )
			Case	"KEY_0"							Return ( KEY_0 )

			Case	"KEY_NUM1"							Return ( KEY_NUM1 )
			Case	"KEY_NUM2"							Return ( KEY_NUM2 )
			Case	"KEY_NUM3"							Return ( KEY_NUM3 )
			Case	"KEY_NUM4"							Return ( KEY_NUM4 )
			Case	"KEY_NUM5"							Return ( KEY_NUM5 )
			Case	"KEY_NUM6"							Return ( KEY_NUM6 )
			Case	"KEY_NUM7"							Return ( KEY_NUM7 )
			Case	"KEY_NUM8"							Return ( KEY_NUM8 )
			Case	"KEY_NUM9"							Return ( KEY_NUM9 )
			Case	"KEY_NUM0"							Return ( KEY_NUM0 )

			Case	"KEY_F1"							Return ( KEY_F1 )
			Case	"KEY_F2"							Return ( KEY_F2 )
			Case	"KEY_F3"							Return ( KEY_F3 )
			Case	"KEY_F4"							Return ( KEY_F4 )
			Case	"KEY_F5"							Return ( KEY_F5 )
			Case	"KEY_F6"							Return ( KEY_F6 )
			Case	"KEY_F7"							Return ( KEY_F7 )
			Case	"KEY_F8"							Return ( KEY_F8 )
			Case	"KEY_F9"							Return ( KEY_F9 )
			Case	"KEY_F10"							Return ( KEY_F10 )
			Case	"KEY_F11"							Return ( KEY_F11 )
			Case	"KEY_F12"							Return ( KEY_F12 )
		
			Case	"KEY_A"							Return ( KEY_A )
			Case	"KEY_B"							Return ( KEY_B )
			Case	"KEY_C"							Return ( KEY_C )
			Case	"KEY_D"							Return ( KEY_D )
			Case	"KEY_E"							Return ( KEY_E )
			Case	"KEY_F"							Return ( KEY_F )
			Case	"KEY_G"							Return ( KEY_G )
			Case	"KEY_H"							Return ( KEY_H )
			Case	"KEY_I"							Return ( KEY_I )
			Case	"KEY_J"							Return ( KEY_J )
			Case	"KEY_K"							Return ( KEY_K )
			Case	"KEY_L"							Return ( KEY_L )
			Case	"KEY_M"							Return ( KEY_M )
			Case	"KEY_N"							Return ( KEY_N )
			Case	"KEY_O"							Return ( KEY_O )
			Case	"KEY_P"							Return ( KEY_P )
			Case	"KEY_Q"							Return ( KEY_Q )
			Case	"KEY_R"							Return ( KEY_R )
			Case	"KEY_S"							Return ( KEY_S )
			Case	"KEY_T"							Return ( KEY_T )
			Case	"KEY_U"							Return ( KEY_U )
			Case	"KEY_V"							Return ( KEY_B )
			Case	"KEY_W"							Return ( KEY_W )
			Case	"KEY_X"							Return ( KEY_X )
			Case	"KEY_Y"							Return ( KEY_Y )
			Case	"KEY_Z"							Return ( KEY_Z )

			Case	"KEY_SPACE"							Return ( KEY_SPACE )
			Case	"KEY_ENTER"							Return ( KEY_ENTER )
			Case	"KEY_RETURN"						Return ( KEY_RETURN )

			Case	"KEY_LALT"							Return ( KEY_LALT )
			Case	"KEY_RALT"							Return ( KEY_RALT )
			Case	"KEY_LSHIFT"						Return ( KEY_LSHIFT )
			Case	"KEY_RSHIFT"						Return ( KEY_RSHIFT )
			Case	"KEY_LCONTROL"						Return ( KEY_LCONTROL )
			Case	"KEY_RCONTROL"						Return ( KEY_RCONTROL )
		
		EndSelect
		
		Error ( "StringToKeyCode : KeyString ~q" + KeyString + "~q ist unbekannt." )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
