'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	GLOBALS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_MATH_LINECOL_X:Double					=	0.00
Global	_AVA_MATH_LINECOL_y:Double					=	0.00

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Modulus:Double ( Value:Double, Limit:Double )

	Select True
	
		Case	Value > 0.00
			
			Return ( Value Mod Limit )
		
		Case	Value < 0.00
		
			Return ( Limit - ( Abs ( Value + 1 ) Mod Limit ) - 1 )
		
		Default
		
			Return ( 0.00 )
	
	EndSelect		

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Fract:Double ( Value:Double )

	Return ( Value - Int ( Value ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function IntCeil:Int ( Value:Double )

	Return ( Ceil ( Value ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function IntRound:Int ( Value:Double )
	
		Select True
		
			Case	Value = 0.00
			
				Return ( 0.00 )
				
			Case	Value > 0.00
			
				Return ( Int ( Value + 0.50 ) )

			Default

				Return ( Int ( Value - 0.50 ) )
			
		EndSelect
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Rotate ( x:Float Var, y:Float Var, Rotation:Float )

	Local		_x:Float							=	x
	Local		_y:Float							=	y
	Local		_Cos:Float							=	Cos ( Rotation )
	Local		_Sin:Float							=	Sin ( Rotation )
		
			x								=	_x * _Cos + _Y * _Sin
			y								=	_y * _Cos - _x * _Sin

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FaceNormal:Float [ ] ( x1:Float, y1:Float, z1:Float, x2:Float, y2:Float, z2:Float, x3:Float, y3:Float, z3:Float )

	Local		NormX:Float							=	( z1 - z2 ) * ( y3 - y2 ) - ( y1 - y2 ) * ( z3 - z2 )
	Local		NormY:Float							=	( x1 - x2 ) * ( z3 - z2 ) - ( z1 - z2 ) * ( x3 - x2 )
	Local		NormZ:Float							=	( y1 - y2 ) * ( x3 - x2 ) - ( x1 - x2 ) * ( y3 - y2 )				

			Normalize3D ( NormX, NormY, NormZ )

	Return	( [ NormX, NormY, NormZ ] )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Cross:Float [ ] ( x1:Float, y1:Float, z1:Float, x2:Float, y2:Float, z2:Float )
	
	Local		result:Float [ 3 ]
	
			result [ 0 ]						=	( y1 * z2 ) - ( z1 * y2 )
			result [ 1 ]						=	( z1 * x2 ) - ( x1 * z2 )
			result [ 2 ]						=	( x1 * y2 ) - ( y1 * x2 )
	
	Return	( result )
	
EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Dot2D:Float ( x1:Float, y1:Float, x2:Float, y2:Float )

		Return ( ( x1 * x2 ) + ( y1 * y2 ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Dot3D:Float ( x1:Float, y1:Float, z1:Float, x2:Float, y2:Float, z2:Float )

		Return ( ( x1 * x2 ) + ( y1 * y2 ) + ( z1 * z2 ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Norm1 ( x:Double Var, y:Double Var )

		Local a:Double 							=	Double ( 1 ) / Max ( Abs ( x ) , Abs ( y ) )
		
		x									:*	a
		y									:*	a
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Normalize2D ( x:Float Var, y:Float Var )

		Local length:Float						=	Sqr ( x * x + y * y )
		
		If	length
		
			length							=	1.00 / length
			
			x								:*	length
			y								:*	length

		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Normalize3D ( x:Float Var, y:Float Var, z:Float Var )

		Local length:Float						=	Sqr ( x * x + y * y + z * z )

		If	length
		
			length							=	1.00 / length
		
			x								:*	length
			y								:*	length
			z								:*	length
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Interpolate:Double ( value_1:Double, value_2:Double, position:Double )
		
		position								=	Limit ( position, 0.00, 1.00 )
		
		Return ( ( value_2 * position ) + ( value_1 * ( 1.00 - position ) ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Interpolate2:Double ( value_1:Double, value_2:Double, position:Double )
		
		position								=	Limit ( position, 0.00, 1.00 )		
		position								=	Interpolate ( position * position, 1.00 - ( 1.00 - position ) * ( 1.00 - position ), position )
		
		Return ( ( value_2 * position ) + ( value_1 * ( 1.00 - position ) ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Limit:Double ( Value:Double, Min_Value:Double, Max_Value:Double )	

	Return ( Max ( Min ( Value, Max_Value ), Min_Value ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LineLength:Double ( x1:Double, y1:Double, x2:Double, y2:Double )	
			
	Local	x:Double								=	x2 - x1
	Local	y:Double								=	y2 - y1

	Return ( Sqr ( x * x + y * y ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LineLength3D:Double ( x1:Double, y1:Double, z1:Double, x2:Double, y2:Double, z2:Double )	
			
	Local	x:Double								=	x2 - x1
	Local	y:Double								=	y2 - y1
	Local	z:Double								=	z2 - z1

	Return ( Sqr ( x * x + y * y + z * z ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LineAngle:Double ( x1:Double, y1:Double, x2:Double, y2:Double )	
	
	Local	a:Double								=	ATan2 ( y2 - y1, x2 - x1 )
	
		If	a < 0.00
		
			a								:+	360.00
		
		EndIf

		If	a >= 360.00
		
			a								:-	360.00
		
		EndIf
	
	Return ( a )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FastLineLength:Double ( x1:Float, y1:Float, x2:Float, y2:Float )	
			
	Local	x:Float								=	x2 - x1
	Local	y:Float								=	y2 - y1

	Return ( x * x + y * y )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	RectsOverlap
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function RectsOverlap:Byte ( x1:Double, y1:Double, w1:Double, h1:Double, x2:Double, y2:Double, w2:Double, h2:Double )	
			
	Return ( x1 + w1 > x2 And y1 + h1 > y2 And x2 + w2 > x1 And y2 + h2 > y1 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	OvalsOverlap
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function OvalsOverlap:Byte ( x1:Double, y1:Double, w1:Double, h1:Double, x2:Double, y2:Double, w2:Double, h2:Double )	
			
	If	RectsOverlap ( x1, y1, w1, h1, x2, y2, w2, h2 )
		
		w1									:*	0.50
		h1									:*	0.50
		w2									:*	0.50
		h2									:*	0.50
		
		Local mx1:Double							=	x1 + w1
		Local my1:Double							=	y1 + h1
		Local mx2:Double							=	x2 + w2
		Local my2:Double							=	y2 + h2
				
		Local angle:Double						=	ATan2 ( my2 - my1, mx2 - mx1 )
		
		Local	a_cos:Double						=	Cos ( angle )
		Local	a_sin:Double						=	Sin ( angle )
		Local	a_x:Double							=	mx1 + a_cos * w1
		Local	a_y:Double							=	my1 + a_sin * h1
		
		If	PointInOval ( a_x, a_y, x2, y2, w2 + w2, h2 + h2 ) 
		
			Return ( True )
		
		EndIf

		Local	b_cos:Double						=	- a_cos
		Local	b_sin:Double						=	- a_sin
		Local	b_x:Double							=	mx2 + b_cos * w2
		Local	b_y:Double							=	my2 + b_sin * h2
				
		Return ( PointInOval ( b_x, b_y, x1, y1, w1 + w1, h1 + h1 ) )
				
	Else
	
		Return ( False )
	
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	OvalRectOverlap
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function OvalRectOverlap:Byte ( oval_x:Double, oval_y:Double, oval_width:Double, oval_height:Double, rect_x:Double, rect_y:Double, rect_width:Double, rect_height:Double )	
			
	If	RectsOverlap ( oval_x, oval_y, oval_width, oval_height, rect_x, rect_y, rect_width, rect_height )
		
		If	PointInOval ( rect_x, rect_y, oval_x, oval_y, oval_width, oval_height ) ..
		Or	PointInOval ( rect_x + rect_width, rect_y, oval_x, oval_y, oval_width, oval_height ) ..
		Or	PointInOval ( rect_x, rect_y + rect_height, oval_x, oval_y, oval_width, oval_height ) ..
		Or	PointInOval ( rect_x, rect_y + rect_height, oval_x, oval_y, oval_width, oval_height ) ..
		Or	PointInOval ( rect_x + rect_width, rect_y + rect_height, oval_x, oval_y, oval_width, oval_height )
		
			Return ( True )
		
		EndIf
		
		oval_width								:*	0.50
		oval_height								:*	0.50
		
		Local mx1:Double							=	oval_x + oval_width
		Local my1:Double							=	oval_y + oval_height
		Local mx2:Double							=	rect_x + rect_width * 0.50
		Local my2:Double							=	rect_y + rect_height * 0.50
				
		Local angle:Double						=	ATan2 ( my2 - my1, mx2 - mx1 )
		
		Local	a_cos:Double						=	Cos ( angle )
		Local	a_sin:Double						=	Sin ( angle )
		Local	a_x:Double							=	mx1 + a_cos * oval_width
		Local	a_y:Double							=	my1 + a_sin * oval_height
		
		Return ( PointInRect ( a_x, a_y, rect_x, rect_y, rect_width, rect_height ) )
		
	Else
	
		Return ( False )
	
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TriangleRectOverlap
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function TriangleRectOverlap:Byte ( tri_x1:Double, tri_y1:Double, tri_x2:Double, tri_y2:Double, tri_x3:Double, tri_y3:Double, rect_x:Double, rect_y:Double, rect_width:Double, rect_height:Double )	
			
	Local	tx:Double								=	Min ( Min ( tri_x1, tri_x2 ), tri_x3 )
	Local	ty:Double								=	Min ( Min ( tri_y1, tri_y2 ), tri_y3 )
	Local	tw:Double								=	Max ( Max ( tri_x1, tri_x2 ), tri_x3 ) - tx
	Local	th:Double								=	Max ( Max ( tri_y1, tri_y2 ), tri_y3 ) - ty
	
	If	RectsOverlap ( tx, ty, tw, th, rect_x, rect_y, rect_width, rect_height )
		
		If	PointInRect ( tri_x1, tri_y1, rect_x, rect_y, rect_width, rect_height ) ..
		Or	PointInRect ( tri_x2, tri_y2, rect_x, rect_y, rect_width, rect_height ) ..
		Or	PointInRect ( tri_x3, tri_y3, rect_x, rect_y, rect_width, rect_height ) ..
		Or	LineTriangleIntersection ( rect_x, rect_y, rect_x + rect_width, rect_y, tri_x1, tri_y1, tri_x2, tri_y2, tri_x3, tri_y3 ) ..
		Or	LineTriangleIntersection ( rect_x, rect_y, rect_x, rect_y + rect_height, tri_x1, tri_y1, tri_x2, tri_y2, tri_x3, tri_y3 ) ..
		Or	LineTriangleIntersection ( rect_x, rect_y + rect_height, rect_x + rect_width, rect_y + rect_height, tri_x1, tri_y1, tri_x2, tri_y2, tri_x3, tri_y3 ) ..
		Or	LineTriangleIntersection ( rect_x + rect_width, rect_y, rect_x + rect_width, rect_y + rect_height, tri_x1, tri_y1, tri_x2, tri_y2, tri_x3, tri_y3 )
		
			Return ( True )
		
		Else
		
			Return ( False )
		
		EndIf
		
	Else
	
		Return ( False )
	
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	LineRectIntersection
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LineRectIntersection:Byte ( line_x1:Double, line_y1:Double, line_x2:Double, line_y2:Double, rect_x:Double, rect_y:Double, rect_width:Double, rect_height:Double )	
			
	If	LinesIntersect ( line_x1, line_y1, line_x2, line_y2, rect_x, rect_y, rect_x, rect_y + rect_height ) ..
	Or	LinesIntersect ( line_x1, line_y1, line_x2, line_y2, rect_x + rect_width, rect_y, rect_x + rect_width, rect_y + rect_height ) ..
	Or	LinesIntersect ( line_x1, line_y1, line_x2, line_y2, rect_x, rect_y, rect_x + rect_width, rect_y ) ..
	Or	LinesIntersect ( line_x1, line_y1, line_x2, line_y2, rect_x, rect_y + rect_height, rect_x + rect_width, rect_y + rect_height )
	
		Return ( True )
	
	Else
	
		Return ( False )
	
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	LineOvalIntersection
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LineOvalIntersection:Byte ( line_x1:Double, line_y1:Double, line_x2:Double, line_y2:Double, oval_x:Double, oval_y:Double, oval_width:Double, oval_height:Double )	
		
		If	PointInOval ( line_x1, line_y1, oval_x, oval_y, oval_width, oval_height ) ..
		Or	PointInOval ( line_x2, line_y2, oval_x, oval_y, oval_width, oval_height )
		
			Return ( True )
		
		Else
		
			oval_width							:*	0.50
			oval_height							:*	0.50
				
			Local	mx:Double						=	oval_x + oval_width
			Local	my:Double						=	oval_y + oval_height
			Local	angle:Double					=	90.00 + ATan2 ( line_y2 - line_y1, line_x2 - line_x1 )
			Local	a_cos:Double					=	Cos ( angle ) * oval_width
			Local	a_sin:Double					=	Sin ( angle ) * oval_height
			Local	x1:Double						=	mx - a_cos
			Local	y1:Double						=	my - a_sin
			Local	x2:Double						=	mx + a_cos
			Local	y2:Double						=	my + a_sin
			
			Return LinesIntersect ( x1, y1, x2, y2, line_x1, line_y1, line_x2, line_y2 )
						
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	LineTriangleIntersection
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LineTriangleIntersection:Byte ( line_x1:Double, line_y1:Double, line_x2:Double, line_y2:Double, tri_x1:Double, tri_y1:Double, tri_x2:Double, tri_y2:Double, tri_x3:Double, tri_y3:Double )	
			
	If	PointInTriangle ( line_x1, line_y1, tri_x1, tri_y1, tri_x2, tri_y2, tri_x3, tri_y3 ) ..
	Or	PointInTriangle ( line_x2, line_y2, tri_x1, tri_y1, tri_x2, tri_y2, tri_x3, tri_y3 )
	
		Return ( True )
	
	EndIf
	
	If	LinesIntersect ( line_x1, line_y1, line_x2, line_y2, tri_x1, tri_y1, tri_x2, tri_y2 ) ..
	Or	LinesIntersect ( line_x1, line_y1, line_x2, line_y2, tri_x1, tri_y1, tri_x3, tri_y3 ) ..
	Or	LinesIntersect ( line_x1, line_y1, line_x2, line_y2, tri_x2, tri_y2, tri_x3, tri_y3 )
	
		Return ( True )
	
	EndIf
	
	Return ( False )	
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	PointInRect
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PointInRect:Byte ( point_x:Double, point_y:Double, rect_x:Double, rect_y:Double, rect_width:Double, rect_height:Double )	
			
	Return ( point_x >= rect_x And point_y >= rect_y And point_x < rect_x + rect_width And point_y < rect_y + rect_height )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	PointInTriangle
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PointInTriangle:Byte ( point_x:Double, point_y:Double, x1:Double, y1:Double, x2:Double, y2:Double, x3:Double, y3:Double )	

	If	Min ( Min ( x1, x2 ), x3 ) > point_x ..
	Or	Min ( Min ( y1, y2 ), y3 ) > point_y ..
	Or	Max ( Max ( x1, x2 ), x3 ) < point_x ..
	Or	Max ( Max ( y1, y2 ), y3 ) < point_y
	
		Return ( False )
	
	EndIf
	
	Local	b1:Double								=	( ( x2 - x1 ) * ( y3 - y1 ) - ( x3 - x1 ) * ( y2 - y1 ) )
	Local	b2:Double								=	( ( x2 - point_x ) * ( y3 - point_y ) - ( x3 - point_x ) * ( y2 - point_y ) ) / b1
	Local	b3:Double								=	( ( x3 - point_x ) * ( y1 - point_y ) - ( x1 - point_x ) * ( y3 - point_y ) ) / b1
	Local	b4:Double								=	1.00 - b2 - b3
	
	Return ( b2 > 0 And b3 > 0 And b4 > 0 )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	PointInOval
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PointInOval:Byte ( point_x:Double, point_y:Double, oval_x:Double, oval_y:Double, oval_width:Double, oval_height:Double )	
	
	If	PointInRect ( point_x, point_y, oval_x, oval_y, oval_width, oval_height )

		Local	w:Double							=	oval_width * 0.50
		Local	h:Double							=	oval_height * 0.50
		Local	mx:Double							=	oval_x + w
		Local	my:Double							=	oval_y + h
		Local	px:Double							=	point_x - mx
		Local	py:Double							=	point_y - my
		
		px									:*	px
		py									:*	py	
		w									:*	w
		h									:*	h

		Return ( ( ( px / w ) + ( py / h ) ) < 1.00 )
		
	Else
	
		Return ( False )
	
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	LinesIntersect
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LinesIntersect:Byte ( ax1:Float, ay1:Float, ax2:Float, ay2:Float, bx1:Float, by1:Float, bx2:Float, by2:Float, limited:Byte = True )

		Local	limitedLeft:Byte						=	True
		Local	limitedRight:Byte						=	True
		Local	limitedUp:Byte						=	True
		Local	limitedDown:Byte						=	True

			If	Not	limited
						
				If	ax1 > ax2	limitedLeft			=	False
				If	ax2 > ax1	limitedRight		=	False
				If	ay1 > ay2	limitedUp			=	False
				If	ay2 > ay1	limitedDown			=	False	
				
			EndIf			

			correctParameters ( ax1, ay1, ax2, ay2 )
			correctParameters ( bx1, by1, bx2, by2 )
		
			If	ax1 = ax2 And bx1 = bx2 And ax1 = bx1
			
				If	limited = False Or (ay2 >= by1 And by2 >= ay1)
				
					Return ( True )
				
				EndIf
			
			EndIf
	
			If	ay1 = ay2 And by1 = by2 And ay1 = by1
			
				If	limited = False Or (ax2 > bx1 And bx2 > ax1)
				
					Return ( True )
				
				EndIf
			
			EndIf
	
			If	ax1 = ax2 And by1 = by2 And bx1 <= ax2 And bx2 >= ax1
			
				If	limited = False Or (ay1 <= by2 And ay2 >= by1)
				
					_AVA_MATH_LINECOL_X			=	ax1
					_AVA_MATH_LINECOL_Y			=	by1
				
					Return ( True )
				
				EndIf
			
			EndIf
	
			If	bx1 = bx2 And ay1 = ay2 And ax1 <= bx2 And ax2 >= bx1
			
				If	limited = False Or (by1 <= ay2 And by2 >= ay1)
				
					_AVA_MATH_LINECOL_X			=	bx1
					_AVA_MATH_LINECOL_Y			=	ay1
				
					Return ( True )
				
				EndIf
			
			EndIf
	
		Local	a_width:Float						=	ax2 - ax1
		Local	a_height:Float						=	ay2 - ay1
		Local	am1:Float							=	a_height / a_width
		Local	an1:Float							=	ay2 - (ax2 * am1)	
		Local	am2:Float							=	a_width / a_height
		Local	an2:Float							=	ax2 - (ay2 * am2)
	
		Local	b_width:Float						=	bx2 - bx1
		Local	b_height:Float						=	by2 - by1
		Local	bm1:Float							=	b_height / b_width
		Local	bn1:Float							=	by2 - (bx2 * bm1)	
		Local	bm2:Float							=	b_width / b_height
		Local	bn2:Float							=	bx2 - (by2 * bm2)
				
		Local	x:Float							=	0.00
		Local	y:Float							=	0.00

			x								=	(bn1 - an1) / (am1 - bm1)

			If	( Not limitedLeft Or ( x >= ax1 ) ) And ( Not limitedRight Or ( x <= ax2 ) ) And x >= bx1 And x <= bx2
				
				Local	pos:Double					=	( x - ax1 ) / a_width
				_AVA_MATH_LINECOL_X				=	ax1 + ( a_width * pos )
				_AVA_MATH_LINECOL_Y				=	ay1 + ( a_height * pos )
				
				Return ( True )				
											
			EndIf
					
			y								=	(bn2 - an2) / (am2 - bm2)
					
			If	( Not limitedUp Or ( y >= Min ( ay1, ay2 ) ) ) And ( Not limitedDown Or ( y <= Max ( ay1, ay2 ) ) ) And y >= Min ( by1, by2 ) And y <= Max ( by1, by2 )

				Local	pos:Double					=	( y - ay1 ) / a_height
				_AVA_MATH_LINECOL_X				=	ax1 + ( a_width * pos )
				_AVA_MATH_LINECOL_Y				=	ay1 + ( a_height * pos )
	
				Return ( True )				
						
			EndIf							

			'----------------------------------------------------------------------------------------------------------------------------------

			Function	correctParameters(x1:Float Var, y1:Float Var, x2:Float Var, y2:Float Var)
				
					Select True
					
					Case	x1 > x2
								
						SwapFloats ( x1, x2 )
						SwapFloats ( y1, y2 )
							
					Case x1 = x2 And y1 > y2
				
						SwapFloats ( y1, y2 )	
					
					EndSelect			
				
			EndFunction

			'----------------------------------------------------------------------------------------------------------------------------------
								
	Return	( False )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------------------------------------------------

