'---------------------------------------------------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_PixmapExt_Screenshot_File:String				=	""
Global	_PixmapExt_Screenshot_Folder:String			=	"SCREENSHOTS"
Global	_PixmapExt_Screenshot_Format:String			=	"JPG"
Global	_PixmapExt_Screenshot_PNG_Compression:Int		=	9
Global	_PixmapExt_Screenshot_JPG_Quality:Int			=	75

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_PixmapExt_Trim_x:Int						=	0
Global	_PixmapExt_Trim_y:Int						=	0
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
returns:
End Rem
Function GetPixmapTrimX:Int ( )

	Return ( _PixmapExt_Trim_x )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
returns:
End Rem
Function GetPixmapTrimY:Int ( )

	Return ( _PixmapExt_Trim_y )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
returns:
End Rem
Function TrimPixmap:TPixmap ( Pixmap:TPixmap )

		Local	x1:Int							=	PixmapWidth ( Pixmap )
		Local	y1:Int							=	PixmapHeight ( Pixmap )
		Local	x2:Int							=	0
		Local	y2:Int							=	0

		For	Local x:Int = 0 Until PixmapWidth ( Pixmap )
		For	Local y:Int = 0 Until PixmapHeight ( Pixmap )
		
			If	ReadPixelAlpha ( Pixmap, x, y ) > 0
			
				x1							=	Min ( x, x1 )
				x2							=	Max ( x, x2 )

				y1							=	Min ( y, y1 )
				y2							=	Max ( y, y2 )
			
			EndIf
		
		Next
		Next
		
		_PixmapExt_Trim_x							=	x1
		_PixmapExt_Trim_y							=	y1
		
		Return ( PixmapWindow ( Pixmap, x1, y1, x2 - x1, y2 - y1 ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
Function	PixmapClearPixels ( Pixmap:TPixmap, RGBA1:Int [ ] = Null, RGBA2:Int [ ] = Null )

		If	Pixmap = Null	Error ( "PixmapClearPixels : TPixmap ist Null." )

		For	Local X:Int = 0 Until PixmapWidth ( Pixmap )
		For	Local Y:Int = 0 Until PixmapHeight ( Pixmap )

			Local	Pixel:Byte [ ]					=	ReadPixel ( Pixmap, X, Y )
			Local	Clear:Byte						=	False
			
			Select RGBA1.length
			
				Case	0
				
					Clear						=	True
				
				Case	1
				
					Clear						=	( Pixel [ 3 ] = RGBA1 [ 0 ] )

				Case	2

					Clear						=	( Pixel [ 0 ] = RGBA1 [ 0 ] ) ..
											And	( Pixel [ 1 ] = RGBA1 [ 0 ] ) ..
											And	( Pixel [ 2 ] = RGBA1 [ 0 ] ) ..
											And	( Pixel [ 3 ] = RGBA1 [ 1 ] ) ..

				Case	3

					Clear						=	( Pixel [ 0 ] = RGBA1 [ 0 ] ) ..
											And	( Pixel [ 1 ] = RGBA1 [ 1 ] ) ..
											And	( Pixel [ 2 ] = RGBA1 [ 2 ] )

				Default

					Clear						=	( Pixel [ 0 ] = RGBA1 [ 0 ] ) ..
											And	( Pixel [ 1 ] = RGBA1 [ 1 ] ) ..
											And	( Pixel [ 2 ] = RGBA1 [ 2 ] ) ..
											And	( Pixel [ 3 ] = RGBA1 [ 3 ] ) ..

			EndSelect

			If	Clear
				
				Select RGBA2.length
				
					Case	0

						WritePixelRed ( Pixmap, X, Y, 0 )
						WritePixelGreen ( Pixmap, X, Y, 0 )
						WritePixelBlue ( Pixmap, X, Y, 0 )
						WritePixelAlpha ( Pixmap, X, Y, 0 )
			
					Case	1
					
						WritePixelRed ( Pixmap, X, Y, RGBA2 [ 0 ] )
						WritePixelGreen ( Pixmap, X, Y, RGBA2 [ 0 ] )
						WritePixelBlue ( Pixmap, X, Y, RGBA2 [ 0 ] )
						WritePixelAlpha ( Pixmap, X, Y, 255 )

					Case	2
					
						WritePixelRed ( Pixmap, X, Y, RGBA2 [ 0 ] )
						WritePixelGreen ( Pixmap, X, Y, RGBA2 [ 0 ] )
						WritePixelBlue ( Pixmap, X, Y, RGBA2 [ 0 ] )
						WritePixelAlpha ( Pixmap, X, Y, RGBA2 [ 1 ] )

					Case	3
					
						WritePixelRed ( Pixmap, X, Y, RGBA2 [ 0 ] )
						WritePixelGreen ( Pixmap, X, Y, RGBA2 [ 1 ] )
						WritePixelBlue ( Pixmap, X, Y, RGBA2 [ 2 ] )
						WritePixelAlpha ( Pixmap, X, Y, 255 )
					
					Case	3
						
						WritePixelRed ( Pixmap, X, Y, RGBA2 [ 0 ] )
						WritePixelGreen ( Pixmap, X, Y, RGBA2 [ 1 ] )
						WritePixelBlue ( Pixmap, X, Y, RGBA2 [ 2 ] )
						WritePixelAlpha ( Pixmap, X, Y, RGBA2 [ 3 ] )
					
					EndSelect
				
			EndIf		

		Next
		Next
		
EndFunction
EndRem

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: Rckgabe der Farbe eines #TPixmap Pixels.
returns: Die Farbe des Pixels als Byte [ R, G, B, A ].
End Rem
Rem
Function ReadPixel:Byte [ ] ( Pixmap:TPixmap, x:Int, y:Int )

		If	Pixmap = Null	Error ( "ReadPixel : TPixmap ist Null." )

		If	x < 0 Or y < 0 Or x >= Pixmap.width Or y >= Pixmap.height
			
			Return ( [ Byte ( 0 ), Byte ( 0 ), Byte ( 0 ), Byte ( 0 ) ] )
									
		EndIf

		Return ( [ ReadPixelRed ( Pixmap, x, y ), ReadPixelGreen ( Pixmap, x, y ), ReadPixelBlue ( Pixmap, x, y ), ReadPixelAlpha ( Pixmap, x, y ) ] )
						
EndFunction
EndRem

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: Rckgabe des Farbwerts @ALPHA eines #TPixmap Pixels.
returns: Der Farbwert @ALPHA des Pixels als Byte.
End Rem
Function ReadPixelAlpha:Byte ( Pixmap:TPixmap, x:Int, y:Int )

		If	Pixmap = Null	Error ( "ReadPixelAlpha : TPixmap ist Null." )

		If	x < 0 Or y < 0 Or x >= Pixmap.width Or y >= Pixmap.height
			
			Return ( 0 )
									
		EndIf

		Local	p:Byte Ptr	= PixmapPixelPtr ( Pixmap, x,y )

		Select	Pixmap.format
		
		Case		PF_RGBA8888, PF_BGRA8888				Return ( p[3] )								
		Case		PF_A8								Return ( p[0] )
		Case		PF_I8, PF_RGB888, PF_BGR888				Return ( 255 )

		EndSelect
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: Rckgabe des Farbwerts @RED eines #TPixmap Pixels.
returns: Der Farbwert @RED des Pixels als Byte.
End Rem
Function ReadPixelRed:Byte ( Pixmap:TPixmap, x:Int, y:Int )

		If	Pixmap = Null	Error ( "ReadPixelRed : TPixmap ist Null." )

		If	x < 0 Or y < 0 Or x >= Pixmap.width Or y >= Pixmap.height
			
			Return ( 0 )
									
		EndIf

		Local	p:Byte Ptr	= PixmapPixelPtr ( Pixmap, x,y )

		Select	Pixmap.format
		
		Case		PF_RGBA8888	, PF_I8, PF_RGB888			Return ( p[0] )
		Case		PF_BGRA8888, PF_BGR888					Return ( p[2] )								
		Case		PF_A8								Return ( 0 )

		EndSelect
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: Rckgabe des Farbwerts @GREEN eines #TPixmap Pixels.
returns: Der Farbwert @GREEN des Pixels als Byte.
End Rem
Function ReadPixelGreen:Byte ( Pixmap:TPixmap, x:Int, y:Int )

		If	Pixmap = Null	Error ( "ReadPixelGreen : TPixmap ist Null." )

		If	x < 0 Or y < 0 Or x >= Pixmap.width Or y >= Pixmap.height
			
			Return ( 0 )
									
		EndIf

		Local	p:Byte Ptr	= PixmapPixelPtr ( Pixmap, x,y )

		Select	Pixmap.format

		Case		PF_RGBA8888	,PF_BGRA8888, PF_RGB888, PF_BGR888	Return ( p[1] )								
		Case		PF_I8								Return ( p[0] )
		Case		PF_A8								Return ( 0 )

		EndSelect
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: Rckgabe des Farbwerts @BLUE eines #TPixmap Pixels.
returns: Der Farbwert @BLUE des Pixels als Byte.
End Rem
Function ReadPixelBlue:Byte ( Pixmap:TPixmap, x:Int, y:Int )

		If	Pixmap = Null	Error ( "ReadPixelBlue : TPixmap ist Null." )

		If	x < 0 Or y < 0 Or x >= Pixmap.width Or y >= Pixmap.height
			
			Return ( 0 )
									
		EndIf

		Local	p:Byte Ptr	= PixmapPixelPtr ( Pixmap, x,y )

		Select	Pixmap.format
		
		Case		PF_RGBA8888	, PF_I8, PF_RGB888			Return ( p[2] )
		Case		PF_BGRA8888, PF_BGR888					Return ( p[0] )								
		Case		PF_A8								Return ( 0 )

		EndSelect
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	WRITEPIXEL
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: NA
End Rem
Function WritePixelAlpha:Byte ( Pixmap:TPixmap, x:Int, y:Int, value:Byte )

		If	Pixmap = Null	Error ( "WritePixelAlpha : TPixmap ist Null." )

		If	x < 0 Or y < 0 Or x >= Pixmap.width Or y >= Pixmap.height
			
			Return ( False )
									
		EndIf

		Local	p:Byte Ptr	= PixmapPixelPtr ( Pixmap, x,y )

		Select	Pixmap.format
		
		Case		PF_RGBA8888, PF_BGRA8888				p[3] = value								
		Case		PF_A8								p[0] = value
		Case		PF_I8, PF_RGB888, PF_BGR888				

		EndSelect
		
		Return ( True )
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: NA
End Rem
Function WritePixelRed:Byte ( Pixmap:TPixmap, x:Int, y:Int, value:Byte )

		If	Pixmap = Null	Error ( "WritePixelRed : TPixmap ist Null." )

		If	x < 0 Or y < 0 Or x >= Pixmap.width Or y >= Pixmap.height
			
			Return ( False )
									
		EndIf

		Local	p:Byte Ptr	= PixmapPixelPtr ( Pixmap, x,y )

		Select	Pixmap.format
		
		Case		PF_RGBA8888	, PF_I8, PF_RGB888			p[0] = value
		Case		PF_BGRA8888, PF_BGR888					p[2] = value							
		Case		PF_A8								

		EndSelect

		Return ( True )
								
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: NA
End Rem
Function WritePixelGreen:Byte ( Pixmap:TPixmap, x:Int, y:Int, value:Byte )

		If	Pixmap = Null	Error ( "WritePixelGreen : TPixmap ist Null." )

		If	x < 0 Or y < 0 Or x >= Pixmap.width Or y >= Pixmap.height
			
			Return ( False )
									
		EndIf

		Local	p:Byte Ptr	= PixmapPixelPtr ( Pixmap, x,y )

		Select	Pixmap.format

		Case		PF_RGBA8888	,PF_BGRA8888, PF_RGB888, PF_BGR888	p[1] = value								
		Case		PF_I8								p[0] = value
		Case		PF_A8								

		EndSelect

		Return ( True )
								
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: NA
End Rem
Function WritePixelBlue:Byte ( Pixmap:TPixmap, x:Int, y:Int, value:Byte )

		If	Pixmap = Null	Error ( "WritePixelBlue : TPixmap ist Null." )

		If	x < 0 Or y < 0 Or x >= Pixmap.width Or y >= Pixmap.height
			
			Return ( False )
									
		EndIf

		Local	p:Byte Ptr	= PixmapPixelPtr ( Pixmap, x,y )

		Select	Pixmap.format
		
		Case		PF_RGBA8888	, PF_I8, PF_RGB888			p[2] = value
		Case		PF_BGRA8888, PF_BGR888					p[0] = value								
		Case		PF_A8								

		EndSelect

		Return ( True )
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	READPIXEL
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: NA
End Rem
Function WritePixmap ( Stream:TStream, Pixmap:TPixmap, Alpha_Cut:Byte = 10 )

		If	Pixmap = Null	Error ( "WritePixmap : TPixmap ist Null." )
		If	stream = Null	Error ( "WritePixmap : TStream ist Null." )
		
		WriteInt ( stream, Pixmap.format )
		WriteInt ( stream, Pixmap.width )
		WriteInt ( stream, Pixmap.height )
		
		Local	alpha:Byte							=	0
		
		For	Local x:Int = 0 Until Pixmap.width
		For	Local y:Int = 0 Until Pixmap.height
		
			alpha								=	ReadPixelAlpha ( Pixmap, x, y )
			
			If	alpha > alpha_cut
				
				WriteByte ( stream, alpha )
				WriteByte ( stream, ReadPixelRed ( Pixmap, x, y ) )
				WriteByte ( stream, ReadPixelGreen ( Pixmap, x, y ) )
				WriteByte ( stream, ReadPixelBlue ( Pixmap, x, y ) )
				
			Else
			
				WriteByte ( stream, 0 )
			
			EndIf
		
		Next
		Next
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: NA
End Rem
Function ReadPixmap:TPixmap ( Stream:TStream )

		If	stream = Null	Error ( "ReadPixmap : TStream ist Null." )
	
		Local	format:Int							=	ReadInt ( stream )
		Local	width:Int							=	ReadInt ( stream )
		Local	height:Int							=	ReadInt ( stream )
		Local	Pixmap:TPixmap						=	CreatePixmap ( width, height, format )
		Local	alpha:Byte							=	0
		
		For	Local x:Int = 0 Until width
		For	Local y:Int = 0 Until height

			alpha								=	ReadByte ( stream )
			
			If	alpha = 0
			
				WritePixelAlpha ( Pixmap, x, y, alpha )
				WritePixelRed ( Pixmap, x, y, 0 )
				WritePixelGreen ( Pixmap, x, y, 0 )
				WritePixelBlue ( Pixmap, x, y, 0 )
				
			Else
			
				WritePixelAlpha ( Pixmap, x, y, alpha )
				WritePixelRed ( Pixmap, x, y, ReadByte ( stream ) )
				WritePixelGreen ( Pixmap, x, y, ReadByte ( stream ) )
				WritePixelBlue ( Pixmap, x, y, ReadByte ( stream ) )
			
			EndIf		
		
		Next
		Next
	
		Return ( Pixmap )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: NA
End Rem
Function WritePixmapGroup ( Stream:TStream, Pixmap:TPixmap [ ], Alpha_Cut:Byte = 10 )

		If	Pixmap = Null	Error ( "PixmapToStream : TPixmap ist Null." )
		If	Stream = Null	Error ( "PixmapToStream : TStream ist Null." )
		
		WriteInt ( Stream, Pixmap.Length )
		
		For	Local i:Int = 0 Until Pixmap.Length
		
			WritePixmap ( Stream, Pixmap [ i ], Alpha_Cut )
		
		Next
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: NA
End Rem
Function ReadPixmapGroup:TPixmap [ ] ( Stream:TStream )

		If	stream = Null	Error ( "ReadPixmapGroup : TStream ist Null." )
	
		Local	Num:Int							=	ReadInt ( stream )
		Local	Pixmap:TPixmap [ Num ]

		For	Local i:Int = 0 Until Num
		
			Pixmap [ i ]						=	ReadPixmap ( Stream )
		
		Next
			
		Return ( Pixmap )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------------------------------------------------


