'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MultiReplace:String ( Source:String, Sub:String [ ], ReplaceWidth:String [ ] )
			
		For	Local i:Int = 0 Until Min ( Sub.Length, ReplaceWidth.Length )
			
			Source							=	Replace ( Source, Sub [ i ], ReplaceWidth [ i ] )			
			
		Next

		Return ( Source )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SplitString:String [ ] ( Source:String, Divisor:Int, IncludeDivisor:Byte = False, TrimResult:Byte = False )

	Local	result:String [ ]

		While source.length
				
			For	Local i:Int = 0 To source.length

				If	i = source.length And i > 0
					
					result					:+	[ ( source  ) ]
						
					Return ( result )					
						
				EndIf
				
				If	source [ i ] = Divisor
					
					If	i > 0
					
						result				:+	[ ( Left ( source, i ) ) ]
						
						If	IncludeDivisor
						
							result			:+	[ Chr ( Divisor ) ]
						
						EndIf
					
					EndIf
					
					source					=	Mid ( source, i + 2 )
						
					Exit
						
				EndIf
					
			Next

		Wend
		
		If	TrimResult
		
			For	Local i:Int = 0 Until Result.Length
		
				Result [ i ]					=	Trim ( Result [ i ] )		
		
			Next
		
		EndIf
			
	Return ( result )
	
	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FirstUpper:String ( Text:String )

	Return ( Upper ( Left ( Text, 1 ) ) + Lower ( Mid ( Text, 2 ) ) )
	
	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
about:
End Rem
Function FloatToString:String ( Value:Float, FractNum:Int = 2 )	

		Local	result:String						=	String ( value )
		
		result								=	Left ( result, Instr ( result, "." ) + FractNum )

		Return ( result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
about:
End Rem
Function IntToString:String ( Value:Int )

		Local	result:String						=	""
		
		Repeat
			
			Local Major:Int						=	Value / 1000
			Local Minor:Int						=	Value - ( Major * 1000 )
			
			Value								=	Major
			
			If	Major

				Local Num:Int					=	0

				If	Minor < 10				Num	:+	1
				If	Minor < 100				Num	:+	1
			
				Result						=	"." + RepeatString ( "0", Num ) + Minor + Result
		
			Else
							
				Result						=	Minor + Result
				
				Exit
			
			EndIf
			
		Forever
		
		Return ( result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
about:
End Rem
Function SecondsToString:String ( Value:Int )	

		Local	Result:String						=	""
		
		Local Hours:Int 							=	Int ( ( Value / 3600 ) )
		Local Minutes:Int 						=	Int ( ( Value / 60 ) - ( Hours * 3600 ) )
		Local Seconds:Int 						=	Int ( ( Value ) - ( ( Minutes * 60 ) + ( Hours * 3600 ) ) )
		
		Select Hours < 10
		
			Case	True					Result	:+	"0" + Hours + ":"
			Case	False					Result	:+	Hours + ":"
			
		EndSelect
		
		Select Minutes < 10
		
			Case	True					Result	:+	"0" + Minutes + ":"
			Case	False					Result	:+	Minutes + ":"
			
		EndSelect
		
		Select Seconds < 10
		
			Case	True					Result	:+	"0" + Seconds
			Case	False					Result	:+	Seconds
			
		EndSelect
	
		Return ( Result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
returns:
about: 
End Rem
Function RepeatString:String ( Text:String, Count:Int )	

		Local	Result:String
		
		While Count <> 0
		
			If	( Count & 1 )
			
				Result						:+	Text
			
			EndIf
			
			Count								=	Count Shr 1
			Text								:+	Text
			
		Wend
	
	Rem
		
		For	Local i:Int = 0 Until Count
		
			Result							:+	Text
		
		Next
	
	EndRem
		
		Return ( Result )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------------------------------------------------

