'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: [ BlendMode : SolidBlend ]
End Rem
Global SolidBlend:Int			=	-1

Rem
bbdoc: [ BlendMode : AlphaBlend ]
End Rem
Global AlphaBlend:Int			=	AddBlendMode ( [ GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_ONE, GL_ONE ] )

Rem
bbdoc: [ BlendMode : OnAlphaBlend ]
End Rem
Global OnAlphaBlend:Int 		=	AddBlendMode ( [ GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_ZERO, GL_ONE ] )

Rem
bbdoc: [ BlendMode : LightBlend ]
End Rem
Global LightBlend:Int 			 =	AddBlendMode ( [ GL_SRC_ALPHA, GL_ONE, GL_ONE, GL_ONE ] )

Rem
bbdoc: [ BlendMode : ShadeBlend ]
End Rem
Global ShadeBlend:Int 			 =	AddBlendMode ( [ GL_DST_COLOR, GL_ONE_MINUS_SRC_ALPHA, GL_ZERO, GL_ONE ] )

Rem
bbdoc: [ BlendMode : ClearBlend ]
End Rem
Global ClearBlend:Int 			=	AddBlendMode ( [ GL_ZERO, GL_ONE, GL_SRC_ALPHA, GL_ZERO ] )

Rem
bbdoc: [ BlendMode : AdditiveBlend ]
End Rem
Global AdditiveBlend:Int 		=	AddBlendMode ( [ GL_ONE, GL_ONE ] )

Rem
bbdoc: [ BlendMode : LightBlend2 ]
End Rem
Global LightBlend2:Int 		 =	AddBlendMode ( [ GL_DST_COLOR, GL_ONE, GL_ZERO, GL_ONE ] )

Rem
bbdoc: [ BlendMode : LightBlend3 ]
End Rem
Global LightBlend3:Int 		 =	AddBlendMode ( [ GL_DST_COLOR, GL_DST_COLOR, GL_ZERO, GL_ONE ] )

Rem
bbdoc: [ BlendMode : ReverseLightBlend ]
End Rem
Global ReverseLightBlend:Int		 =	AddBlendMode ( [ GL_ONE, GL_ONE, GL_DST_COLOR, GL_ONE ] )

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_BLEND:TIntStack				=	New TIntStack
Global	_AVA_GFX_BLENDMODE:Int [ ] [ ]
Global	_AVA_GFX_DISABLED_COUNTER:Int			=	0

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function AddBlendMode:Int ( BlendFunc:Int [ ] )

		If	Not ( blendfunc.length = 2 Or blendfunc.length = 4 )
		
			Error ( "AddBlendMode : BlendFunc muss 2 oder 4 Eintrge besitzen." )
		
		EndIf
		
		_AVA_GFX_BLENDMODE					:+	[ BlendFunc ]
		
Return	( _AVA_GFX_BLENDMODE.length - 1 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetBlend ( mode:Int )

		If	mode >= _AVA_GFX_BLENDMODE.length
		
			Error ( "SetBlend : Ungltiger Modus." )
		
		EndIf

		_AVA_GFX_BLEND.Set ( mode )
		_AVA_GFX_UPDATE_BLEND ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetBlend ( )

		_AVA_GFX_BLEND.Set ( 0 )
		_AVA_GFX_UPDATE_BLEND ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushBlend ( mode:Int )

		If	mode >= _AVA_GFX_BLENDMODE.length
		
			Error ( "PushBlend : Ungltiger Modus." )
		
		EndIf
		
		_AVA_GFX_BLEND.Push ( mode )
		_AVA_GFX_UPDATE_BLEND ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopBlend ( )

		_AVA_GFX_BLEND.Pop ( )
		_AVA_GFX_UPDATE_BLEND ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetBlend:Int ( )

Return	( _AVA_GFX_BLEND.Get ( ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DisableBlend ( )
		
		If	_AVA_GFX_DISABLED_COUNTER = 0
			
			StopDraw ( )
			
			_AVA_GL_CLIENT._DISABLE ( GL_BLEND )

		EndIf
		
		_AVA_GFX_DISABLED_COUNTER					:+	1
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function EnableBlend ( )
		
		If	_AVA_GFX_DISABLED_COUNTER = 1
		
			SetBlend ( _AVA_GFX_BLEND.Get ( ) )

		EndIf
		
		_AVA_GFX_DISABLED_COUNTER					= Max ( _AVA_GFX_DISABLED_COUNTER - 1, 0 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_BLEND ( )
		
		StopDraw ( )
		
			If	_AVA_GFX_BLEND.Get ( ) < 0
			
				_AVA_GL_CLIENT._DISABLE ( GL_BLEND )
			
			Else
			
				_AVA_GL_CLIENT._ENABLE ( GL_BLEND )
				_AVA_GL_CLIENT._BLEND_FUNC ( _AVA_GFX_BLENDMODE [ _AVA_GFX_BLEND.Get ( ) ] )
			
			EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
