'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TPoly

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		BaseVertices:TVertex [ ]
	Field		FinalVertices:TVertex [ ]
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		Modified:Byte						=	True
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method 	AddVertex ( x:Float, y:Float, z:Float = 0.00, u:Float = 0.00, v:Float = 0.00, r:Float = 1.00, g:Float = 1.00, b:Float = 1.00, a:Float = 1.00 )

			BaseVertices						:+	[ TVertex.Create ( x, y, z, u, v, r, g, b, a ) ]
			Modified							=	True

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	Draw ( Shrink:Double )
			
			If	Modified
			
				Update ( )
			
			EndIf

			If	FinalVertices
			
				StartDraw ( GL_TRIANGLES )
	
				For	Local i:Int = 0 Until FinalVertices.Length Step 3
				
					FinalVertices [ i ] . DrawN ( Shrink )
					FinalVertices [ i + 1 ] . DrawN ( Shrink )
					FinalVertices [ i + 2 ] . DrawN ( Shrink )
				
				Next
		
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	DrawFrame ( Size:Float, Shrink:Double )
			
			If	Modified
			
				Update ( )
			
			EndIf

			If	BaseVertices
			
				StartDraw ( GL_QUAD_STRIP )
	
				For	Local i:Int = 0 Until BaseVertices.Length
				
					BaseVertices [ i ] . DrawN ( Shrink )
					BaseVertices [ i ] . DrawN ( Shrink + Size )
				
				Next

				BaseVertices [ 0 ] . DrawN ( Shrink )
				BaseVertices [ 0 ] . DrawN ( Shrink + Size )
				
				EndDraw ( )
		
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	Update ( )

			Modified							=	False
			
			If	BaseVertices.Length > 2
			
			'	BaseVertices					=	Arrange ( BaseVertices )
				FinalVertices					=	Triangulate2D_EarClipping ( BaseVertices )
				
				UpdateNormals ( )
						
			EndIf
				
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	UpdateNormals ( )
	
			For	Local IndexB:Int = 0 Until BaseVertices.Length
				
				Local	IndexA:Int					=	Modulus ( IndexB - 1, BaseVertices.Length )
				Local	IndexC:Int					=	Modulus ( IndexB + 1, BaseVertices.Length )

				Local	VertexA:TVertex				=	BaseVertices [ IndexA ]
				Local	VertexB:TVertex				=	BaseVertices [ IndexB ]
				Local	VertexC:TVertex				=	BaseVertices [ IndexC ]

				Local	AngleA:Double 				=	LineAngle ( VertexA.x, VertexA. y, VertexB.x, VertexB.y )
				Local	AngleB:Double 				=	LineAngle ( VertexC.x, VertexC. y, VertexB.x, VertexB.y )
				Local	AngleC:Double 				=	LineAngle ( Cos ( AngleA ) + Cos ( AngleB ), Sin ( AngleA ) + Sin ( AngleB ), 0, 0 )
				
				VertexB.nx						=	Cos ( AngleC )
				VertexB.ny						=	Sin ( AngleC )
				
				Norm1 ( VertexB.nx, VertexB.ny )
				
			'	Print AngleC + " = " + VertexB.nx + " / " + VertexB.ny
				
			Next
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	CheckEdge:Byte ( v1:TVertex, v2:TVertex )

	Local		Angle:Float							=	LineAngle ( v1.x, v1.y, v2.x, v2.y ) + 90.00
	Local		_x:Float							=	Cos ( Angle ) * 0.01
	Local		_y:Float							=	Sin ( Angle ) * 0.01
	Local		mx:Float							=	( v1.x + v2.x ) * 0.50
	Local		my:Float							=	( v1.y + v2.y ) * 0.50
	
			If	PointInPoly_VertexArray ( mx + _x, my + _y, BaseVertices ) ..
			And	PointInPoly_VertexArray ( mx - _x, my - _y, BaseVertices )
				
				Return ( False )
			Else
			
				Return ( True )
				
			EndIf
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	Invert:TVertex [ ] ( Vertices:TVertex [ ] )

	Local		Result:TVertex [ Vertices.Length ]
	
			For	Local i:Int = 0 Until Vertices.Length
				
				Result [ Vertices.Length - i - 1 ]		=	Vertices [ i ]
	
			Next
			
	Return	( Result )

	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TVertex

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		x:Float							=	0.00
	Field		y:Float							=	0.00
	Field		z:Float							=	0.00
	
	Field		u:Float							=	0.00
	Field		v:Float							=	0.00
	
	Field		r:Float							=	1.00
	Field		g:Float							=	1.00
	Field		b:Float							=	1.00
	Field		a:Float							=	1.00

	Field		nx:Double							=	0.00
	Field		ny:Double							=	0.00
	
	Field		Normal:Float [ ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function 	Create:TVertex ( x:Float, y:Float, z:Float = 0.00, u:Float = 0.00, v:Float = 0.00, r:Float = 1.00, g:Float = 1.00, b:Float = 1.00, a:Float = 1.00 )

	Local		n:TVertex							=	New TVertex
			
			n.x								=	x
			n.y								=	y
			n.z								=	z

			n.u								=	u
			n.v								=	v

			n.r								=	r
			n.g								=	g
			n.b								=	b
			n.a								=	a	
	
	Return	( n )

	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Draw ( )
	
			If	Normal.Length = 3
			
				_AVA_GL_CLIENT._NORMAL ( Normal [ 0 ], Normal [ 1 ], Normal [ 2 ] )
			
			EndIf

			DrawVertex ( x, y, z, u, v, r, g, b, a )

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	DrawN ( Shrink:Double )

			DrawVertex ( x + nx * Shrink, y + ny * Shrink, z, u, v, r, g, b, a )

	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function CreatePoly:TPoly ( )

	Return ( New TPoly )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawPoly ( Poly:TPoly, Shrink:Double = 0.00, z:Float = 0.00 )

	If	Poly = Null
	
		Error ( "DrawPoly : TPoly ist NUll." )
	
	EndIf
	
	Poly.Draw ( Shrink )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawPolyFrame ( Poly:TPoly, Size:Double, Shrink:Double = 0.00, z:Float = 0.00 )

	If	Poly = Null
	
		Error ( "DrawPolyFrame : TPoly ist NUll." )
	
	EndIf
	
	Poly.DrawFrame ( Size, Shrink )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
