'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_OVAL_MIN_SEGMENTS:Int			=	16
Global	_AVA_GFX_OVAL_MAX_SEGMENTS:Int			=	512
Global	_AVA_GFX_OVAL_SEGMENTING:Int				=	8

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetOvalMinSegments ( num:Int = 16 )

		_AVA_GFX_OVAL_MIN_SEGMENTS				=	num
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetOvalMaxSegments ( num:Int = 512 )

		_AVA_GFX_OVAL_MAX_SEGMENTS				=	num
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetOvalSegmenting ( value:Int = 8 )

		_AVA_GFX_OVAL_SEGMENTING				=	value
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_OVAL_CENTER_X:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_CENTER_Y:TFloatStack			=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetOvalCenter ( x:Float, y:Float )

		_AVA_GFX_OVAL_CENTER_X.Set ( x )
		_AVA_GFX_OVAL_CENTER_Y.Set ( y )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetOvalCenter ( )

		_AVA_GFX_OVAL_CENTER_X.Reset ( 0.50 )
		_AVA_GFX_OVAL_CENTER_Y.Reset ( 0.50 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushOvalCenter ( x:Float, y:Float )

		_AVA_GFX_OVAL_CENTER_X.Push ( x )
		_AVA_GFX_OVAL_CENTER_Y.Push ( y )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopOvalCenter ( )

		_AVA_GFX_OVAL_CENTER_X.Pop ( )
		_AVA_GFX_OVAL_CENTER_Y.Pop ( )
				
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_OVAL_START:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_RANGE:TFloatStack			=	New TFloatStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetOvalRadius ( start:Float, range:Float )

		_AVA_GFX_OVAL_START.Set ( start )
		_AVA_GFX_OVAL_RANGE.Set ( range )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetOvalRadius ( )

		_AVA_GFX_OVAL_START.Reset ( 0.00 )
		_AVA_GFX_OVAL_RANGE.Reset ( 360.00 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushOvalRadius ( start:Float, range:Float )

		_AVA_GFX_OVAL_START.Push ( start )
		_AVA_GFX_OVAL_RANGE.Push ( range )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopOvalRadius ( )

		_AVA_GFX_OVAL_START.Pop ( )
		_AVA_GFX_OVAL_RANGE.Pop ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_OVAL_COLOR_R2:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_COLOR_G2:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_COLOR_B2:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_COLOR_A2:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_COLOR_USE2:Byte			=	False

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function _AVA_UPDATE_OVAL_COLOR2 ( )

		_AVA_GFX_OVAL_COLOR_USE2				=	( _AVA_GFX_OVAL_COLOR_R2.Get ( ) <> 1.00 Or _AVA_GFX_OVAL_COLOR_G2.Get ( ) <> 1.00 Or _AVA_GFX_OVAL_COLOR_B2.Get ( ) <> 1.00 Or _AVA_GFX_OVAL_COLOR_A2.Get ( ) <> 1.00 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetOvalColor2 ( r:Float, g:Float, b:Float, a:Float = 1.00 )

		_AVA_GFX_OVAL_COLOR_R2.Set ( r )
		_AVA_GFX_OVAL_COLOR_G2.Set ( g )
		_AVA_GFX_OVAL_COLOR_B2.Set ( b )
		_AVA_GFX_OVAL_COLOR_A2.Set ( a )
		_AVA_UPDATE_OVAL_COLOR2 ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetOvalColor2 ( )
		
		_AVA_GFX_OVAL_COLOR_USE2				=	False
		
		_AVA_GFX_OVAL_COLOR_R2.Reset ( 1.00 )
		_AVA_GFX_OVAL_COLOR_G2.Reset ( 1.00 )
		_AVA_GFX_OVAL_COLOR_B2.Reset ( 1.00 )
		_AVA_GFX_OVAL_COLOR_A2.Reset ( 1.00 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushOvalColor2 ( r:Float, g:Float, b:Float, a:Float = 1.00 )

		_AVA_GFX_OVAL_COLOR_R2.Push ( r )
		_AVA_GFX_OVAL_COLOR_G2.Push ( g )
		_AVA_GFX_OVAL_COLOR_B2.Push ( b )
		_AVA_GFX_OVAL_COLOR_A2.Push ( a )
		_AVA_UPDATE_OVAL_COLOR2 ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopOvalColor2 ( )

		_AVA_GFX_OVAL_COLOR_R2.Pop ( )
		_AVA_GFX_OVAL_COLOR_G2.Pop ( )
		_AVA_GFX_OVAL_COLOR_B2.Pop ( )
		_AVA_GFX_OVAL_COLOR_A2.Pop ( )
		_AVA_UPDATE_OVAL_COLOR2 ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetOvalColor2 ( r:Float Var, g:Float Var, b:Float Var, a:Float Var )

		r									=	_AVA_GFX_OVAL_COLOR_R2.Get ( )
		g									=	_AVA_GFX_OVAL_COLOR_G2.Get ( )
		b									=	_AVA_GFX_OVAL_COLOR_B2.Get ( )
		a									=	_AVA_GFX_OVAL_COLOR_A2.Get ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_OVAL_COLOR_R1:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_COLOR_G1:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_COLOR_B1:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_COLOR_A1:TFloatStack			=	New TFloatStack
Global	_AVA_GFX_OVAL_COLOR_USE1:Byte			=	False

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function _AVA_UPDATE_OVAL_COLOR1 ( )

		_AVA_GFX_OVAL_COLOR_USE1				=	( _AVA_GFX_OVAL_COLOR_R1.Get ( ) <> 1.00 Or _AVA_GFX_OVAL_COLOR_G1.Get ( ) <> 1.00 Or _AVA_GFX_OVAL_COLOR_B1.Get ( ) <> 1.00 Or _AVA_GFX_OVAL_COLOR_A1.Get ( ) <> 1.00 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetOvalColor1 ( r:Float, g:Float, b:Float, a:Float = 1.00 )

		_AVA_GFX_OVAL_COLOR_R1.Set ( r )
		_AVA_GFX_OVAL_COLOR_G1.Set ( g )
		_AVA_GFX_OVAL_COLOR_B1.Set ( b )
		_AVA_GFX_OVAL_COLOR_A1.Set ( a )
		_AVA_UPDATE_OVAL_COLOR1 ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetOvalColor1 ( )
		
		_AVA_GFX_OVAL_COLOR_USE1				=	False
		
		_AVA_GFX_OVAL_COLOR_R1.Reset ( 1.00 )
		_AVA_GFX_OVAL_COLOR_G1.Reset ( 1.00 )
		_AVA_GFX_OVAL_COLOR_B1.Reset ( 1.00 )
		_AVA_GFX_OVAL_COLOR_A1.Reset ( 1.00 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushOvalColor1 ( r:Float, g:Float, b:Float, a:Float = 1.00 )

		_AVA_GFX_OVAL_COLOR_R1.Push ( r )
		_AVA_GFX_OVAL_COLOR_G1.Push ( g )
		_AVA_GFX_OVAL_COLOR_B1.Push ( b )
		_AVA_GFX_OVAL_COLOR_A1.Push ( a )
		_AVA_UPDATE_OVAL_COLOR1 ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopOvalColor1 ( )

		_AVA_GFX_OVAL_COLOR_R1.Pop ( )
		_AVA_GFX_OVAL_COLOR_G1.Pop ( )
		_AVA_GFX_OVAL_COLOR_B1.Pop ( )
		_AVA_GFX_OVAL_COLOR_A1.Pop ( )
		_AVA_UPDATE_OVAL_COLOR1 ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetOvalColor1 ( r:Float Var, g:Float Var, b:Float Var, a:Float Var )

		r									=	_AVA_GFX_OVAL_COLOR_R1.Get ( )
		g									=	_AVA_GFX_OVAL_COLOR_G1.Get ( )
		b									=	_AVA_GFX_OVAL_COLOR_B1.Get ( )
		a									=	_AVA_GFX_OVAL_COLOR_A1.Get ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

