'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Plot ( x:Float, y:Float, size:Float = 1.00, z:Float = 0.00 )

		StartDraw ( GL_POINTS )
		
			DrawVertex ( x, y, z )
			
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawLine ( x1:Float, y1:Float, x2:Float, y2:Float, z:Float = 0.00 )

		StartDraw ( GL_LINES )
		
			DrawVertex ( x1, y1, z, 0.00, 0.00 )
			DrawVertex ( x2, y2, z, 1.00, 0.00 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawLines ( xy:Float [ ], z:Float = 0.00 )

		StartDraw ( GL_LINES )
		
			For	Local i:Int = 0 Until xy.length - 1 Step 2
			
				DrawVertex ( xy [ i ], xy [ i + 1 ], z )
			
			Next

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawLineStrip ( xy:Float [ ], z:Float = 0.00 )

		StartDraw ( GL_LINE_STRIP )
		
			For	Local i:Int = 0 Until xy.length - 1 Step 2
			
				DrawVertex ( xy [ i ], xy [ i + 1 ], z )
			
			Next
			
		EndDraw ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawLineLoop ( xy:Float [ ], z:Float = 0.00 )

		StartDraw ( GL_LINE_LOOP )
		
			For	Local i:Int = 0 Until xy.length - 1 Step 2
			
				DrawVertex ( xy [ i ], xy [ i + 1 ], z )
			
			Next
			
		EndDraw ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawRect ( x:Float, y:Float, width:Float, height:Float, z:Float = 0.00 )
		
		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf

		StartDraw ( GL_QUADS )
		
			DrawVertex ( x, y, z, 0.00, 0.00 )
			DrawVertex ( x, y + height, z, 0.00, 1.00 )
			DrawVertex ( x + width, y + height, z, 1.00, 1.00 )
			DrawVertex ( x + width, y, z, 1.00, 0.00 )

		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawRoundRect ( x:Float, y:Float, width:Float, height:Float, round:Float = 16.00, z:Float = 0.00 )
		
		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf
	
		LockProjection ( )
		
		round									=	Min ( round, Min ( width, height ) )

		PushOvalRadius ( 180, 90 )
		
			DrawOval ( x, y, round, round, z )		

		SetOvalRadius ( 90, 90 )
				
			DrawOval ( x, y + height - round, round, round, z )		

		SetOvalRadius ( 270, 90 )
		
			DrawOval ( x + width - round, y, round, round, z )		

		SetOvalRadius ( 0, 90 )
	
			DrawOval ( x + width - round, y + height - round, round, round, z )		
		
		PopOvalRadius ( )

		DrawRect ( x + round * 0.50, y, width - round, round * 0.50, z )
		DrawRect ( x + round * 0.50, y + round * 0.50, width - round, ( height - round ) * 0.50, z )
		DrawRect ( x + round * 0.50, y + height * 0.50, width - round, ( height - round ) * 0.50, z )
		DrawRect ( x + round * 0.50, y + height, width - round, round * -0.50, z )
			
		If	round < height
				
			DrawRect ( x, y + round * 0.50, round * 0.50, ( height - round ) * 0.50, z )
			DrawRect ( x, y + height * 0.50, round * 0.50, ( height - round ) * 0.50, z )

			DrawRect ( x + width, y + round * 0.50, round * -0.50, ( height - round ) * 0.50, z )
			DrawRect ( x + width, y + height * 0.50, round * -0.50, ( height - round ) * 0.50, z )
			
		EndIf

		UnlockProjection ( )
	
		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawFrame ( x:Float, y:Float, width:Float, height:Float, size:Float = 1.00, z:Float = 0.00 )

		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf

		StartDraw ( GL_QUADS )
		
			DrawVertex ( x, y, z, 0.00, 0.00 )
			DrawVertex ( x + size, y + size, z, 0.00, 1.00 )
			DrawVertex ( x + width - size, y + size, z, 1.00, 1.00 )
			DrawVertex ( x + width, y, z, 1.00, 0.00 )

			DrawVertex ( x, y + Height, z, 0.00, 0.00 )
			DrawVertex ( x + size, y  + Height - size, z, 0.00, 1.00 )
			DrawVertex ( x + width - size, y + Height - size, z, 1.00, 1.00 )
			DrawVertex ( x + width, y + Height, z, 1.00, 0.00 )

			DrawVertex ( x, y, z, 0.00, 0.00 )
			DrawVertex ( x + size, y + size, z, 0.00, 1.00 )
			DrawVertex ( x + size, y + Height - size, z, 1.00, 1.00 )
			DrawVertex ( x, y + height, z, 1.00, 0.00 )

			DrawVertex ( x + width, y, z, 0.00, 0.00 )
			DrawVertex ( x + width - size, y + size, z, 0.00, 1.00 )
			DrawVertex ( x + width - size, y + Height - size, z, 1.00, 1.00 )
			DrawVertex ( x + width, y + height, z, 1.00, 0.00 )


		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawRoundFrame ( x:Float, y:Float, width:Float, height:Float, round:Float = 16.00, size:Float = 1.00, z:Float = 0.00 )
		
		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf
	
		LockProjection ( )
		
		round									=	Min ( round, Min ( width, height ) )

		PushOvalRadius ( 180, 90 )
		
			DrawRing ( x, y, round, round, size, z )		

		SetOvalRadius ( 90, 90 )
				
			DrawRing ( x, y + height - round, round, round, size, z )		

		SetOvalRadius ( 270, 90 )
		
			DrawRing ( x + width - round, y, round, round, size, z )		

		SetOvalRadius ( 0, 90 )
	
			DrawRing ( x + width - round, y + height - round, round, round, size, z )		
		
		PopOvalRadius ( )

		DrawRect ( x + round * 0.50, y, width - round, size, z )
		DrawRect ( x + round * 0.50, y + height, width - round, -size, z )
			
		If	round < height
				
			DrawRect ( x, y + round * 0.50, size, height - round, z )
			DrawRect ( x + width, y + round * 0.50, -size, height - round, z )
			
		EndIf

		UnlockProjection ( )
	
		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawLineFrame ( x:Float, y:Float, width:Float, height:Float, z:Float = 0.00 )

		StartDraw ( GL_LINE_STRIP )
		
			DrawVertex ( x, y, z, 0.00, 0.00 )
			DrawVertex ( x + width, y, z, 0.25, 0.00 )
			DrawVertex ( x + width, y + height, z, 0.50, 0.00 )
			DrawVertex ( x, y + height, z, 0.75, 0.00 )
			DrawVertex ( x, y, z, 1.00, 0.00 )
		
		EndDraw ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawOval ( x:Float, y:Float, width:Float, height:Float, z:Float = 0.00 )
	
		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf
		
		Local	mx:Float							=	x + width * 0.50
		Local	my:Float							=	y + height * 0.50
		Local segments:Int						=	Limit ( ( width * _AVA_GFX_SCALE_X.Get ( ) + height * _AVA_GFX_SCALE_Y.Get ( ) ) / _AVA_GFX_OVAL_SEGMENTING, _AVA_GFX_OVAL_MIN_SEGMENTS, _AVA_GFX_OVAL_MAX_SEGMENTS )
		Local delta:Double						=	_AVA_GFX_OVAL_RANGE.Get ( ) / Double ( segments )
		Local	angle:Double						=	_AVA_GFX_OVAL_START.Get ( )
		Local	finish:Double						=	_AVA_GFX_OVAL_START.Get ( ) + _AVA_GFX_OVAL_RANGE.Get ( )
		
		Local	r1:Float							=	1.00
		Local	g1:Float							=	1.00
		Local	b1:Float							=	1.00
		Local	a1:Float							=	1.00
		
		If	_AVA_GFX_OVAL_COLOR_USE1
		
			GetOvalColor1 ( r1, g1, b1, a1 )
		
		EndIf

		Local	r2:Float							=	1.00
		Local	g2:Float							=	1.00
		Local	b2:Float							=	1.00
		Local	a2:Float							=	1.00
		
		If	_AVA_GFX_OVAL_COLOR_USE2
		
			GetOvalColor2 ( r2, g2, b2, a2 )
		
		EndIf
		
		StartDraw ( GL_TRIANGLE_FAN )

			DrawVertex ( x + width * _AVA_GFX_OVAL_CENTER_X.Get ( ), y + height * _AVA_GFX_OVAL_CENTER_Y.Get ( ), z, 1.00, 0.00, r1, g1, b1, a1 )
		
			width								:*	0.50
			height							:*	0.50
			
			For	Local i:Int = 0 To segments
				
				DrawVertex ( mx + width * Cos ( angle ), my + height * Sin ( angle ), z, 0.00, 0.00, r2, g2, b2, a2 )
			
				angle							:+	delta
							
			Next
			
		EndDraw ( )

		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawRing ( x:Float, y:Float, width:Float, height:Float, size:Float = 1.00, z:Float = 0.00 )

		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf
		
		Local	mx:Float							=	x + width * 0.50
		Local	my:Float							=	y + height * 0.50
		Local segments:Int						=	Limit ( ( width * _AVA_GFX_SCALE_X.Get ( ) + height * _AVA_GFX_SCALE_Y.Get ( ) ) / _AVA_GFX_OVAL_SEGMENTING, _AVA_GFX_OVAL_MIN_SEGMENTS, _AVA_GFX_OVAL_MAX_SEGMENTS )
		Local delta:Double						=	_AVA_GFX_OVAL_RANGE.Get ( ) / Double ( segments )
		Local	angle:Double						=	_AVA_GFX_OVAL_START.Get ( ) - delta
		Local	finish:Double						=	_AVA_GFX_OVAL_START.Get ( ) + _AVA_GFX_OVAL_RANGE.Get ( )

		Local	r1:Float							=	1.00
		Local	g1:Float							=	1.00
		Local	b1:Float							=	1.00
		Local	a1:Float							=	1.00
		
		If	_AVA_GFX_OVAL_COLOR_USE1
		
			GetOvalColor1 ( r1, g1, b1, a1 )
		
		EndIf
		
		Local	r2:Float							=	1.00
		Local	g2:Float							=	1.00
		Local	b2:Float							=	1.00
		Local	a2:Float							=	1.00
		
		If	_AVA_GFX_OVAL_COLOR_USE2
		
			GetOvalColor2 ( r2, g2, b2, a2 )
		
		EndIf
				
		width									:*	0.50
		height								:*	0.50
		
		Local	u:Double							=	0.00
		Local	u_delta:Double						=	1.00 / Double ( Segments )
		
		StartDraw ( GL_QUAD_STRIP )
	
			For	Local i:Int = 0 To segments
			
				angle							:+	delta
				
				DrawVertex ( mx + width * Cos ( angle ), my + height * Sin ( angle ), z, u, 0.00, r2, g2, b2, a2 )
				DrawVertex ( mx + ( width - size ) * Cos ( angle ), my + ( height - size ) * Sin ( angle ), z, u, 1.00, r1, g1, b1, a1 )
				
				u							:+	u_delta
						
			Next
			
		EndDraw ( )

		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawLineRing ( x:Float, y:Float, width:Float, height:Float, z:Float = 0.00 )
	
		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf
		
		Local	mx:Float							=	x + width * 0.50
		Local	my:Float							=	y + height * 0.50
		Local segments:Int						=	Limit ( ( width * _AVA_GFX_SCALE_X.Get ( ) + height * _AVA_GFX_SCALE_Y.Get ( ) ) / _AVA_GFX_OVAL_SEGMENTING, _AVA_GFX_OVAL_MIN_SEGMENTS, _AVA_GFX_OVAL_MAX_SEGMENTS )
		Local delta:Double						=	_AVA_GFX_OVAL_RANGE.Get ( ) / Double ( segments )
		Local	angle:Double						=	_AVA_GFX_OVAL_START.Get ( )
		Local	finish:Double						=	_AVA_GFX_OVAL_START.Get ( ) + _AVA_GFX_OVAL_RANGE.Get ( )
		
		Local	u:Double							=	0.00
		Local u_step:Double						=	1.00 / Double ( segments )
		
		StartDraw ( GL_LINE_STRIP )

			width								:*	0.50
			height							:*	0.50
		'	segments							:+	1
			
			For	Local i:Int = 0 To segments
				
				DrawVertex ( mx + width * Cos ( angle ), my + height * Sin ( angle ), z, u, 0.00 )
			
				angle							:+	delta
				u							:+	u_step
							
			Next
			
		EndDraw ( )

		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawRhombFrame ( x:Float, y:Float, width:Float, height:Float, z:Float = 0.00 )

		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf

		StartDraw ( GL_LINE_LOOP )
		
			DrawVertex ( x + width * 0.50, y, z, 0.00, 0.00 )
			DrawVertex ( x + width, y + height * 0.50, z, 1.00, 0.00 )
			DrawVertex ( x + width * 0.50, y + height, z, 1.00, 1.00 )
			DrawVertex ( x, y + height * 0.50, z, 0.00, 1.00 )
		
		EndDraw ( )
		
		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawInvRhombFrame ( x:Float, y:Float, width:Float, height:Float, z:Float = 0.00 )

		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf

		StartDraw ( GL_LINE_LOOP )
		
			DrawVertex ( x, y, z, 0.00, 0.00 )
			DrawVertex ( x + width * 0.50, y, z, 0.00, 0.00 )
			DrawVertex ( x, y + height * 0.50, z, 0.00, 1.00 )
		
		EndDraw ( )
		StartDraw ( GL_LINE_LOOP )
		
			DrawVertex ( x + width, y, z, 0.00, 0.00 )
			DrawVertex ( x + width, y + height * 0.50, z, 1.00, 0.00 )			
			DrawVertex ( x + width * 0.50, y, z, 0.00, 0.00 )

		EndDraw ( )
		StartDraw ( GL_LINE_LOOP )
			
			DrawVertex ( x, y + height, z, 0.00, 0.00 )
			DrawVertex ( x + width * 0.50, y + height, z, 0.00, 0.00 )
			DrawVertex ( x, y + height * 0.50, z, 0.00, 1.00 )

		EndDraw ( )
		StartDraw ( GL_LINE_LOOP )

			DrawVertex ( x + width, y + height, z, 0.00, 0.00 )
			DrawVertex ( x + width * 0.50, y + height, z, 0.00, 0.00 )
			DrawVertex ( x + width, y + height * 0.50, z, 0.00, 1.00 )

		EndDraw ( )

		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawRhomb ( x:Float, y:Float, width:Float, height:Float, z:Float = 0.00 )

		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf

		StartDraw ( GL_QUADS )
		
			DrawVertex ( x + width * 0.50, y, z, 0.00, 0.00 )
			DrawVertex ( x + width, y + height * 0.50, z, 1.00, 0.00 )
			DrawVertex ( x + width * 0.50, y + height, z, 1.00, 1.00 )
			DrawVertex ( x, y + height * 0.50, z, 0.00, 1.00 )

		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawInvRhomb ( x:Float, y:Float, width:Float, height:Float, z:Float = 0.00 )

		If	_AVA_GFX_PROJECT_USE

			PushProjection ( x, y, width, height )
	
		EndIf

		StartDraw ( GL_TRIANGLES )
		
			DrawVertex ( x, y, z, 0.00, 0.00 )
			DrawVertex ( x + width * 0.50, y, z, 0.00, 0.00 )
			DrawVertex ( x, y + height * 0.50, z, 0.00, 1.00 )

			DrawVertex ( x + width, y, z, 0.00, 0.00 )
			DrawVertex ( x + width, y + height * 0.50, z, 1.00, 0.00 )			
			DrawVertex ( x + width * 0.50, y, z, 0.00, 0.00 )
			
			DrawVertex ( x, y + height, z, 0.00, 0.00 )
			DrawVertex ( x + width * 0.50, y + height, z, 0.00, 0.00 )
			DrawVertex ( x, y + height * 0.50, z, 0.00, 1.00 )

			DrawVertex ( x + width, y + height, z, 0.00, 0.00 )
			DrawVertex ( x + width * 0.50, y + height, z, 0.00, 0.00 )
			DrawVertex ( x + width, y + height * 0.50, z, 0.00, 1.00 )

		If	_AVA_GFX_PROJECT_USE

			PopProjection ( )
	
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawPolygon ( xy:Float [ ], uv:Float [ ] = Null, rgba:Float [ ] = Null, z:Float = 0.00 )

		Local	u:Float, v:Float, r:Float = 1, g:Float = 1, b:Float = 1, a:Float = 1
		Local i:Int, ci:Int

		StartDraw ( GL_POLYGON )
		
		While	i < xy.length - 1
		
			If	i < uv.length					Then	u = uv [ i ]
			If	i < uv.length - 1					Then	v = uv [ i + 1 ]

			If	ci < rgba.length					Then	r = rgba [ ci ]
			If	ci < rgba.length - 1				Then	g = rgba [ ci + 1 ]
			If	ci < rgba.length - 2				Then	b = rgba [ ci + 2 ]
			If	ci < rgba.length - 3				Then	a = rgba [ ci + 3 ]
		
			DrawVertex ( xy [ i ], xy [ i + 1 ], z, u, v, r, g, b, a )
		
			i								:+	2
			ci								:+	4
			
		Wend
		
		EndDraw ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawShadow ( coords:Float [ ], length:Float = 16.00, Alpha_1:Float = 0.35, Alpha_2:Float = 0.00, z:Float = 0.00 )
		
		PushAlphaTest ( False )		
		StartDraw ( GL_QUAD_STRIP )
		
			For	Local i:Int = 1 Until coords.length Step 2
			
				DrawVertex ( coords [ i - 1 ], coords [ i ], z, 0.00, 0.00, 0.00, 0.00, 0.00, Alpha_1 )
				DrawVertex ( coords [ i - 1 ] + length, coords [ i ] + length, z, 1.00, 0.00, 0.00, 0.00, 0.00, Alpha_2 )
			
			Next
		
		EndDraw ( )
		PopAlphaTest ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
