'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Triangulate2D_EarClipping:TVertex [ ] ( BaseVertices:TVertex [ ] )
	
	Local	Vertices:TVertex [ ]						=	BaseVertices
	
	Local	Result:TVertex [ ], Index:Int [ 3 ]
	Local	TriCenterX:Float, TriCenterY:Float
	
		If	Vertices.Length < 3
		
			Return ( Null )	
		
		EndIf
		
		While ( Vertices.Length > 3 )
			
			Local	vIndex:Int						=	0
			Local	Inversed:Byte					=	False
			
			Repeat
			
				Index [ 0 ]						=	vIndex
				Index [ 1 ]						=	( vIndex + 1 ) Mod Vertices.Length
				Index [ 2 ]						=	( vIndex + 2 ) Mod Vertices.Length
	
				TriCenterX						=	( Vertices [ Index [ 0 ] ] . x + Vertices [ Index [ 1 ] ] . x + Vertices [ Index [ 2 ] ] . x ) / 3.00
				TriCenterY						=	( Vertices [ Index [ 0 ] ] . y + Vertices [ Index [ 1 ] ] . y + Vertices [ Index [ 2 ] ] . y ) / 3.00
		
				If	PointInPoly_VertexArray ( TriCenterX, TriCenterY, Vertices )
				
					Local	Failed:Byte				=	False
					
					For	Local i:Int = 0 Until BaseVertices.Length
					
						If	BaseVertices [ i ] = Vertices [ Index [ 0 ] ] ..
						Or	BaseVertices [ i ] = Vertices [ Index [ 1 ] ] ..
						Or	BaseVertices [ i ] = Vertices [ Index [ 2 ] ]
							
							Continue
						
						EndIf
					
						If	PointInTriangle ( BaseVertices [ i ] . x, BaseVertices [ i ] . y, Vertices [ Index [ 0 ] ] . x, Vertices [ Index [ 0 ] ] . y, Vertices [ Index [ 1 ] ] . x, Vertices [ Index [ 1 ] ] . y, Vertices [ Index [ 2 ] ] . x, Vertices [ Index [ 2 ] ] . y )
						
							Failed			=	True

							If	Inversed			Print ( "  Failed // Out of Triangle" )
							
							Exit
					
						EndIf
						
						If	( BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] <> Vertices [ Index [ 0 ] ] And BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] <> Vertices [ Index [ 1 ] ] And LinesIntersect ( BaseVertices [ i ] . x, BaseVertices [ i ] . y, BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] . x, BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] . y, Vertices [ Index [ 0 ] ] . x, Vertices [ Index [ 0 ] ] . y, Vertices [ Index [ 1 ] ] . x, Vertices [ Index [ 1 ] ] . y ) ) ..
						Or	( BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] <> Vertices [ Index [ 0 ] ] And BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] <> Vertices [ Index [ 2 ] ] And LinesIntersect ( BaseVertices [ i ] . x, BaseVertices [ i ] . y, BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] . x, BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] . y, Vertices [ Index [ 0 ] ] . x, Vertices [ Index [ 0 ] ] . y, Vertices [ Index [ 2 ] ] . x, Vertices [ Index [ 2 ] ] . y ) ) ..
						Or	( BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] <> Vertices [ Index [ 1 ] ] And BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] <> Vertices [ Index [ 2 ] ] And LinesIntersect ( BaseVertices [ i ] . x, BaseVertices [ i ] . y, BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] . x, BaseVertices [ ( i + 1 ) Mod BaseVertices.Length ] . y, Vertices [ Index [ 1 ] ] . x, Vertices [ Index [ 1 ] ] . y, Vertices [ Index [ 2 ] ] . x, Vertices [ Index [ 2 ] ] . y ) ) ..
						
							Failed			=	True
							
							If	Inversed			Print ( "  Failed // Line Intersection" )
							
							Exit
					
						EndIf
						
					Next
					
					If	Not Failed
				
						Result				:+	[ Vertices [ Index [ 0 ] ] ]
						Result				:+	[ Vertices [ Index [ 1 ] ] ]
						Result				:+	[ Vertices [ Index [ 2 ] ] ]
						
						Vertices				=	Vertices [ ..Index [ 1 ] ] + Vertices [ Index [ 1 ] + 1 .. ]
						
						Exit
					
					EndIf
				
				Else
				
					If	Inversed			Print ( "  Failed // Out of Polygon" )

				EndIf
				
				vIndex						=	( vIndex + 1 ) Mod Vertices.Length
						
				If	vIndex = 0
				
					If	Inversed
						
						Print ( "[ EXIT UNFINISHED ]" )
						
						Return ( Result )
					
					Else
					
						BaseVertices			=	TPoly.Invert ( BaseVertices )
						Vertices				=	TPoly.Invert ( Vertices )
						Inversed				=	True
																		
						Print ( "" )
						Print ( "[ TRY INVERSE ]" )
						
					EndIf
									
				EndIf
		
			Forever
		
		Wend
		
		Result								:+	[ Vertices [ 0 ] ]
		Result								:+	[ Vertices [ 1 ] ]
		Result								:+	[ Vertices [ 2 ] ]
	
	Return ( Result )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PointInPoly_VertexArray:Byte ( px:Float, py:Float, Vertices:TVertex [ ] )
	
	Local	x1:Float								=	Vertices [ 0 ] . x
	Local	y1:Float								=	Vertices [ 0 ] . y
	Local	x2:Float								=	Vertices [ 0 ] . x
	Local	y2:Float								=	Vertices [ 0 ] . y

		For	Local i:Int = 1 Until Vertices.Length
		
			x1								=	Min ( x1, Vertices [ i ] . x )
			y1								=	Min ( y1, Vertices [ i ] . y )
			x2								=	Max ( x2, Vertices [ i ] . x )
			y2								=	Max ( y2, Vertices [ i ] . y )
		
		Next
	
	Local	w:Float								=	x2 - x1 + 1.00
	Local	h:Float								=	y2 - y1 + 1.00
	
	If	Not PointInRect ( px, py, x1, y1, w, h )
		
		Return ( False )
	
	EndIf
	
	Local	px2:Float								=	px + ( w + h ) + 0.1379
	Local	py2:Float								=	py + ( w + h ) - 0.1379
	Local	Hits:Int								=	0

		For	Local i:Int = 0 Until Vertices.Length
		
			Hits								:+	LinesIntersect ( px, py, px2, py2, Vertices [ i ] . x, Vertices [ i ] . y, Vertices [ ( i + 1 ) Mod Vertices.Length ] . x, Vertices [ ( i + 1 ) Mod Vertices.Length ] . y )
		
		Next
		
	Return ( Hits Mod 2 )
	
	Rem
	
	Local	Hits:Int								=	0
		
		If	Vertices.Length < 3
		
			Return ( False )
		
		EndIf
		
		For	Local i:Int = 0 Until Vertices.Length
		
			Local x1:Float						=	Vertices [ i ] . x
			Local y1:Float						=	Vertices [ i ] . y
			Local x2:Float						=	Vertices [ ( i + 1 ) Mod Vertices.Length ] . x
			Local y2:Float						=	Vertices [ ( i + 1 ) Mod Vertices.Length ] . y
		
			If	( y1 - py ) * ( y2 - py ) < 0.00
			
				If	( x1 + ( x2 - x1 ) * ( py - y1 ) / ( x2 - y1 ) ) < px
				
					Hits						:+	1
				
				EndIf			
			
			EndIf
			
		Next
		
	Return ( Hits Mod 2 )
		
	EndRem
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
