'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: Die Objektklasse fr den Grafiktreiber.
End Rem
Type TAvaGraphicsDriver Extends TGraphicsDriver

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	LINKS
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Global	debug ( t:String )					=	DebugLog
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	GLOBALS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Global	active_driver:TAvaGraphicsDriver			=	Null
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FIELDS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		active_graphics:TAvaGraphics				=	Null

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	New ( )
	
			active_driver						=	Self
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	GraphicsModes:TGraphicsMode [ ] ( )
	
	Local		buffer:Int[4100]
	Local		count:Int							=	bbGLGraphicsGraphicsModes ( buffer, 1024 )
	Local		pointer:Int Ptr						=	buffer
	Local		modes:TGraphicsMode [ count ]
	
			For	Local i:Int = 0 Until count
				
				modes[i]						=	New TGraphicsMode
				
				modes[i].width					=	pointer [ 0 ]
				modes[i].height					=	pointer [ 1 ]
				modes[i].depth					=	pointer [ 2 ]
				modes[i].hertz					=	pointer [ 3 ]
				
				pointer						:+	4
				
			Next
		
	Return	( modes )
		
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	AttachGraphics:TAvaGraphics ( widget:Int, flags:Int )
	
	Local		n:TAvaGraphics						=	New TAvaGraphics

			n.graphicsdriver						=	Self
			n.context							=	bbGLGraphicsAttachGraphics ( widget, flags )
			
	Return	( n )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	CreateGraphics:TAvaGraphics ( width:Int, height:Int, depth:Int, hertz:Int, flags:Int )
	
	Local		n:TAvaGraphics						=	New TAvaGraphics
			
			debug									( "" )
			debug									( "	[ AVA.GFX : erstelle Grafikausgabe ]" )

			n.graphicsdriver						=	Self
			n.context							=	bbGLGraphicsCreateGraphics ( width, height, depth, hertz, flags )

			Select	n.context > 0
				Case	True	debug						( "	[ AVA.GFX : Grafikausgabe = erfolgreich ]" )
				Case	False	Error						( "	FEHLER : [ AVA.GFX : Grafikausgabe = NICHT erfolgreich]" )
			EndSelect
				
	Return	( n )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	SetGraphics ( n:TGraphics )
				
			If	n

				If	active_graphics <> n
				
					active_graphics					=	TAvaGraphics ( n )

					bbGLGraphicsSetGraphics ( active_graphics.context )
					
					If	TAvaGraphicsEngine.active_engine = Null
					
						New TAvaGraphicsEngine
					
					EndIf

					active_graphics.activate ( )
					
					CheckGLError ( )
					
				EndIf
						
			Else
			
				active_graphics						=	Null
			
			EndIf
						
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	Flip ( sync:Int )
	
			If	active_graphics
				
				active_graphics.Flip ( )

			EndIf
			
			bbGLGraphicsFlip ( sync )

	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	ENDTYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	EXTERNAL FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function AvaGraphicsDriver:TAvaGraphicsDriver ( )
	
		Return ( New TAvaGraphicsDriver )
		
End Function


'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------



