'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	MODULE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

SuperStrict

Rem
bbdoc: AVA.Gfx
End Rem
Module AVA.Gfx

ModuleInfo	"Version: 1.17"
ModuleInfo	"Authors: Ava Vanessa Poldrack"
ModuleInfo	"Copyright: Ava Vanessa Poldrack"

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	IMPORTS
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
Import AVA.Core
Import AVA.GL
Import AVA.MediaLoader

Import BRL.Graphics
Import BRL.BmpLoader
Import BRL.PngLoader
Import BRL.JpgLoader
Import BRL.FreeTypeFont

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	EXTERN
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Const GLU_BEGIN:Int		= 	100100
	Const GLU_VERTEX:Int		=	100101 
	Const GLU_END:Int			=	100102
	Const GLU_ERROR:Int		=	100103

	Extern "Os"

		Function gluTessCallback(tesselator_tess:Byte Ptr,enum:Int,void_userData:Byte Ptr)
		Function gluErrorString:String(code:Int)
	
	EndExtern
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	INCLUDES
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Include "engine.bmx"
Include "driver.bmx"
Include "graphics.bmx"

Include "color.bmx"
Include "colorscale.bmx"
Include "coloroffset.bmx"
Include "color2.bmx"
Include "clscolor.bmx"
Include "blend.bmx"
Include "blend_eq.bmx"
Include "alphafunc.bmx"
Include "depthfunc.bmx"
Include "depth.bmx"
Include "depthrange.bmx"
Include "uvtransform.bmx"
Include "uvswap.bmx"
Include "uvscale.bmx"
Include "uvoffset.bmx"
Include "uvhandle.bmx"
Include "uvorigin.bmx"
Include "uvrotation.bmx"
Include "transform.bmx"
Include "xyswap.bmx"
Include "yzswap.bmx"
Include "scale.bmx"
Include "aspect.bmx"
Include "origin.bmx"
Include "offset.bmx"
Include "handle.bmx"
Include "rotation.bmx"
Include "projection.bmx"
Include "display.bmx"
Include "viewport.bmx"
Include "screenshot.bmx"

Include "image\TImage.bmx"
Include "image\image.bmx"
Include "image\texture.bmx"
Include "image\buffer.bmx"
Include "image\TMediaImageLoader.bmx"

Include "sprite\TSprite.bmx"
Include "sprite\sprite.bmx"

Include "imagefont\TImageFont.bmx"
Include "imagefont\TImageFontGlyph.bmx"
Include "imagefont\imagefont.bmx"
Include "imagefont\fontcolor.bmx"
Include "imagefont\TMediaFontLoader.bmx"

Include "shader\TShader.bmx"
Include "shader\shader.bmx"
Include "shader\TMediaShaderLoader.bmx"

Include "draw\draw.bmx"
Include "draw\primitive.bmx"
Include "draw\polygon.bmx"
Include "draw\point.bmx"
Include "draw\line.bmx"
Include "draw\oval.bmx"
Include "draw\TPoly.bmx"
Include "draw\triangulate.bmx"

Include "TColor.bmx"
Include "TFontColor.bmx"

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Incbin "arial.ttf"

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

AddErrorFunc ( EndGraphics )

'---------------------------------------------------------------------------------------------------------------------------------------------------------

AppTitle = "BlitzMax | AvaEngine"

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
