'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: Die Objektklasse fr die Grafikausgabe.
End Rem
Type TAvaGraphics Extends TGraphics

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	LINKS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	GLOBALS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Global	SetupCalls ( ) [ ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FIELDS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		context:Int
	Field		graphicsdriver:TAvaGraphicsDriver 

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FIELDS LINKS
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		_FPS:Int							=	0
	Field		_FPS_COUNTER:Int						=	0
	Field		_FPS_TIMER:Int [ ]					=	[ 0, 0 ]
	
	Field		_SETUP:Byte							=	True

	Global	_TEMP_VERTEX_COUNTER:Int				=	0
	Global	_VERTEX_COUNTER:Int					=	0
	Global	_POLY_COUNTER:Int						=	0
	Global	_TRIANGLE_COUNTER:Int					=	0

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	activate ( )
			
			If	_SETUP							setup ( )

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	setup ( )
			
			_SETUP							=	False			
			
			ResetDisplay ( )
			ResetViewport ( )

			ResetDepthTest ( )
			ResetDepthFunc ( )
			ResetDepthRange ( )

			ResetAlphaTest ( True )
			ResetAlphaFunc ( GL_GREATER, 0.00 )

			ResetPolyMode ( )
			ResetColor ( )
			ResetColor2 ( )
			ResetFontColor1 ( )
			ResetFontColor2 ( )
			ResetFontColor3 ( )
			ResetBlend ( )
			ResetBlendEQ ( )
			ResetLineWidth ( )
			ResetPointSize ( )
			ResetOvalRadius ( )
			ResetOvalCenter ( )
			ResetOvalColor1 ( )
			ResetOvalColor2 ( )
			
			ResetAspect ( )
			ResetScale ( )
			ResetOffset ( )
			ResetOrigin ( )
			ResetHandle ( )
			ResetRotation ( ) 
			
			ResetUVScale ( )
			ResetUVOrigin ( )
			ResetUVOffset ( )
			ResetUVRotation ( )
			
			_AVA_GFX_TEXTURE						=	_AVA_GFX_TEXTURE [ .. TAvaGraphicsEngine.GL_MULTITEX_UNITS ]
			_AVA_GFX_TEXTURE_UPDATE				=	_AVA_GFX_TEXTURE_UPDATE [ .. TAvaGraphicsEngine.GL_MULTITEX_UNITS ]
			_AVA_GFX_TEXTURE_SMARTSHADER_MODE			=	_AVA_GFX_TEXTURE_SMARTSHADER_MODE [ .. TAvaGraphicsEngine.GL_MULTITEX_UNITS ]
			
			For	Local i:Int = 0 Until TAvaGraphicsEngine.GL_MULTITEX_UNITS 
			
				_AVA_GFX_TEXTURE [ i ]				=	New TObjectStack			
				_AVA_GFX_TEXTURE_SMARTSHADER_MODE [ i ]	=	New TIntStack			
			
			Next
					
			_AVA_GFX_IMAGEFONT_STD					=	LoadImageFont ( "incbin::arial.ttf", 16 )

			ResetImageFont ( )

			MoveMouse ( GraphicsWidth ( ) / 2, GraphicsHeight ( ) / 2 )
			
			For	Local i:Int = 0 Until SetupCalls.Length
			
				SetupCalls [ i ] ( )
			
			Next
			
			Cls ( )
			Flip ( )
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	Flip ( )
			
			EndDraw ( )
			
			_FPS_TIMER [ 0 ]						=	MilliSecs ( )
	
			If	_FPS_TIMER [ 0 ] < _FPS_TIMER [ 1 ]
			
				_FPS_COUNTER					:+	1
				
			Else
			
				_FPS							=	_FPS_COUNTER
				_FPS_COUNTER					=	1
				_FPS_TIMER [ 1 ]					=	_FPS_TIMER [ 0 ] + 1000
			
			EndIf
			
			_TEMP_VERTEX_COUNTER					=	0
			_VERTEX_COUNTER						=	0
			_POLY_COUNTER						=	0
			_TRIANGLE_COUNTER						=	0
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TGRAPHICS METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	Driver:TAvaGraphicsDriver ( )
	
	Return	( graphicsdriver )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	GetSettings ( width:Int Var, height:Int Var, depth:Int Var, hertz:Int Var, flags:Int Var )
	
			bbGLGraphicsGetSettings ( context, width, height, depth, hertz, flags )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Close ( )
	
			If	context
			
				bbGLGraphicsClose ( context )

				context						=	Null

			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	ENDTYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	EXTERNAL FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function AvaGraphics:TGraphics ( Width:Int, Height:Int, Depth:Int = 0, Hertz:Int = 60, Flags:Int = GRAPHICS_BACKBUFFER )

		SetGraphicsDriver ( AvaGraphicsDriver ( ) )		
		Return ( Graphics ( width, height, depth, hertz, flags ) )
		
End Function

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FPS:Int ( )

	If	TAvaGraphicsDriver.active_driver And TAvaGraphicsDriver.active_driver.active_graphics
	
		Return ( TAvaGraphicsDriver.active_driver.active_graphics._FPS )
	
	Else
	
		Return ( -1 )
	
	EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: 
End Rem
Function Cls ( Flags:Int = GL_COLOR_BUFFER_BIT )

	EndDraw ( )
	
	glClear ( flags )
	
	CheckGLError ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: 
End Rem
Function ClsDepth ( )

	Cls ( GL_DEPTH_BUFFER_BIT )

EndFunction


'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: 
End Rem
Function ClsAcccum ( )

	Cls ( GL_ACCUM_BUFFER_BIT )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: 
End Rem
Function ClsStencil ( )

	Cls ( GL_STENCIL_BUFFER_BIT )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------


