'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TImage

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Global	F_Pixmap:TPixmap ( n:TPixmap, flags:Int ) [ ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		Flags:Int							=	-1
	Field		Source:Object						=	Null
	Field		Pixmap:TPixmap						=	Null

	Field		Texture:Int							=	-1
	Field		Frame_Buffer:Int						=	-1
	Field		Render_Buffer:Int						=	-1
	Field		Buffer_Ready:Byte						=	False

	Field		frame:TImageFrame [ ]					=	[ New TImageFrame ]	
	Field		FrameCount_X:Float					=	1.00
	Field		FrameCount_Y:Float					=	1.00

	Field		Width:Float							=	0.00						
	Field		Height:Float						=	0.00
	Field		Texture_Width:Float					=	0.00						
	Field		Texture_Height:Float					=	0.00
	
	Field		hx:Float							=	0.00
	Field		hy:Float							=	0.00
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Manage ( )
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Load ( )
			
			If	Texture > 0
			
				Return
			
			EndIf
			
			StopDraw ( )
			DisableBlend ( )			

			If	Pixmap = Null

				Pixmap						=	TPixmap ( Source )
				
			EndIf

			If	Pixmap = Null

				Pixmap						=	LoadPixmap ( Source )
				
			EndIf

			If	Pixmap = Null

				Error ( "LoadImage : ~q" + Source.ToString ( ) + "~q : konnte nicht geladen werden." )
			
			EndIf
			
			For	Local i:Int = 0 Until F_Pixmap.length

				Pixmap						=	F_Pixmap [ i ] ( Pixmap, Flags )
			
			Next
			
			Width								=	PixmapWidth ( Pixmap )
			Height							=	PixmapHeight ( Pixmap )
			
			Adjust_Pixmap ( )
			Gen_Texture ( )

			Texture_Width						=	PixmapWidth ( Pixmap )
			Texture_Height						=	PixmapHeight ( Pixmap )
			
			For	Local i:Int = 0 Until frame.length
			
			'	frame [ i ] . Texture				=	Texture
				frame [ i ] . Width				=	Width / FrameCount_x
				frame [ i ] . Height				=	Height / FrameCount_y
	
			Next
			
			If	Flags & ManagedImage = 0
			
				Pixmap						=	Null
			
			EndIf
			
			EnableBlend ( )
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Adjust_Pixmap:TPixmap ( )
	
	Local		width:Int							=	pixmap.width
	Local		height:Int							=	pixmap.height
			
			adjust_texsize ( width, height )
				
			If	pixmap.format <> PF_RGBA8888
					
				pixmap						=		pixmap.convert ( PF_RGBA8888 )
			
			EndIf
			
			If	pixmap.width <> width Or pixmap.height <> height 
		
				pixmap						=		ResizePixmap ( pixmap, width, height )
			
			EndIf

			Rem
			If	flags & MaskedImage
			
				pixmapclearpixels ( pixmap, TImage.MASK_COLOR, Null )

			EndIf
			EndRem
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Adjust_Texsize ( width:Int Var, height:Int Var )

			width								=	Pow2Size ( width )
			height							=	Pow2Size ( height )
			
			Repeat
			
				Local	t:Int
				
				glTexImage2D ( GL_PROXY_TEXTURE_2D, 0, 4, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, Null )
				glGetTexLevelParameteriv ( GL_PROXY_TEXTURE_2D, 0, GL_TEXTURE_WIDTH, Varptr t )
				
				If	t						Then	Exit
				
				If	( width = 1 And height = 1 )
				
					Error ( "LoadImage : ~q" + Source.ToString ( ) + "~q : Texturgrsse konnte nicht berechnet werden." )
				
					Exit
				
				EndIf	
				
				If	width > 1					Then	width :/ 2
				If	height > 1					Then	height :/ 2
		
			Forever

			'----------------------------------------------------------------------------------------------------------------------------------------

			Function Pow2Size:Int ( n:Int )
			
				Local	t:Int = 1
				
				While t < n
				
					t :* 2
					
				Wend
				
				Return ( t )
			
			EndFunction

			'----------------------------------------------------------------------------------------------------------------------------------------
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Gen_Texture ( )
		
			Texture							=	_AVA_GL_CLIENT._GEN_TEXTURE ( Pixmap, Flags, GEN_TEXTURE_CALLBACK )

			_AVA_GFX_UPDATE_TEXTURE ( )
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Function	GEN_TEXTURE_CALLBACK ( texture:Int )
			
			_AVA_GFX_UPDATE_TEXTURE ( texture )

	EndFunction
		
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Buffer:Int ( )

			If	Buffer_Ready = False

				StopDraw ( )
				Load ( )

				width							=	texture_width
				height						=	texture_height

				frame							=	[ New TImageFrame ]
				frame [ 0 ] . Width				=	Width
				frame [ 0 ] . Height				=	Height
				
				_AVA_GFX_UPDATE_TEXTURE ( texture )
				
				If	_AVA_GL_CLIENT._GEN_FRAMEBUFFER ( width, height, texture, frame_buffer, render_buffer ) = False
				
					Error ( "Imagebuffer konnte nicht erstellt werden." )
				
				Else
				
					Buffer_Ready				=	True
									
				EndIf
				
				_AVA_GFX_UPDATE_TEXTURE ( )

			EndIf
			
	Return	( Frame_Buffer )
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Correct_Frame ( f:Int Var )
			
			If	f <> 0 And frame.length > 1
			
				f							=	Modulus ( f, frame.Length )
	
			Else
			
				f							=	0
				
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Draw ( x:Float, y:Float, f:Int )
	
			Correct_Frame ( f )
			
			PushTexture ( Self )	
			PushOrigin ( x, y, 0, True )
			
				Frame [ f ] . Draw ( - hx * width, - hy * height, 0.00 )
	
			PopOrigin ( )
			PopTexture ( )
					
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Draw_Rect ( x:Float, y:Float, w:Float, h:Float, f:Int )

			PushTexture ( Self )

			Correct_Frame ( f )
			Frame [ f ] . Draw_Rect ( x, y, 0.00, w, h )

			PopTexture ( )

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Tile ( x:Float, y:Float, f:Int )

			PushTexture ( Self )
	
			Correct_Frame ( f )
			Frame [ f ] . Tile ( x, y, 0.00 )

			PopTexture ( )

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Free_Texture ( )
	
			If	Texture
			
				glDeleteTextures ( 1, Varptr Texture )
			
			EndIf
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Free_Buffer ( )
	
			If	Buffer_Ready
			
				glDeleteFramebuffersEXT ( 1, Varptr Frame_Buffer )
				glDeleteRenderbuffersEXT ( 1, Varptr Render_Buffer )
			
				Buffer_Ready					=	False
				
			EndIf
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Delete ( )

			Free_Texture ( )
			Free_Buffer ( )
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Type TImageFrame

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		Width:Float							=	0.00						
	Field		Height:Float						=	0.00

	Field		u1:Float							=	0.00
	Field		v1:Float							=	0.00
	Field		u2:Float							=	1.00
	Field		v2:Float							=	1.00
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Draw ( x:Float, y:Float, z:Float )
			
			StartDraw ( GL_QUADS )
			
				DrawVertex ( x, y, z, u1, v1 )
				DrawVertex ( x, y + height, z, u1, v2 )
				DrawVertex ( x + width, y + height, z, u2, v2 )
				DrawVertex ( x + width, y, z, u2, v1 )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Draw_Rect ( x:Float, y:Float, z:Float, width:Float, height:Float )

			StartDraw ( GL_QUADS )
			
				DrawVertex ( x, y, z, u1, v1 )
				DrawVertex ( x, y + height, z, u1, v2 )
				DrawVertex ( x + width, y + height, z, u2, v2 )
				DrawVertex ( x + width, y, z, u2, v1 )

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Tile ( x:Float, y:Float, z:Float )
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

