'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Const FilteredImage:Int							=	1

Rem
bbdoc:
End Rem
Const MipmappedImage:Int							=	2

Rem
bbdoc:
End Rem
Const ClampedImage:Int								=	4

Rem
bbdoc:
End Rem
Const MaskedImage:Int								=	8

Rem
bbdoc:
End Rem
Const ManagedImage:Int								=	16

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_IMAGE_AUTOFLAGS:Int					=	FilteredImage

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function CreateImage:TImage ( Width:Int, Height:Int, flags:Int = -1, Handle_X:Float = 0.00, Handle_Y:Float = 0.00 )

		Local Pixmap:TPixmap						=	CreatePixmap ( Width, Height, PF_RGBA8888 )
		
		ClearPixels ( Pixmap )

		Local	n:TImage							=	LoadImage ( Pixmap, flags )

		n.hx									=	Handle_X
		n.hy									=	Handle_Y

		Return ( n )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LoadImage:TImage ( Source:Object, Flags:Int = -1, Handle_X:Float = 0.00, Handle_Y:Float = 0.00 )

Local		n:TImage								=	New TImage

		If	flags = -1		
		
			n.flags							=	_AVA_GFX_IMAGE_AUTOFLAGS
		
		Else
		
			n.flags							=	flags
		
		EndIf
		
		n.source								=	source
		n.hx									=	Handle_X
		n.hy									=	Handle_Y

		If	n.flags & ManagedImage

			n.manage ( )
		
		Else
			
			n.Load ( )
		
		EndIf

Return	( n )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LoadAnimImage:TImage ( Source:Object, FrameCount_X:Int, FrameCount_Y:Int, Flags:Int = -1, Handle_X:Float = 0.00, Handle_Y:Float = 0.00 )

Local		n:TImage								=	New TImage

		If	flags = -1		
		
			n.flags							=	_AVA_GFX_IMAGE_AUTOFLAGS
		
		Else
		
			n.flags							=	flags
		
		EndIf
		
		n.source								=	source
		n.hx									=	Handle_X
		n.hy									=	Handle_Y

		n.Frame								=	New n.Frame [ .. FrameCount_x * FrameCount_y ]
		n.FrameCount_x							=	FrameCount_x
		n.FrameCount_y							=	FrameCount_y

Local		u_Step:Float							=	1.00 / n.FrameCount_x
Local		v_Step:Float							=	1.00 / n.FrameCount_y
		
		For	Local f:Int = 0 Until n.Frame.Length
		
			n.Frame [ f ]						=	New TImageFrame
			
			n.Frame [ f ] . u1					=	( f Mod FrameCount_x ) * u_Step			
			n.Frame [ f ] . u2					=	n.Frame [ f ] . u1 + u_Step			
			n.Frame [ f ] . v1					=	Ceil ( f / FrameCount_x ) * v_Step			
			n.Frame [ f ] . v2					=	n.Frame [ f ] . v1 + v_Step		
		
		Next

		If	n.flags & ManagedImage

			n.manage ( )
		
		Else
			
			n.Load ( )
		
		EndIf

Return	( n )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawImage ( n:TImage, x:Float, y:Float, frame:Int = 0 )

		If	n = Null
		
			Error ( "DrawImage : TImage ist Null." )
		
		EndIf

		n.Draw ( x, y, frame )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawImageRect ( n:TImage, x:Float, y:Float, width:Float, height:Float, frame:Int = 0 )

		If	n = Null
		
			Error ( "DrawImageRect : TImage ist Null." )
		
		EndIf
		
		n.Draw_Rect ( x, y, width, height, frame )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function TileImage ( n:TImage, x:Float, y:Float, frame:Int = 0 )

		If	n = Null
		
			Error ( "TileImage : TImage ist Null." )
		
		EndIf

		Error ( "TileImage : Diese Funktion wird noch nicht untersttzt." )

		n.Tile ( x, y, frame )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawMaskedImage ( Image:TImage, Mask:TImage, x:Float, y:Float )

		If	Image = Null
		
			Error ( "DrawMaskedImage : Image:TImage ist Null." )
		
		EndIf

		If	Mask = Null
		
			Error ( "DrawMaskedImage : Mask:TImage ist Null." )
		
		EndIf

		PushTexture ( Mask, 1 )
		
			Image.Draw ( x, y, 0 )
		
		PopTexture ( 1 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawMaskedImageRect ( Image:TImage, Mask:TImage, x:Float, y:Float, width:Float, height:Float )

		If	Image = Null
		
			Error ( "DrawMaskedImage : Image:TImage ist Null." )
		
		EndIf

		If	Mask = Null
		
			Error ( "DrawMaskedImage : Mask:TImage ist Null." )
		
		EndIf
		
		PushTexture ( Mask, 1 )
		
			Image.Draw_Rect ( x, y, width, height, 0 )
		
		PopTexture ( 1 )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ImageWidth:Int ( n:TImage, Frame:Int = 0 )

		If	n = Null
		
			Error ( "ImageWidth : TImage ist Null." )
		
		EndIf
		
		n.Correct_Frame ( Frame )

		Return ( n.Frame [ Frame ] . Width )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ImageHeight:Int ( n:TImage, Frame:Int = 0 )

		If	n = Null
		
			Error ( "ImageHeight : TImage ist Null." )
		
		EndIf

		n.Correct_Frame ( Frame )

		Return ( n.Frame [ Frame ] . Height )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetImageHandle ( n:TImage, HandleX:Float, HandleY:Float, UsePixelCoords:Byte = False )

		If	n = Null
		
			Error ( "SetImageHandle : TImage ist Null." )
		
		EndIf
		
		If	UsePixelCoords
		
			n.hx								=	HandleX / n.Width
			n.hy								=	HandleY / n.Height			
		
		Else
		
			n.hx								=	HandleX
			n.hy								=	HandleY
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MidHandleImage ( n:TImage )

		If	n = Null
		
			Error ( "MidHandleImage : TImage ist Null." )
		
		EndIf

		n.hx									=	0.50
		n.hy									=	0.50
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LinkLoadImageFunc ( FunctionArray:TPixmap ( Source:TPixmap, Flags:Int ) [ ] )

	TImage.F_Pixmap								=	FunctionArray

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LoadImageGroup:TImage [ ] ( Url:Object, Flags:Int = -1, Handle_X:Float = 0.00, Handle_Y:Float = 0.00 )

		If	Flags = -1		
		
			Flags								=	_AVA_GFX_IMAGE_AUTOFLAGS

		EndIf

		Local	Pixmap:TPixmap [ ]					=	TPixmap [ ] ( Url )
		
		If	Pixmap = Null
		
			Pixmap							=	LoadPixmapGroup ( Url )
		
		EndIf
		
		Local	Image:TImage [ Pixmap.Length ]
				
		For	Local i:Int = 0 Until Image.Length
				
			Image [ i ]							=	New TImage
			Image [ i ] . Flags					=	Flags
			Image [ i ] . Source					=	Pixmap [ i ]
			Image [ i ] . Hx						=	Handle_X
			Image [ i ] . Hy						=	Handle_Y
			
			If	Flags & ManagedImage
	
				Image [ i ] . Manage ( )
			
			Else
				
				Image [ i ] . Load ( )
			
			EndIf
		
		Next
		
Return	( Image )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LoadPixmapGroup:TPixmap [ ] ( Url:Object )

		Local	Pixmap:TPixmap [ ]
		Local	Bank:TBank							=	UncompressBank ( LoadBank ( Url ) )
		Local	Stream:TStream						=	CreateBankStream ( Bank )
			
			Pixmap							=	ReadPixmapGroup ( Stream )
				
		CloseStream ( Stream )
		
		Return ( Pixmap )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SavePixmapGroup ( Url:Object, Pixmap:TPixmap [ ] )

		Local	Bank:TBank							=	CreateBank ( )
		Local	Stream:TStream						=	CreateBankStream ( Bank )
			
			WritePixmapGroup ( Stream, Pixmap )				
			CloseStream ( Stream )
			
		SaveBank ( CompressBank ( Bank ), Url )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------


