'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_TEXTURE:TObjectStack [ ]
Global	_AVA_GFX_TEXTURE_SMARTSHADER_MODE:TIntStack [ ]
Global	_AVA_GFX_TEXTURE_UPDATE:Byte [ ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MaxTextureUnits:Int ( )
		
		Return ( _AVA_GFX_TEXTURE . Length )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetTexture ( n:TImage, Unit:Int = 0, SmartShaderMode:Int = 1 )
		
		If	Unit >= _AVA_GFX_TEXTURE.Length
		
			Error ( "SetTexture : Textureinheit [" + Unit + "] bersteigt das Limit (0 bis " + ( _AVA_GFX_TEXTURE.Length - 1 ) + ")." )
		
		EndIf
		
		If	_AVA_GFX_TEXTURE [ Unit ] . Get ( ) <> n ..
		Or	_AVA_GFX_TEXTURE_SMARTSHADER_MODE [ Unit ] . Get ( ) <> SmartShaderMode
		
			StopDraw ( )
		
			_AVA_GFX_TEXTURE_UPDATE [ Unit ]			=	True
		
		EndIf
		
		_AVA_GFX_TEXTURE [ Unit ] . Set ( n )
		_AVA_GFX_TEXTURE_SMARTSHADER_MODE [ Unit ] . Set ( SmartShaderMode )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushTexture ( n:TImage, Unit:Int = 0, SmartShaderMode:Int = 1 )

		If	Unit >= _AVA_GFX_TEXTURE.Length
		
			Error ( "PushTexture : Textureinheit [" + Unit + "] bersteigt das Limit (0 bis " + ( _AVA_GFX_TEXTURE.Length - 1 ) + ")." )
		
		EndIf

		If	_AVA_GFX_TEXTURE [ Unit ] . Get ( ) <> n ..
		Or	_AVA_GFX_TEXTURE_SMARTSHADER_MODE [ Unit ] . Get ( ) <> SmartShaderMode
		
			StopDraw ( )
		
			_AVA_GFX_TEXTURE_UPDATE [ Unit ]			=	True
		
		EndIf

		_AVA_GFX_TEXTURE [ Unit ] . Push ( n )
		_AVA_GFX_TEXTURE_SMARTSHADER_MODE [ Unit ] . Push ( SmartShaderMode )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopTexture ( Unit:Int = 0 )

		If	Unit >= _AVA_GFX_TEXTURE.Length
		
			Error ( "PopTexture : Textureinheit [" + Unit + "] bersteigt das Limit (0 bis " + ( _AVA_GFX_TEXTURE.Length - 1 ) + ")." )
		
		EndIf
		
		Local	n:Object							=	_AVA_GFX_TEXTURE [ Unit ] . Get ( )
		Local SmartShaderMode:Int					=	_AVA_GFX_TEXTURE_SMARTSHADER_MODE [ Unit ] . Get ( )
		
		_AVA_GFX_TEXTURE [ Unit ] . Pop ( )
		_AVA_GFX_TEXTURE_SMARTSHADER_MODE [ Unit ] . Pop ( )

		If	_AVA_GFX_TEXTURE [ Unit ] . Get ( ) <> n ..
		Or	_AVA_GFX_TEXTURE_SMARTSHADER_MODE [ Unit ] . Get ( ) <> SmartShaderMode

		
			StopDraw ( )
		
			_AVA_GFX_TEXTURE_UPDATE [ Unit ]			=	True
		
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetTexture:TImage ( Unit:Int = 0 )

		If	Unit >= _AVA_GFX_TEXTURE.Length
		
			Error ( "GetTexture : Textureinheit [" + Unit + "] bersteigt das Limit (0 bis " + ( _AVA_GFX_TEXTURE.Length - 1 ) + ")." )
		
		EndIf

		Return ( TImage ( _AVA_GFX_TEXTURE [ Unit ] . Get ( ) ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_TEXTURE ( texture:Int = -1 )
		
		StopDraw ( )
		
		Local n:TImage
		
		If	texture = -1

			For	Local i:Int = 0 Until _AVA_GFX_TEXTURE.Length
			
				If	_AVA_GFX_TEXTURE_UPDATE [ i ]
					
					n			 			=	TImage ( _AVA_GFX_TEXTURE [ i ] . Get ( ) )
					
					If	n
					
						texture				=	n.texture
					
					Else
						
						texture				=	0
					
					EndIf
	
					If	texture = 0
						
						_AVA_GL_CLIENT._ACTIVE_TEXTURE ( i )
						_AVA_GL_CLIENT._DISABLE ( GL_TEXTURE_2D )		
					
					Else
					
						_AVA_GL_CLIENT._ACTIVE_TEXTURE ( i )
						_AVA_GL_CLIENT._ENABLE ( GL_TEXTURE_2D )			
						_AVA_GL_CLIENT._BIND_TEXTURE ( texture, i )
			
					EndIf
					
					_AVA_GFX_TEXTURE_UPDATE [ i ]		=	False
				
				EndIf
			
			Next
			
		Else
			
			_AVA_GFX_TEXTURE_UPDATE [ 0 ]				=	True
			
			If	texture = 0
						
				_AVA_GL_CLIENT._ACTIVE_TEXTURE ( 0 )
				_AVA_GL_CLIENT._DISABLE ( GL_TEXTURE_2D )		
				
			Else
					
				_AVA_GL_CLIENT._ACTIVE_TEXTURE ( 0 )
				_AVA_GL_CLIENT._ENABLE ( GL_TEXTURE_2D )			
				_AVA_GL_CLIENT._BIND_TEXTURE ( texture, 0 )
			
			EndIf
						
		EndIf
		
		If	_AVA_GFX_ACTIVE_SHADER And _AVA_GFX_ACTIVE_SHADER.Flags & SmartShader
		
			_AVA_GFX_ACTIVE_SHADER.SmartUpdate_Textures ( )
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
