'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	CONSTANTS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Const SmoothFont:Int								=	1

Rem
bbdoc:
End Rem
Const ShadowFont:Int								=	2

Rem
bbdoc:
End Rem
Const EmbossedFont:Int								=	4

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc: @TImageFont Objekt.
End Rem
Type TImageFont

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	GLOBALS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Const		org_charset:String					=	" 0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ?!.,:;_-+*/\<>()[]{}#%&^'`|@$%&=" + ("~~") + ("~q")
	Global	default_charset:String					=	org_charset

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Global	AUTO_FLAGS:Int						=	SmoothFont
	Global	Multiple_Break_Factor:Float				=	1.00
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FIELDS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		IMAGES:TImage [ ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		charset:String						=	default_charset

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		SpaceFactor:Float						=	0.25
	
	Field		SIZE:Int						
	Field		FLAGS:Int
	Field		SOURCE:TFont

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		SHEAR:Float
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		GLYPH:TImageFontGlyph [ ]
	Field		GLYPH_count:Int
	Field		GLYPH_start:Int

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Load ( file:String, size:Int, flags:Int )

			Self.SIZE							=	size
			Self.FLAGS							=	flags
				
			SOURCE							=	LoadFont ( file, size, flags )
	
			If	SOURCE = Null
			
				Error ( "LoadImageFont : Datei ~q" + file + "~q konnte nicht geladen werden." )
	
			EndIf

			SetupGlyphs ( )
			CreateGlyphs ( )

	EndMethod	

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	SetupGlyphs ( )

	Local		max_char:Int						=	0
	
			GLYPH_count							=	SOURCE.CountGlyphs ( )
			GLYPH_start							=	1024

			For	Local i:Int = 0 Until charset.length 

				GLYPH_start						=	Min ( GLYPH_start	, charset [ i ] )
				max_char						=	Max ( max_char, charset [ i ] )

			Next
								
			GLYPH								=	New TImageFontGlyph [ max_char - GLYPH_start + 1 ]

	EndMethod	

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	CreateGlyphs ( )

	Local		n:TImageFontGlyph	
	
	Local		GLYPH_index:Int
	Local		GLYPH_source:TGlyph
	Local		GLYPH_pixmap:TPixmap
	
	Local		GROUP:Int
	Local		GROUP_x:Int
	Local		GROUP_y:Int
	Local		GROUP_h:Int
	Local		GROUP_pixmap:TPixmap

	Local		gSize:Int [ 4 ]
	Global	size_inc:Int						=	2 + ( SIZE / 8 )
		
			For	Local i:Int = 0 Until charset.length
			
				GLYPH_index						=	SOURCE.CharToGlyph ( charset [ i ] )
				If	GLYPH_index < 0					Continue
				
				GLYPH_source					=	SOURCE.LoadGlyph ( GLYPH_index )
				If	GLYPH_source.pixels ( ) = Null		Continue
				
				GLYPH_pixmap					=	TPixmap ( GLYPH_source.pixels ( ) ) . convert ( PF_RGBA8888 )				

				GLYPH [ charset [ i ] - GLYPH_start ]	=	New TImageFontGlyph 	
				n							=	GLYPH [ charset [ i ] - GLYPH_start ]
				n.width						=	GLYPH_pixmap.width + size_inc
				n.height						=	GLYPH_pixmap.height + size_inc
				n.advance						=	GLYPH_source.advance ( )	
				
				GLYPH_source.GetRect ( gSize [ 0 ], gSize [ 1 ],gSize [ 2 ], gSize [ 3 ] )
				
				n.Size [ 0 ]					=	gSize [ 0 ]
				n.Size [ 1 ]					=	gSize [ 1 ]
				n.Size [ 2 ]					=	gSize [ 2 ]
				n.Size [ 3 ]					=	gSize [ 3 ]
				
				n.size [ 2 ]					:+	n.size [ 0 ] + size_inc
				n.size [ 3 ]					:+	n.size [ 1 ] + size_inc
								
				If	GROUP_pixmap And ( GROUP_x + n.width >= GROUP_pixmap.width )
					
					GROUP_x					=	0
					GROUP_y					:+	GROUP_h
					GROUP_h					=	0
					
				EndIf				

				If	( GROUP_pixmap = Null ) ..
				Or	( GROUP_y + Max ( n.height, GROUP_h ) >= GROUP_pixmap.height )
					
					If	GROUP_pixmap
						
						GROUP_y				:+	GROUP_h
						
						Select True
						
							Case	GROUP_y < 16
								GROUP_pixmap	=	PixmapWindow ( GROUP_pixmap, 0, 0, 256, 16 )
						
							Case	GROUP_y < 32
								GROUP_pixmap	=	PixmapWindow ( GROUP_pixmap, 0, 0, 256, 32 )
							
							Case	GROUP_y < 64
								GROUP_pixmap	=	PixmapWindow ( GROUP_pixmap, 0, 0, 256, 64 )
						
							Case	GROUP_y < 128
								GROUP_pixmap	=	PixmapWindow ( GROUP_pixmap, 0, 0, 256, 128 )			
						
						EndSelect
						
						CompleteGlyphGroup ( GROUP, GROUP_pixmap )
					
					EndIf
					
					GROUP						:+	1
					GROUP_x					=	0
					GROUP_y					=	0
					GROUP_h					=	0

					GROUP_pixmap				=	CreatePixmap ( 256, 256, PF_RGBA8888 )
					
					GROUP_pixmap.ClearPixels ( Null )
								
				EndIf
				
				n.GROUP						=	GROUP
				n.x							=	GROUP_x
				n.y							=	GROUP_y
			
				GROUP_pixmap.paste ( GLYPH_pixmap, GROUP_x, GROUP_y )
				
				GROUP_x						:+	n.width
				GROUP_h						=	Max ( n.height, GROUP_h )
				
			Next	

			If	GROUP_pixmap
						
				GROUP_y						:+	GROUP_h
						
				Select True
						
					Case	GROUP_y < 16
						GROUP_pixmap			=	PixmapWindow ( GROUP_pixmap, 0, 0, 256, 16 )
				
					Case	GROUP_y < 32
						GROUP_pixmap			=	PixmapWindow ( GROUP_pixmap, 0, 0, 256, 32 )
						
					Case	GROUP_y < 64
						GROUP_pixmap			=	PixmapWindow ( GROUP_pixmap, 0, 0, 256, 64 )
						
					Case	GROUP_y < 128
						GROUP_pixmap			=	PixmapWindow ( GROUP_pixmap, 0, 0, 256, 128 )			
						
				EndSelect
						
				CompleteGlyphGroup ( GROUP, GROUP_pixmap )
					
			EndIf	
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	CompleteGlyphGroup ( GROUP:Int, GROUP_pixmap:TPixmap )

	Local		IMAGE:TImage						=	Null
	
			If	FLAGS & EmbossedFont	GROUP_pixmap	=	RenderEmbossedFont ( GROUP_pixmap )
			If	FLAGS & ShadowFont	GROUP_pixmap	=	RenderShadowFont ( GROUP_pixmap )

			Select FLAGS & SmoothFont
				
				Case	True			IMAGE			=	LoadImage ( GROUP_pixmap, FilteredImage | MipmappedImage )
				Case	False			IMAGE			=	LoadImage ( GROUP_pixmap, 0 )
				
			EndSelect
			
			For	Local	i:Int = 0 Until GLYPH.length
			
				If	GLYPH [ i ] And GLYPH [ i ] . GROUP = GROUP
					
					GLYPH [ i ] . IMAGE			=	IMAGE

					GLYPH [ i ] . uv				=	[ GLYPH [ i ] . x / Float ( GROUP_pixmap.width ), ..
												GLYPH [ i ] . y / Float ( GROUP_pixmap.height ), ..
												( GLYPH [ i ] . x + GLYPH [ i ] . width ) / Float ( GROUP_pixmap.width ), ..
												( GLYPH [ i ] . y + GLYPH [ i ] . height ) / Float ( GROUP_pixmap.height ) ]					
						
				EndIf
				
			Next
			
			IMAGES							:+	[ IMAGE ]
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	RenderShadowFont:TPixmap ( Pixmap:TPixmap )
	
	Local		SHADOW_size:Int						=	2 + ( SIZE / 8 )
	Local		SHADOW_density:Int					=	50
	Local		Pixmap_Copy:TPixmap					=	CopyPixmap ( Pixmap )
	
			For	Local i:Int = 1 To SHADOW_size
	
				For	Local x:Int = 0 Until Pixmap.Width - i
				For	Local y:Int = 0 Until Pixmap.Height - i
					
					If	ReadPixelAlpha ( Pixmap_Copy, x, y ) > 200 And ReadPixelAlpha ( Pixmap, x + i, y + i ) < 150
					
						WritePixelRed ( Pixmap, x + i, y + i, 0 )
						WritePixelGreen ( Pixmap, x + i, y + i, 0 )
						WritePixelBlue ( Pixmap, x + i, y + i, 0 )
						WritePixelAlpha ( Pixmap, x + i, y + i, Min ( ReadPixelAlpha ( Pixmap, x + i, y + i ) + SHADOW_density, 150 ) )
					
					EndIf
	
				Next
				Next
				
			Next
	
	Return	( Pixmap )
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	RenderEmbossedFont:TPixmap ( Pixmap:TPixmap )

			For	Local x:Int = 0 Until Pixmap.Width
			For	Local y:Int = Pixmap.Height - 1 To 0 Step - 1 
									
				If	y > 0 ..
				And	ReadPixelAlpha ( Pixmap, x, y - 1 ) > 127 ..
				And	ReadPixelAlpha ( Pixmap, x, y ) < 127
	
					WritePixelRed ( Pixmap, x, y, 255 )
					WritePixelGreen ( Pixmap, x, y, 255 )
					WritePixelBlue ( Pixmap, x, y, 255 )
					WritePixelAlpha ( Pixmap, x, y, ( ReadPixelAlpha ( Pixmap, x, y - 1 ) + ReadPixelAlpha ( Pixmap, x, y ) ) / 3 )
					
				Else
				
					WritePixelRed ( Pixmap, x, y, 0 )
					WritePixelGreen ( Pixmap, x, y, 0 )
					WritePixelBlue ( Pixmap, x, y, 0 )					
				
				EndIf
				
			Next
			Next

			For	Local x:Int = 0 Until Pixmap.Width
			For	Local y:Int = 0 Until Pixmap.Height - 1
									
				If	ReadPixelAlpha ( Pixmap, x, y + 1 ) > 127 ..
				And	ReadPixelAlpha ( Pixmap, x, y ) < 127

					WritePixelAlpha ( Pixmap, x, y, ( ReadPixelAlpha ( Pixmap, x, y - 1 ) + ReadPixelAlpha ( Pixmap, x, y ) ) / 3 )	
				
				EndIf
				
			Next
			Next
	
	Return	( Pixmap )
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	DRAWTEXT
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	TextWidth:Int ( Text:String )
	
	Local		result:Int							=	0
	Local		max_Result:Int						=	0
		
			For	Local i:Int = 0 Until Text.length

				If	Text [ i ] = 10
					
					max_Result					=	Max ( max_Result, Result )
					Result					=	0
					Continue
				
				EndIf
											
				If	Text [ i ] = 32
					
					result					:+	SIZE * SpaceFactor
						
				EndIf

				If	Text [ i ] < GLYPH_start Or Text [ i ] >= GLYPH_start + GLYPH.length Or GLYPH [ Text [ i ] - GLYPH_start ] = Null
			
					Continue
			
				EndIf
								
				result						:+	GLYPH [ Text [ i ] - GLYPH_start ].advance
					
			Next
	
	Return	( Max ( max_Result, Result ) )
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	TextHeight:Int ( Text:String )
	
	Local		Result:Int							=	SIZE
	Local		Break:Byte							=	False
	
			For	Local i:Int = 0 Until Text.length
				
				If	Text [ i ] = 10
					
					If	Break
					
						Result				:+	Int ( SIZE * Multiple_Break_Factor )
										
					Else

						Result				:+	SIZE

					EndIf
					
					Break						=	True
					
				Else
				
					Break						=	False
					
				EndIf
			
			Next			
	
	Return	( Result )
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	DrawText ( Text:String, _x:Float, _y:Float, _z:Float, hx:Float, hy:Float)
	
	Local		break:Byte							=	False
	
	Local		x:Float							=	_x
	Local		y:Float							=	_y
	Local		z:Float							=	_z
	Local		Text_Width:Int						=	TextWidth ( Text )
	
	Local		n:TImageFontGlyph
	
			If	hx <> 0.00					x	:-	( hx * Text_Width )
			If	hy <> 0.00					y	:-	( hy * TextHeight ( Text ) )
	
	Local		r1:Float							=	1.00
	Local		g1:Float							=	1.00
	Local		b1:Float							=	1.00
	Local		a1:Float							=	1.00
	
			If	_AVA_GFX_FONT_COLOR_USE1
			
				GetFontColor1 ( r1, g1, b1, a1 )
			
			EndIf

	Local		r2:Float							=	1.00
	Local		g2:Float							=	1.00
	Local		b2:Float							=	1.00
	Local		a2:Float							=	1.00
	
			If	_AVA_GFX_FONT_COLOR_USE2
			
				GetFontColor2 ( r2, g2, b2, a2 )
			
			EndIf

	Local		r3:Float							=	1.00
	Local		g3:Float							=	1.00
	Local		b3:Float							=	1.00
	Local		a3:Float							=	1.00
	
			If	_AVA_GFX_FONT_COLOR_USE3
			
				GetFontColor3 ( r3, g3, b3, a3 )
			
			EndIf

			_AVA_GFX_TRANSFORM_NO_FRACT				=	True
	
			PushTexture ( Null )
			
			For	Local i:Int = 0 Until Text.length
				
				If	Text [ i ] = 10
					
					x						=	_x
					
					If	Break
					
						y					:+	( SIZE * Multiple_Break_Factor )

					Else
					
						y					:+	SIZE
					
					EndIf
					
					Break						=	True

					If	hx <> 0.00			x	:-	( hx * Text_Width )

					Continue
				
				Else
				
					Break						=	False
				
				EndIf

				If	Text [ i ] = 32
					
					x						:+	( SIZE * SpaceFactor )
					Continue
				
				EndIf
				
				If	Text [ i ] < GLYPH_start Or Text [ i ] >= GLYPH_start + GLYPH.length Or GLYPH [ Text [ i ] - GLYPH_start ] = Null
			
					Continue
			
				EndIf
			
				n							=	GLYPH [ Text [ i ] - GLYPH_start ]
				
				SetTexture ( n.IMAGE )
				StartDraw ( GL_QUADS )
				
				If	_AVA_GFX_FONT_COLOR_USE2

					DrawVertex ( x + n.size [ 0 ] + n.size [ 3 ] * SHEAR, y + n.size [ 1 ], z, n.uv [ 0 ], n.uv [ 1 ], r1, g1, b1, a1 )
					DrawVertex ( x + n.size [ 2 ] + n.size [ 3 ] * SHEAR, y + n.size [ 1 ], z, n.uv [ 2 ], n.uv [ 1 ], r1, g1, b1, a1 )

					_AVA_GFX_TRANSFORM_NO_FRACT		=	False
					
					DrawVertex ( x + n.size [ 2 ] + n.size [ 3 ] * SHEAR * 0.50, y + ( n.size [ 1 ] * 0.70 + n.size [ 3 ] * 0.30 ), z, n.uv [ 2 ], ( n.uv [ 1 ] * 0.70 + n.uv [ 3 ] * 0.30 ), r2, g2, b2, a2 )
					DrawVertex ( x + n.size [ 0 ] + n.size [ 3 ] * SHEAR * 0.50, y + ( n.size [ 1 ] * 0.70 + n.size [ 3 ] * 0.30 ), z, n.uv [ 0 ], ( n.uv [ 1 ] * 0.70 + n.uv [ 3 ] * 0.30 ), r2, g2, b2, a2 )
					
					DrawVertex ( x + n.size [ 0 ] + n.size [ 3 ] * SHEAR * 0.50, y + ( n.size [ 1 ] * 0.70 + n.size [ 3 ] * 0.30 ), z, n.uv [ 0 ], ( n.uv [ 1 ] * 0.70 + n.uv [ 3 ] * 0.30 ), r2, g2, b2, a2 )
					DrawVertex ( x + n.size [ 2 ] + n.size [ 3 ] * SHEAR * 0.50, y + ( n.size [ 1 ] * 0.70 + n.size [ 3 ] * 0.30 ), z, n.uv [ 2 ], ( n.uv [ 1 ] * 0.70 + n.uv [ 3 ] * 0.30 ), r2, g2, b2, a2 )
					
					_AVA_GFX_TRANSFORM_NO_FRACT		=	True
					
					DrawVertex ( x + n.size [ 2 ], y + n.size [ 3 ], z, n.uv [ 2 ], n.uv [ 3 ], r3, g3, b3, a3 )
					DrawVertex ( x + n.size [ 0 ], y + n.size [ 3 ], z, n.uv [ 0 ], n.uv [ 3 ], r3, g3, b3, a3 )
					
				Else

					DrawVertex ( x + n.size [ 0 ] + n.size [ 3 ] * SHEAR, y + n.size [ 1 ], z, n.uv [ 0 ], n.uv [ 1 ], r1, g1, b1, a1 )
					DrawVertex ( x + n.size [ 2 ] + n.size [ 3 ] * SHEAR, y + n.size [ 1 ], z, n.uv [ 2 ], n.uv [ 1 ], r1, g1, b1, a1 )
					DrawVertex ( x + n.size [ 2 ], y + n.size [ 3 ], z, n.uv [ 2 ], n.uv [ 3 ], r3, g3, b3, a3 )
					DrawVertex ( x + n.size [ 0 ], y + n.size [ 3 ], z, n.uv [ 0 ], n.uv [ 3 ], r3, g3, b3, a3 )

				EndIf
				
				x							:+	n.advance
			
			Next

			EndDraw ( )
			PopTexture ( )
			
			_AVA_GFX_TRANSFORM_NO_FRACT				=	False
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	ENDTYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------------------------------------------------------------------
