'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Global	_AVA_GFX_IMAGEFONT:TObjectStack			=	New TObjectStack
	Global	_AVA_GFX_IMAGEFONT_STD:TImageFont			=	Null

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function LoadImageFont:TImageFont ( URL:Object, Size:Int, Style:Int = -1)
	
	Local	n:TImageFont							=	New TImageFont
	If	Style = -1						Style		=	TImageFont.AUTO_FLAGS

	If	Size < 1

		Error ( "LoadImageFont : Parameter ~qSize~q muss positiv sein." )

	EndIf
	
		n.Load ( URL.toString ( ), Size, Style )
	
	Return ( n )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function SetImageFont ( Font:TImageFont )

	If	Font = Null

		Error ( "SetImageFont : TImageFont ist Null." )

	EndIf

	_AVA_GFX_IMAGEFONT.Set ( Font )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function ResetImageFont ( )

	_AVA_GFX_IMAGEFONT.Reset ( _AVA_GFX_IMAGEFONT_STD )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function PushImageFont ( Font:TImageFont )

	If	Font = Null

		Error ( "PushImageFont : TImageFont ist Null." )

	EndIf

	_AVA_GFX_IMAGEFONT.Push ( Font )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function PopImageFont ( )

	_AVA_GFX_IMAGEFONT.Pop ( )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function GetImageFont:TImageFont ( )

	Return ( TImageFont  ( _AVA_GFX_IMAGEFONT.Get ( ) ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function GetImageFontImages:TImage [ ] ( Font:TImageFont )

	If	Font = Null

		Font									=	GetImageFont ( )

	EndIf

	Return ( Font.Images )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetImageFontAutoFlags ( Flags:Int )

	TImageFont.AUTO_FLAGS							=	flags
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function ImageFontScaleChars ( Font:TImageFont, FirstChar:Int, LastChar:Int, Scale:Float )
	
	If	Font = Null

		Error ( "ImageFontScaleChars : TImageFont ist Null." )

	EndIf
	
	Local	n:TImageFontGlyph
		
		For	Local i:Int = FirstChar To LastChar
		
			If	i < Font.GLYPH_start Or i >= Font.GLYPH_start + Font.GLYPH.length Or Font.GLYPH [ i - Font.GLYPH_start ] = Null
			
				Continue
			
			EndIf
			
			n								=	Font.GLYPH [ i - Font.GLYPH_start ]
			n.Size [ 3 ]						=	( n.Size [ 3 ] - n.Size [ 1 ] ) * Scale + n.Size [ 1 ]
		
		Next
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function ImageFontMoveChars ( Font:TImageFont, FirstChar:Int, LastChar:Int, Move:Float )
	
	If	Font = Null

		Error ( "ImageFontMoveChars : TImageFont ist Null." )

	EndIf
	
	Local	n:TImageFontGlyph
		
		For	Local i:Int = FirstChar To LastChar
		
			If	i < Font.GLYPH_start Or i >= Font.GLYPH_start + Font.GLYPH.length Or Font.GLYPH [ i - Font.GLYPH_start ] = Null
			
				Continue
			
			EndIf
			
			n								=	Font.GLYPH [ i - Font.GLYPH_start ]
			n.Size [ 1 ]						:+	Move
			n.Size [ 3 ]						:+	Move
		
		Next
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function ImageFontScaleCharAdvance ( Font:TImageFont, Char:Int, Scale:Float )
	
	If	Font = Null

		Error ( "ImageFontScaleCharAdvance : TImageFont ist Null." )

	EndIf
	
	Local	Glyph:TImageFontGlyph						=	Font.GLYPH [ Char - Font.GLYPH_start ]

	If	Glyph = Null

		Error ( "ImageFontScaleCharAdvance : ~q" + Chr ( Char ) + "~q ist in der Schrift nicht present." )

	EndIf

	Glyph.Advance								:*	Scale
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function ImageFontReplaceGlyph:TImageFontGlyph ( Font:TImageFont, Char:Int, Image:TImage )

	If	Font = Null

		Error ( "ImageFontReplaceGlyph : TImageFont ist Null." )

	EndIf

	If	Image = Null

		Error ( "ImageFontReplaceGlyph : TImage ist Null." )

	EndIf
	
	Local	Glyph:TImageFontGlyph						=	Font.GLYPH [ Char - Font.GLYPH_start ]

	If	Glyph = Null
		
		Glyph									=	New TImageFontGlyph
		Font.GLYPH [ Char - Font.GLYPH_start ]			=	Glyph
								
	'	Error ( "ImageFontReplaceGlyph : ~q" + Chr ( Char ) + "~q ist in der Schrift nicht present." )

	EndIf
	
	Glyph.Image									=	Image
	Glyph.Size									=	[ 0.00, 0.00, Image.Width, Image.Height ]
	Glyph.UV									=	[ 0.00, 0.00, 1.00, 1.00 ]
	Glyph.Advance								=	Image.Width
	
	Return ( Glyph )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function TextWidth:Float ( Text:String )
	
	Return ( GetImageFont ( ) . TextWidth ( Text ) )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function TextHeight:Int ( Text:String )
	
	Return ( GetImageFont ( ) . TextHeight ( Text ) )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
EndRem
Function DrawText ( Text:String, x:Float, y:Float, hx:Float = 0.00, hy:Float = 0.00, z:Float = 0.00 )
	
	If	Text
	
		GetImageFont ( ) . DrawText ( Text, x, y, z, hx, hy )
			
	EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------


