'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_PROJECT_X:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_PROJECT_Y:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_PROJECT_W:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_PROJECT_H:TFloatStack				=	New TFloatStack
Global	_AVA_GFX_PROJECT_FUNC:TProjectFuncStack 		=	New TProjectFuncStack 
Global	_AVA_GFX_PROJECT_USE:Byte					=	False
Global	_AVA_GFX_PROJECT_LOCKED:Int					=	0

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LockProjection ( )

		_AVA_GFX_PROJECT_LOCKED					:+	1

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function UnlockProjection ( )

		_AVA_GFX_PROJECT_LOCKED					=	Max ( _AVA_GFX_PROJECT_LOCKED - 1, 0 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetProjection ( x:Float, y:Float, width:Float, height:Float )
		
		If	_AVA_GFX_PROJECT_LOCKED > 0
		
			Return
		
		EndIf
		
		_AVA_GFX_PROJECT_X.Set ( x )
		_AVA_GFX_PROJECT_Y.Set ( y )
		_AVA_GFX_PROJECT_W.Set ( width )
		_AVA_GFX_PROJECT_H.Set ( height )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetProjection ( )
		
		If	_AVA_GFX_PROJECT_LOCKED > 0
		
			Return
		
		EndIf

		_AVA_GFX_PROJECT_X.Reset ( 0.00 )
		_AVA_GFX_PROJECT_Y.Reset ( 0.00 )
		_AVA_GFX_PROJECT_W.Reset ( 0.00 )
		_AVA_GFX_PROJECT_H.Reset ( 0.00 )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushProjection ( x:Float, y:Float, width:Float, height:Float )
		
		If	_AVA_GFX_PROJECT_LOCKED > 0
		
			Return
		
		EndIf

		_AVA_GFX_PROJECT_X.Push ( x )
		_AVA_GFX_PROJECT_Y.Push ( y )
		_AVA_GFX_PROJECT_W.Push ( width )
		_AVA_GFX_PROJECT_H.Push ( height )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopProjection ( )
		
		If	_AVA_GFX_PROJECT_LOCKED > 0
		
			Return
		
		EndIf

		_AVA_GFX_PROJECT_X.Pop ( )
		_AVA_GFX_PROJECT_Y.Pop ( )
		_AVA_GFX_PROJECT_W.Pop ( )
		_AVA_GFX_PROJECT_H.Pop ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetProjection ( x:Float Var, y:Float Var, width:Float Var, height:Float Var )

		x									=	_AVA_GFX_PROJECT_X.Get ( )
		y									=	_AVA_GFX_PROJECT_Y.Get ( )
		width									=	_AVA_GFX_PROJECT_W.Get ( )
		height								=	_AVA_GFX_PROJECT_H.Get ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetProjectFunc ( func ( x:Float Var, y:Float Var, z:Float Var, u:Float Var, v:Float Var, r:Float Var, g:Float Var, b:Float Var, a:Float Var, unit:Int ) )
		
		If	_AVA_GFX_PROJECT_LOCKED > 0
		
			Return
		
		EndIf

		_AVA_GFX_PROJECT_FUNC.Set ( func )
		_AVA_GFX_UPDATE_PROJECTION ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetProjectFunc ( )
		
		If	_AVA_GFX_PROJECT_LOCKED > 0
		
			Return
		
		EndIf

		_AVA_GFX_PROJECT_FUNC.Reset ( Null )
		_AVA_GFX_UPDATE_PROJECTION ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushProjectFunc ( func ( x:Float Var, y:Float Var, z:Float Var, u:Float Var, v:Float Var, r:Float Var, g:Float Var, b:Float Var, a:Float Var, unit:Int ) )
		
		If	_AVA_GFX_PROJECT_LOCKED > 0
		
			Return
		
		EndIf

		_AVA_GFX_PROJECT_FUNC.Push ( func )
		_AVA_GFX_UPDATE_PROJECTION ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopProjectFunc ( )
		
		If	_AVA_GFX_PROJECT_LOCKED > 0
		
			Return
		
		EndIf

		_AVA_GFX_PROJECT_FUNC.Pop ( )
		_AVA_GFX_UPDATE_PROJECTION ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_PROJECTION ( )

		_AVA_GFX_PROJECT_USE						=	( _AVA_GFX_PROJECT_FUNC.Get ( ) <> Null )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_PROJECT ( x:Float Var, y:Float Var, z:Float Var, u:Float Var, v:Float Var, r:Float Var, g:Float Var, b:Float Var, a:Float Var, Unit:Int )
		
		If	_AVA_GFX_PROJECT_USE
			
			_AVA_GFX_PROJECT_FUNC.Get ( ) ( x, y, z, u, v, r, g, b, a, Unit )
			
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Type TProjectFuncStack 

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FIELD
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		Index:Int							=	0
	Field		Stack ( x:Float Var, y:Float Var, z:Float Var, u:Float Var, v:Float Var, r:Float Var, g:Float Var, b:Float Var, a:Float Var, unit:Int ) [ 1 ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Get ( x:Float Var, y:Float Var, z:Float Var, u:Float Var, v:Float Var, r:Float Var, g:Float Var, b:Float Var, a:Float Var, unit:Int ) ( )
	
			Return ( Stack [ Index ] )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Set ( v ( x:Float Var, y:Float Var, z:Float Var, u:Float Var, v:Float Var, r:Float Var, g:Float Var, b:Float Var, a:Float Var, unit:Int ) )
	
			Stack [ Index ]						=	v
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Reset ( v ( x:Float Var, y:Float Var, z:Float Var, u:Float Var, v:Float Var, r:Float Var, g:Float Var, b:Float Var, a:Float Var, unit:Int ) = Null )
	
			Stack								=	[ v ]
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Push ( v ( x:Float Var, y:Float Var, z:Float Var, u:Float Var, v:Float Var, r:Float Var, g:Float Var, b:Float Var, a:Float Var, unit:Int ) )
			
			Index								:+	1
			
			If	Index < Stack.Length
			
				Stack [ Index ]					=	v
	
			Else
			
				Stack							:+	[ v ]
			
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Pop ( )
	
			If	Index
			
				Index							:-	1
	
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	ENDTYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
