'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_SCREENSHOT_FOLDER:String				=	"SCREENSHOTS"
Global	_AVA_GFX_SCREENSHOT_FILE:String				=	""
Global	_AVA_GFX_SCREENSHOT_FORMAT:String				=	"JPG"
Global	_AVA_GFX_SCREENSHOT_PNG_COMP:Int				=	9
Global	_AVA_GFX_SCREENSHOT_JPG_QUAL:Int				=	75

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetScreenshotFormat ( Format:String )

		_AVA_GFX_SCREENSHOT_FORMAT					=	Upper ( Format )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetScreenshotFolder ( Folder:String )

		_AVA_GFX_SCREENSHOT_FOLDER					=	Folder
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetScreenshotFile ( File:String )

		_AVA_GFX_SCREENSHOT_FILE					=	File
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function DrawPixmap:TPixmap ( Pixmap:TPixmap, X:Int, Y:Int )

		If	Pixmap = Null
		
			Error ( "DrawPixmap : TPixmap ist Null." )
		
		EndIf

	Local	n:TPixmap								=	YFlipPixmap ( Pixmap )
		
		If	n.format <> PF_RGBA8888
		
			n								=	ConvertPixmap ( n, PF_RGBA8888 )
			
		EndIf

		StopDraw ( )
		DisableBlend ( )
			
		glRasterPos2i ( 0, 0 )
		CheckGLError ( )
		
		glBitmap ( 0, 0, 0, 0, x, -(n.height + y), Null )
		CheckGLError ( )
		
		glDrawPixels ( n.width, n.height, GL_RGBA, GL_UNSIGNED_BYTE, n.pixels )
		CheckGLError ( )

		EnableBlend ( )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GrabPixmap:TPixmap ( x:Int, y:Int, width:Int, height:Int, GL_BUFFER:Int = GL_BACK )

	Local		Pixmap:TPixmap						=	CreatePixmap ( width, height, PF_RGBA8888 )

			StopDraw ( )
			DisableBlend ( )

			glReadBuffer ( GL_BUFFER )
			CheckGLError ( )
							
			glReadPixels ( x, y, width, Height, GL_RGBA,GL_UNSIGNED_BYTE, Pixmap.pixels )
			CheckGLError ( )	
									
			Pixmap							=	YFlipPixmap ( Pixmap )

			EnableBlend ( )
			
	Return	Pixmap
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GrabFrontBuffer:TPixmap ( )
			
	Return ( GrabPixmap ( 0, 0, GraphicsWidth ( ), GraphicsHeight ( ), GL_FRONT ) )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GrabBackBuffer:TPixmap ( )
			
	Return ( GrabPixmap ( 0, 0, GraphicsWidth ( ), GraphicsHeight ( ), GL_BACK ) )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Screenshot ( )
			
		If	FileType ( _AVA_GFX_SCREENSHOT_FOLDER ) = 0 
		
			If	CreateDir ( _AVA_GFX_SCREENSHOT_FOLDER, True ) = False
		
				Error ( "SCREENSHOT : Verzeichnis ~q" + _AVA_GFX_SCREENSHOT_FOLDER + "~q konnte nicht erstellt werden." )
			
			Else
				
				?debug
				DebugLog ( "" )
				DebugLog ( "	[ SCREENSHOT : Verzeichnis ~q" + _AVA_GFX_SCREENSHOT_FOLDER + "~q wurde erstellt. ]" )
				DebugLog ( "" )
				?
			
			EndIf
			
		EndIf
	
	Local	file:String								=	_AVA_GFX_SCREENSHOT_FILE	
	
		If	file
		
			file								=	_AVA_GFX_SCREENSHOT_FOLDER + "\" + file
		
		Else
		
			file								=	_AVA_GFX_SCREENSHOT_FOLDER + "\SCREENSHOT_"  + CurrentDate ( ) + "_" + CurrentTime ( )
			file								=	Replace ( Replace ( file, ":", "_" ), " ", "_" )

		EndIf
		
		If	file

			Local	Pixmap:TPixmap					=	GrabFrontBuffer ( )
				
			Select Upper ( _AVA_GFX_SCREENSHOT_FORMAT )
			Case "PNG"								SavePixmapPNG ( Pixmap, file + ".PNG", _AVA_GFX_SCREENSHOT_PNG_COMP )
			Case "JPG"								SavePixmapJPeg ( Pixmap, file + ".JPG", _AVA_GFX_SCREENSHOT_JPG_QUAL )
			EndSelect
			
		EndIf	
						
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
