'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetShaderAutoFlags ( Flags:Int )

		TShader.AutoFlags						=	Flags

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LoadShader:TShader ( VertexShader_Url:Object, FragmentShader_Url:Object, Flags:Int = -1 )

		Local	n:TShader						=	New TShader
		
		If	Flags = -1
		
			n.Flags						=	TShader.AutoFlags
			
		Else
		
			n.Flags						=	Flags
		
		EndIf
		
		n.Load ( VertexShader_Url, FragmentShader_Url )
		
		Return ( n )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_SHADER:TObjectStack				=	New TObjectStack
Global	_AVA_GFX_ACTIVE_SHADER:TShader			=	Null

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetShader ( n:TShader )

		_AVA_GFX_SHADER.Set ( n )
		_AVA_GFX_ACTIVE_SHADER					=	n
		_AVA_GFX_UPDATE_SHADER ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetShader ( )

		_AVA_GFX_SHADER.Reset ( Null )
		_AVA_GFX_ACTIVE_SHADER					=	Null
		_AVA_GFX_UPDATE_SHADER ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushShader ( n:TShader )

		_AVA_GFX_SHADER.Push ( n )
		_AVA_GFX_ACTIVE_SHADER					=	n
		_AVA_GFX_UPDATE_SHADER ( )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopShader ( )
		
		_AVA_GFX_SHADER.Pop ( )
		_AVA_GFX_ACTIVE_SHADER					=	TShader ( _AVA_GFX_SHADER.Get ( ) )
		_AVA_GFX_UPDATE_SHADER ( )

EndFunction


'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetShader:TShader ( )
		
		Return ( _AVA_GFX_ACTIVE_SHADER )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ShadersAvail:Byte ( )

		Return ( TAvaGraphicsEngine . GL_SHADERS_AVAIL )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetUniform:TShaderUniform ( Shader:TShader, Name:String )

		If	Shader = Null
		
			Error ( "GetUniform : TShader ist Null." )
		
		EndIf

		Return ( TShaderUniform ( MapValueForKey ( Shader.uniform_map, Upper ( Name ) ) ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function UpdateUniform ( Uniform:TShaderUniform, Value:Object )

		If	Uniform = Null
		
			Error ( "UpdateUniform : TShaderUniform ist Null." )
		
		EndIf

		Local	_int:Int [ ]						=	Int [ ] ( Value )
		
		If	_int
		
			Uniform.vi							=	_int
			Uniform.Update ( )
		
			Return
		
		EndIf

		Local	_float:Float [ ]						=	Float [ ] ( Value )
		
		If	_float 
		
			Uniform.vf							=	_float
			Uniform.Update ( )
		
			Return
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_SHADER ( )
		
		If	TAvaGraphicsEngine . GL_SHADERS_AVAIL
		
			StopDraw ( )
			
			If	_AVA_GFX_ACTIVE_SHADER	
	
				glUseProgramObjectARB ( _AVA_GFX_ACTIVE_SHADER.program )
	
				CheckGLError ( )
				
				_AVA_GFX_ACTIVE_SHADER.Update ( )
				
			Else
			
				glUseProgramObjectARB ( 0 )
	
				CheckGLError ( )
			
			EndIf
		
		Else
		
			Error ( "Shaderprogramme werden von der Hardware nicht untersttzt." )
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
