'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TSprite

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		Image:TImage [ ]						=	Null

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		frame:Int							=	0
	
	Field		x:Float							=	0.00
	Field		y:Float							=	0.00
	Field		z:Float							=	0.00
	Field		Layer:Float							=	0.00

	Field		r:Float							=	1.00
	Field		g:Float							=	1.00
	Field		b:Float							=	1.00
	Field		a:Float							=	1.00

	Field		Blend:Int							=	-1

	Field		_Object:Object						=	Null
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	Copy:TSprite ( )
	
	Local		n:TSprite							=	New TSprite
			
			n.Image							=	Image

			n.x								=	x
			n.y								=	y
			n.z								=	z
			n.layer							=	layer

			n.r								=	r
			n.g								=	g
			n.b								=	b
			n.a								=	a

			n.blend							=	blend
	
	Return	( n )	
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	To_Stream ( f:TStream )
			
			WriteByte ( f, 1 )
			WriteShort ( f, Image.Length )
			
			For	Local i:Int = 0 Until Image.Length
			
				WritePixmap ( f, Image [ i ] . Pixmap )
				WriteFloat ( f, Image [ i ] . hx )
				WriteFloat ( f, Image [ i ] . hy )
				
			Next
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	From_Stream:TSprite ( f:TStream, flags:Int )
	
			Select ReadByte ( f )
			
			Case	1	Return ( From_Stream_v1 ( f, flags ) )
			
			EndSelect
			
	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	From_Stream_v1:TSprite ( f:TStream, flags:Int )
	
	Local		n:TSprite							=	New TSprite
			
			n.Image							=	New TImage [ ReadShort ( f ) ]

			For	Local i:Int = 0 Until n.Image.Length
			
				n.Image [ i ]					=	LoadImage ( ReadPixmap ( f ), flags )
				n.Image [ i ] . hx				=	ReadFloat ( f )
				n.Image [ i ] . hy				=	ReadFloat ( f )
				
			Next
	
	Return	( n )
			
	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Draw ( )
			
			PushColor ( r, g, b, a, True )
			
			If	blend > -1 
			
				PushBlend ( Blend )	
						
			EndIf
			
			DrawImage ( Image [ Frame ], x, y ) 

			If	blend > -1 
			
				PopBlend ( )	
						
			EndIf
			
			PopColor ( )
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	Draw_List ( List:TList )

			SortList ( List )
			
			For	Local n:TSprite = EachIn List
			
				n.Draw ( )	
			
			Next

	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Compare:Int ( Obj:Object )
			
			If	Obj = Self
			
				Return ( 0 )
			
			EndIf
	
	Local		n:TSprite							=	TSprite ( Obj )
	
			If	n
			
				If	layer < n.layer
				
					Return ( -1 )
				
				EndIf	

				If	layer > n.layer
				
					Return ( 1 )
				
				EndIf		
						
				If	y < n.y
				
					Return ( -1 )
				
				EndIf	

				If	y > n.y
				
					Return ( 1 )
				
				EndIf	
						
				If	x < n.x
				
					Return ( -1 )
				
				EndIf	

				If	x > n.x
				
					Return ( 1 )
				
				EndIf	
		
			EndIf
			
	Return	( 1 )
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Free ( )

			Image								=	Null
			_Object							=	Null
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	Delete ( )
	
			Free ( )
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

