'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_TRANSFORM_NO_FRACT:Byte				=	False
Global	_AVA_GFX_TRANSFORM_ENABLED:Byte				=	True

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_TRANSFORM_MODIFIED:Int				=	0
Global	_AVA_GFX_TRANSFORM_OFFSET_MODIFIED:Int			=	1
Global	_AVA_GFX_TRANSFORM_ORIGIN_MODIFIED:Int			=	2
Global	_AVA_GFX_TRANSFORM_ROTATION_MODIFIED:Int		=	4
Global	_AVA_GFX_TRANSFORM_SCALE_MODIFIED:Int			=	8
Global	_AVA_GFX_TRANSFORM_HANDLE_MODIFIED:Int			=	16
Global	_AVA_GFX_TRANSFORM_ASPECT_MODIFIED:Int			=	32

Global	_AVA_GFX_TRANSFORM_1:Byte					=	False
Global	_AVA_GFX_TRANSFORM_X1:Float					=	0.00
Global	_AVA_GFX_TRANSFORM_Y1:Float					=	0.00
Global	_AVA_GFX_TRANSFORM_Z1:Float					=	0.00
Global	_AVA_GFX_TRANSFORM_2:Byte					=	False
Global	_AVA_GFX_TRANSFORM_X2:Float					=	1.00
Global	_AVA_GFX_TRANSFORM_Y2:Float					=	1.00
Global	_AVA_GFX_TRANSFORM_Z2:Float					=	1.00
Global	_AVA_GFX_TRANSFORM_3:Byte					=	False
Global	_AVA_GFX_TRANSFORM_X3:Float					=	0.00
Global	_AVA_GFX_TRANSFORM_Y3:Float					=	0.00
Global	_AVA_GFX_TRANSFORM_Z3:Float					=	0.00
Global	_AVA_GFX_TRANSFORM_R:Byte					=	False
Global	_AVA_GFX_TRANSFORM_RCOS:Float				=	0.00
Global	_AVA_GFX_TRANSFORM_RSIN:Float				=	0.00
Global	_AVA_GFX_TRANSFORM_4:Byte					=	False
Global	_AVA_GFX_TRANSFORM_X4:Float					=	0.00
Global	_AVA_GFX_TRANSFORM_Y4:Float					=	0.00

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Transform2D ( x:Float Var, y:Float Var )
		
		Local z:Float
		
		_AVA_GFX_TRANSFORM ( x, y, z )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function Transform3D ( x:Float Var, y:Float Var, z:Float Var )

		_AVA_GFX_TRANSFORM ( x, y, z )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function InvTransform2D ( x:Float Var, y:Float Var )
		
		Local z:Float
		
		_AVA_GFX_INVERSE_TRANSFORM ( x, y, z )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function InvTransform3D ( x:Float Var, y:Float Var, z:Float Var )

		_AVA_GFX_INVERSE_TRANSFORM ( x, y, z )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_TRANSFORM ( x:Float Var, y:Float Var, z:Float Var )
		
		If	_AVA_GFX_TRANSFORM_ENABLED = False
		
			Return
		
		EndIf
		
		If	_AVA_GFX_TRANSFORM_MODIFIED
		
			_AVA_GFX_UPDATE_TRANSFORM ( )
		
		EndIf
			
		If	_AVA_GFX_TRANSFORM_1

			x								:+	_AVA_GFX_TRANSFORM_X1
			y								:+	_AVA_GFX_TRANSFORM_Y1
			z								:+	_AVA_GFX_TRANSFORM_Z1

		EndIf
			
		If	_AVA_GFX_TRANSFORM_2

			x								:*	_AVA_GFX_TRANSFORM_X2
			y								:*	_AVA_GFX_TRANSFORM_Y2
			z								:*	_AVA_GFX_TRANSFORM_Z2
		
		EndIf
		
		If	_AVA_GFX_TRANSFORM_R
		
			Local	_x:Float						=	x
			Local	_y:Float						=	y
		
			x								=	_x * _AVA_GFX_TRANSFORM_RCOS + _Y * _AVA_GFX_TRANSFORM_RSIN
			y								=	_y * _AVA_GFX_TRANSFORM_RCOS - _x * _AVA_GFX_TRANSFORM_RSIN

		EndIf

		If	_AVA_GFX_TRANSFORM_4

			x								:*	_AVA_GFX_TRANSFORM_X4
			y								:*	_AVA_GFX_TRANSFORM_Y4
		
		EndIf
				
		If	_AVA_GFX_TRANSFORM_3

			x								:+	_AVA_GFX_TRANSFORM_X3
			y								:+	_AVA_GFX_TRANSFORM_Y3
			z								:+	_AVA_GFX_TRANSFORM_Z3
			
		EndIf

		If	GetXYSwap ( )
		
			SwapFloats ( x, y )
		
		EndIf
		
		If	GetYZSwap ( )
		
			SwapFloats ( y, z )
		
		EndIf
		
		z									:+	_AVA_GFX_DEPTH.Get ( ) 
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_INVERSE_TRANSFORM ( x:Float Var, y:Float Var, z:Float Var )

		If	_AVA_GFX_TRANSFORM_ENABLED = False
		
			Return
		
		EndIf

		If	_AVA_GFX_TRANSFORM_MODIFIED
		
			_AVA_GFX_UPDATE_TRANSFORM ( )
		
		EndIf

		z									:-	_AVA_GFX_DEPTH.Get ( ) 

		If	GetYZSwap ( )
		
			SwapFloats ( y, z )
		
		EndIf

		If	GetXYSwap ( )
		
			SwapFloats ( x, y )
		
		EndIf
			
		If	_AVA_GFX_TRANSFORM_3

			x								:-	_AVA_GFX_TRANSFORM_X3
			y								:-	_AVA_GFX_TRANSFORM_Y3
			z								:-	_AVA_GFX_TRANSFORM_Z3
			
		EndIf

		If	_AVA_GFX_TRANSFORM_4

			x								:/	_AVA_GFX_TRANSFORM_X4
			y								:/	_AVA_GFX_TRANSFORM_Y4
		
		EndIf

		If	_AVA_GFX_TRANSFORM_R
		
			Local	_x:Float						=	x
			Local	_y:Float						=	y

			Local	_AVA_GFX_TRANSFORM_RCOS:Float		=	Cos ( - _AVA_GFX_ROTATION.Get ( ) )
			Local	_AVA_GFX_TRANSFORM_RSIN:Float		=	Sin ( - _AVA_GFX_ROTATION.Get ( ) )
						
			x								=	_x * _AVA_GFX_TRANSFORM_RCOS + _Y * _AVA_GFX_TRANSFORM_RSIN
			y								=	_y * _AVA_GFX_TRANSFORM_RCOS - _x * _AVA_GFX_TRANSFORM_RSIN

		EndIf

		If	_AVA_GFX_TRANSFORM_2

			x								:/	_AVA_GFX_TRANSFORM_X2
			y								:/	_AVA_GFX_TRANSFORM_Y2
			z								:/	_AVA_GFX_TRANSFORM_Z2
		
		EndIf

		If	_AVA_GFX_TRANSFORM_1

			x								:-	_AVA_GFX_TRANSFORM_X1
			y								:-	_AVA_GFX_TRANSFORM_Y1
			z								:-	_AVA_GFX_TRANSFORM_Z1

		EndIf
			
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_TRANSFORM ( )

		If	_AVA_GFX_TRANSFORM_MODIFIED & _AVA_GFX_TRANSFORM_HANDLE_MODIFIED

			_AVA_GFX_TRANSFORM_X1					=	- _AVA_GFX_HANDLE_X.Get ( )
			_AVA_GFX_TRANSFORM_Y1					=	- _AVA_GFX_HANDLE_Y.Get ( )
			_AVA_GFX_TRANSFORM_Z1					=	- _AVA_GFX_HANDLE_Z.Get ( )
			
			_AVA_GFX_TRANSFORM_1					=	( _AVA_GFX_TRANSFORM_X1 <> 0.00 Or _AVA_GFX_TRANSFORM_Y1 <> 0.00 Or _AVA_GFX_TRANSFORM_Z1 <> 0.00 )

		EndIf
	
		If	_AVA_GFX_TRANSFORM_MODIFIED & _AVA_GFX_TRANSFORM_SCALE_MODIFIED
		
			_AVA_GFX_TRANSFORM_X2					=	_AVA_GFX_SCALE_X.Get ( )
			_AVA_GFX_TRANSFORM_Y2					=	_AVA_GFX_SCALE_Y.Get ( )
			_AVA_GFX_TRANSFORM_Z2					=	_AVA_GFX_SCALE_Z.Get ( )

			_AVA_GFX_TRANSFORM_2					=	( _AVA_GFX_TRANSFORM_X2 <> 1.00 Or _AVA_GFX_TRANSFORM_Y2 <> 1.00 Or _AVA_GFX_TRANSFORM_Z2 <> 1.00 )
			
		EndIf

		If	_AVA_GFX_TRANSFORM_MODIFIED & _AVA_GFX_TRANSFORM_ROTATION_MODIFIED
			
			If	_AVA_GFX_ROTATION.Get ( ) <> 0.00
			
				_AVA_GFX_TRANSFORM_R				=	True
				_AVA_GFX_TRANSFORM_RCOS			=	_AVA_GFX_ROTATION_COS.Get ( )
				_AVA_GFX_TRANSFORM_RSIN			=	_AVA_GFX_ROTATION_SIN.Get ( )
			
			Else
			
				_AVA_GFX_TRANSFORM_R				=	False			
			
			EndIf
						
		EndIf
	
		If	_AVA_GFX_TRANSFORM_MODIFIED & _AVA_GFX_TRANSFORM_ORIGIN_MODIFIED ..
		Or	_AVA_GFX_TRANSFORM_MODIFIED & _AVA_GFX_TRANSFORM_OFFSET_MODIFIED ..
		Or	_AVA_GFX_TRANSFORM_MODIFIED & _AVA_GFX_TRANSFORM_HANDLE_MODIFIED

			_AVA_GFX_TRANSFORM_X3					=	_AVA_GFX_ORIGIN_X.Get ( ) + _AVA_GFX_HANDLE_X.Get ( )
			_AVA_GFX_TRANSFORM_Y3					=	_AVA_GFX_ORIGIN_Y.Get ( ) + _AVA_GFX_HANDLE_Y.Get ( )
			_AVA_GFX_TRANSFORM_Z3					=	_AVA_GFX_ORIGIN_Z.Get ( ) + _AVA_GFX_HANDLE_Z.Get ( )
			
			If	_AVA_GFX_TRANSFORM_MODIFIED & _AVA_GFX_TRANSFORM_OFFSET_MODIFIED
			
				_AVA_GFX_TRANSFORM_X3				:+	_AVA_GFX_OFFSET_X.Get ( ) * _AVA_GFX_SCALE_X.Get ( ) * _AVA_GFX_ASPECT_X.Get ( )
				_AVA_GFX_TRANSFORM_Y3				:+	_AVA_GFX_OFFSET_Y.Get ( ) * _AVA_GFX_SCALE_Y.Get ( ) * _AVA_GFX_ASPECT_Y.Get ( )
				_AVA_GFX_TRANSFORM_Z3				:+	_AVA_GFX_OFFSET_Z.Get ( ) * _AVA_GFX_SCALE_Z.Get ( )
				
			EndIf
			
			_AVA_GFX_TRANSFORM_3					=	( _AVA_GFX_TRANSFORM_X3 <> 0.00 Or _AVA_GFX_TRANSFORM_Y3 <> 0.00 Or _AVA_GFX_TRANSFORM_Z3 <> 0.00 )

		EndIf

		If	_AVA_GFX_TRANSFORM_MODIFIED & _AVA_GFX_TRANSFORM_ASPECT_MODIFIED
		
			_AVA_GFX_TRANSFORM_X4					=	_AVA_GFX_ASPECT_X.Get ( )
			_AVA_GFX_TRANSFORM_Y4					=	_AVA_GFX_ASPECT_Y.Get ( )

			_AVA_GFX_TRANSFORM_4					=	( _AVA_GFX_TRANSFORM_X4 <> 1.00 Or _AVA_GFX_TRANSFORM_Y4 <> 1.00 )
			
		EndIf
		
		_AVA_GFX_TRANSFORM_MODIFIED					=	0
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

