'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFX_UVTRANSFORM_MODIFIED:Int				=	0
Global	_AVA_GFX_UVTRANSFORM_UVOFFSET_MODIFIED:Int		=	1
Global	_AVA_GFX_UVTRANSFORM_UVORIGIN_MODIFIED:Int		=	2
Global	_AVA_GFX_UVTRANSFORM_UVROTATION_MODIFIED:Int		=	4
Global	_AVA_GFX_UVTRANSFORM_UVSCALE_MODIFIED:Int		=	8
Global	_AVA_GFX_UVTRANSFORM_UVHANDLE_MODIFIED:Int		=	16

Global	_AVA_GFX_UVTRANSFORM_UV1:Byte				=	False
Global	_AVA_GFX_UVTRANSFORM_UVX1:Float				=	0.00
Global	_AVA_GFX_UVTRANSFORM_UVY1:Float				=	0.00
Global	_AVA_GFX_UVTRANSFORM_UV2:Byte				=	False
Global	_AVA_GFX_UVTRANSFORM_UVX2:Float				=	1.00
Global	_AVA_GFX_UVTRANSFORM_UVY2:Float				=	1.00
Global	_AVA_GFX_UVTRANSFORM_UV3:Byte				=	False
Global	_AVA_GFX_UVTRANSFORM_UVX3:Float				=	0.00
Global	_AVA_GFX_UVTRANSFORM_UVY3:Float				=	0.00
Global	_AVA_GFX_UVTRANSFORM_UVR:Byte				=	False
Global	_AVA_GFX_UVTRANSFORM_UVRCOS:Float				=	0.00
Global	_AVA_GFX_UVTRANSFORM_UVRSIN:Float				=	0.00

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UVTRANSFORM ( x:Float Var, y:Float Var )
		
		If	_AVA_GFX_UVTRANSFORM_MODIFIED
		
			_AVA_GFX_UPDATE_UVTRANSFORM ( )
		
		EndIf
			
		If	_AVA_GFX_UVTRANSFORM_UV1

			x								:+	_AVA_GFX_UVTRANSFORM_UVX1
			y								:+	_AVA_GFX_UVTRANSFORM_UVY1

		EndIf
			
		If	_AVA_GFX_UVTRANSFORM_UV2

			x								:*	_AVA_GFX_UVTRANSFORM_UVX2
			y								:*	_AVA_GFX_UVTRANSFORM_UVY2
		
		EndIf
		
		If	_AVA_GFX_UVTRANSFORM_UVR
		
			Local	_x:Float						=	x
			Local	_y:Float						=	y
		
			x								=	_x * _AVA_GFX_UVTRANSFORM_UVRCOS + _Y * _AVA_GFX_UVTRANSFORM_UVRSIN
			y								=	_y * _AVA_GFX_UVTRANSFORM_UVRCOS - _x * _AVA_GFX_UVTRANSFORM_UVRSIN

		EndIf

		If	_AVA_GFX_UVTRANSFORM_UV3

			x								:+	_AVA_GFX_UVTRANSFORM_UVX3
			y								:+	_AVA_GFX_UVTRANSFORM_UVY3
			
		EndIf
		
		If	GetUVSwap ( )
		
			SwapFloats ( x, y )
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATE_UVTRANSFORM ( )

		If	_AVA_GFX_UVTRANSFORM_MODIFIED & _AVA_GFX_UVTRANSFORM_UVHANDLE_MODIFIED

			_AVA_GFX_UVTRANSFORM_UVX1				=	- _AVA_GFX_UVHANDLE_X.Get ( )
			_AVA_GFX_UVTRANSFORM_UVY1				=	- _AVA_GFX_UVHANDLE_Y.Get ( )
			
			_AVA_GFX_UVTRANSFORM_UV1				=	( _AVA_GFX_UVTRANSFORM_UVX1 <> 0.00 Or _AVA_GFX_UVTRANSFORM_UVY1 <> 0.00 )

		EndIf
	
		If	_AVA_GFX_UVTRANSFORM_MODIFIED & _AVA_GFX_UVTRANSFORM_UVSCALE_MODIFIED
		
			_AVA_GFX_UVTRANSFORM_UVX2				=	_AVA_GFX_UVSCALE_X.Get ( )
			_AVA_GFX_UVTRANSFORM_UVY2				=	_AVA_GFX_UVSCALE_Y.Get ( )

			_AVA_GFX_UVTRANSFORM_UV2				=	( _AVA_GFX_UVTRANSFORM_UVX2 <> 1.00 Or _AVA_GFX_UVTRANSFORM_UVY2 <> 1.00 )
			
		EndIf

		If	_AVA_GFX_UVTRANSFORM_MODIFIED & _AVA_GFX_UVTRANSFORM_UVROTATION_MODIFIED
			
			If	_AVA_GFX_UVROTATION.Get ( ) <> 0.00
			
				_AVA_GFX_UVTRANSFORM_UVR			=	True
				_AVA_GFX_UVTRANSFORM_UVRCOS			=	_AVA_GFX_UVROTATION_COS.Get ( )
				_AVA_GFX_UVTRANSFORM_UVRSIN			=	_AVA_GFX_UVROTATION_SIN.Get ( )
			
			Else
			
				_AVA_GFX_UVTRANSFORM_UVR			=	False			
			
			EndIf
						
		EndIf
	
		If	_AVA_GFX_UVTRANSFORM_MODIFIED & _AVA_GFX_UVTRANSFORM_UVORIGIN_MODIFIED ..
		Or	_AVA_GFX_UVTRANSFORM_MODIFIED & _AVA_GFX_UVTRANSFORM_UVOFFSET_MODIFIED ..
		Or	_AVA_GFX_UVTRANSFORM_MODIFIED & _AVA_GFX_UVTRANSFORM_UVHANDLE_MODIFIED

			_AVA_GFX_UVTRANSFORM_UVX3				=	_AVA_GFX_UVORIGIN_X.Get ( ) + _AVA_GFX_UVHANDLE_X.Get ( )
			_AVA_GFX_UVTRANSFORM_UVY3				=	_AVA_GFX_UVORIGIN_Y.Get ( ) + _AVA_GFX_UVHANDLE_Y.Get ( )
			
			If	_AVA_GFX_UVTRANSFORM_MODIFIED & _AVA_GFX_UVTRANSFORM_UVOFFSET_MODIFIED
			
				_AVA_GFX_UVTRANSFORM_UVX3			:+	_AVA_GFX_UVOFFSET_X.Get ( ) * _AVA_GFX_UVSCALE_X.Get ( )
				_AVA_GFX_UVTRANSFORM_UVY3			:+	_AVA_GFX_UVOFFSET_Y.Get ( ) * _AVA_GFX_UVSCALE_Y.Get ( )
				
			EndIf
			
			_AVA_GFX_UVTRANSFORM_UV3				=	( _AVA_GFX_UVTRANSFORM_UVX3 <> 0.00 Or _AVA_GFX_UVTRANSFORM_UVY3 <> 0.00 )

		EndIf

		_AVA_GFX_UVTRANSFORM_MODIFIED				=	0
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

