'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GFXVIEWPORT_X:TIntStack					=	New TIntStack
Global	_AVA_GFXVIEWPORT_Y:TIntStack					=	New TIntStack
Global	_AVA_GFXVIEWPORT_WIDTH:TIntStack				=	New TIntStack
Global	_AVA_GFXVIEWPORT_HEIGHT:TIntStack				=	New TIntStack

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetViewport ( x:Int, y:Int, Width:Int, Height:Int, relative:Byte = False )
		
		If	relative
		
			Local	x1:Float						=	Limit ( x, ViewportX ( ), ViewportX ( ) + ViewportWidth ( ) ) 
			Local	y1:Float						=	Limit ( y, ViewportY ( ), ViewportY ( ) + ViewportHeight ( ) ) 
			Local	x2:Float						=	Limit ( x + Width, ViewportX ( ), ViewportX ( ) + ViewportWidth ( ) ) 
			Local	y2:Float						=	Limit ( y + Height, ViewportY ( ), ViewportY ( ) + ViewportHeight ( ) ) 
		
			x								=	x1
			y								=	y1
			Width								=	x2 - x1
			Height							=	y2 - y1
		
		EndIf
		
		_AVA_GFXVIEWPORT_X.Set ( x )
		_AVA_GFXVIEWPORT_Y.Set ( y )
		_AVA_GFXVIEWPORT_WIDTH.Set ( Width )
		_AVA_GFXVIEWPORT_HEIGHT.Set ( Height )
		
		_AVA_GFX_UPDATEVIEWPORT ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ResetViewport ( )

		_AVA_GFXVIEWPORT_X.Reset ( 0 )
		_AVA_GFXVIEWPORT_Y.Reset ( 0 )
		_AVA_GFXVIEWPORT_WIDTH.Reset ( GraphicsWidth ( ) )
		_AVA_GFXVIEWPORT_HEIGHT.Reset ( GraphicsHeight ( ) )
		
		_AVA_GFX_UPDATEVIEWPORT ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PushViewport ( x:Int, y:Int, Width:Int, Height:Int, relative:Byte = False )

		If	relative
		
			Local	x1:Float						=	Limit ( x, ViewportX ( ), ViewportX ( ) + ViewportWidth ( ) ) 
			Local	y1:Float						=	Limit ( y, ViewportY ( ), ViewportY ( ) + ViewportHeight ( ) ) 
			Local	x2:Float						=	Limit ( x + Width, ViewportX ( ), ViewportX ( ) + ViewportWidth ( ) ) 
			Local	y2:Float						=	Limit ( y + Height, ViewportY ( ), ViewportY ( ) + ViewportHeight ( ) ) 
		
			x								=	x1
			y								=	y1
			Width								=	x2 - x1
			Height							=	y2 - y1
		
		EndIf
		
		_AVA_GFXVIEWPORT_X.Push ( x )
		_AVA_GFXVIEWPORT_Y.Push ( y )
		_AVA_GFXVIEWPORT_WIDTH.Push ( Width )
		_AVA_GFXVIEWPORT_HEIGHT.Push ( Height )
		
		_AVA_GFX_UPDATEVIEWPORT ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PopViewport (  )

		_AVA_GFXVIEWPORT_X.Pop ( )
		_AVA_GFXVIEWPORT_Y.Pop ( )
		_AVA_GFXVIEWPORT_WIDTH.Pop ( )
		_AVA_GFXVIEWPORT_HEIGHT.Pop ( )
		
		_AVA_GFX_UPDATEVIEWPORT ( )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetViewport ( X:Int Var, Y:Int Var, Width:Int Var, Height:Int Var )

		X									=	_AVA_GFXVIEWPORT_X.Get ( )
		Y									=	_AVA_GFXVIEWPORT_Y.Get ( )
		Width									=	_AVA_GFXVIEWPORT_WIDTH.Get ( )
		Height								=	_AVA_GFXVIEWPORT_HEIGHT.Get ( )
	
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetViewportArray:Int [ ] ( )

		Return ( [ _AVA_GFXVIEWPORT_X.Get ( ), _AVA_GFXVIEWPORT_Y.Get ( ), _AVA_GFXVIEWPORT_WIDTH.Get ( ), _AVA_GFXVIEWPORT_HEIGHT.Get ( ) ] )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ViewportX:Int ( )

		Return ( _AVA_GFXVIEWPORT_X.Get ( ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ViewportY:Int ( )

		Return ( _AVA_GFXVIEWPORT_Y.Get ( ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ViewportWidth:Int ( )

		Return ( _AVA_GFXVIEWPORT_WIDTH.Get ( ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function ViewportHeight:Int ( )

		Return ( _AVA_GFXVIEWPORT_HEIGHT.Get ( ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function PointInViewport:Byte ( Point_x:Float, Point_y:Float, Transform:Byte = False )

		If	Transform
		
			Transform2D ( Point_x, Point_y )
		
		EndIf
		
		Local x:Int, y:Int, w:Int, h:Int
		
		GetViewport ( x, y, w, h )
		
		Return ( PointInRect ( Point_x, Point_y, x, y, w, h ) )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function RectInViewport:Byte ( Rect_x:Float, Rect_y:Float, Rect_Width:Float, Rect_Height:Float, Transform:Byte = False )

		If	Transform
		
			Local	Point_x:Float					=	Rect_x + Rect_Width
			Local	Point_y:Float					=	Rect_y + Rect_Height
		
			Transform2D ( Rect_x, Rect_y )
			Transform2D ( Point_x, Point_y )
		
			Rect_Width							=	Point_x - Rect_x
			Rect_Height							=	Point_y - Rect_y
		
		EndIf
		
		Local x:Int, y:Int, w:Int, h:Int
		
		GetViewport ( x, y, w, h )
		
		Return ( RectsOverlap ( Rect_x, Rect_y, Rect_Width, Rect_Height, x, y, w, h ) ) ' <- !! berarbeiten !!
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Function	_AVA_GFX_UPDATEVIEWPORT ( )

Local		x:Int									=	_AVA_GFXVIEWPORT_X.Get ( )
Local		y:Int									=	_AVA_GFXVIEWPORT_Y.Get ( )
Local		Width:Int								=	_AVA_GFXVIEWPORT_WIDTH.Get ( )
Local		Height:Int								=	_AVA_GFXVIEWPORT_HEIGHT.Get ( ) 

		x									:/	_AVA_GFX_DISPLAY_WFACTOR
		Width									:/	_AVA_GFX_DISPLAY_WFACTOR
		y									:/	_AVA_GFX_DISPLAY_HFACTOR
		Height								:/	_AVA_GFX_DISPLAY_HFACTOR
		
		StopDraw ( )
		
		If	x = 0 And y = 0 And width = BufferWidth( ) And height = BufferHeight ( )
		
			_AVA_GL_CLIENT._DISABLE ( GL_SCISSOR_TEST )

		Else
		
			_AVA_GL_CLIENT._ENABLE ( GL_SCISSOR_TEST )
			_AVA_GL_CLIENT._SCISSOR ( x, BufferHeight ( ) - y - height, width, height )
		
		EndIf
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

