'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Global	_AVA_GL_CLIENT:TGlClient					=	New TGlClient

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TGlClient

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		bound_texture:Int [ ]					=	Null
	Field		enabled_texture:Int [ ]				=	Null
	Field		active_texture:Int					=	-1
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		bound_framebuffer:Int					=	-1

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		blendfunc:Int [ ]						=	Null
	Field		blend_equation:Int					=	-1

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		color:Float [ ]						=	[ 1.00, 1.00, 1.00, 1.00 ]
	Field		sec_color:Float [ ]					=	[ 0.00, 0.00, 0.00 ]
	Field		cls_color:Float [ ]					=	[ 0.00, 0.00, 0.00, 0.00 ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		u:Float							=	0.00
	Field		v:Float							=	0.00

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		alphafunc:Int						=	GL_ALWAYS
	Field		alphavalue:Float						=	0.00

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Field		polygonmode:Int						=	GL_FILL
	Field		linewidth:Float						=	1.00
	Field		pointsize:Float						=	1.00

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		scissor:Int [ ]						=	[ 0, 0, 0, 0 ]

	Field		display:Float [ ]						=	[ 0.00, 0.00, 0.00, 0.00 ]
	Field		displayrange:Float [ ]					=	[ 0.00, 0.00 ]
	Field		display_mode:Byte						=	-1
	
	Field		depthrange:Float [ ]					=	[ -1.00, 1.00 ]
	Field		depthfunc:Int						=	GL_ALWAYS

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		enabled:Int [ ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		material_color:Float [ 4, 4 ]
	Field		material_shininess:Float				=	0.00

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		light_color:Float [ , , ]
	Field		light_position:Float [ , ]

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Field		normal:Float [ ]						=	[ 0.00, 0.00, 1.00 ]
		
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_TEXCOORD ( x:Float, y:Float, force:Byte = False )
	
			If	force Or x <> u Or y <> v
			
				u							=	x
				v							=	y
				
				glTexCoord2f ( u, v )
			
			EndIf
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_BIND_FRAMEBUFFER ( buffer:Int, force:Byte = False )
	
			If	force Or buffer <> bound_framebuffer
			
				bound_framebuffer					=	buffer
				
				glBindFramebufferEXT ( GL_FRAMEBUFFER_EXT, bound_framebuffer )
			
			EndIf
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_ACTIVE_TEXTURE ( unit:Int, force:Byte = False )
	
			If	force Or unit <> active_texture
				
				active_texture					=	unit
			
				glActiveTexture ( GL_TEXTURE0 + active_texture )
			
			EndIf
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_BIND_TEXTURE ( texture:Int, unit:Int, force:Byte = False )

			If	unit >= bound_texture.length

				 bound_texture					=	 bound_texture [ .. unit + 1 ]

			EndIf
	
			If	force Or texture <> bound_texture [ unit ]
				
				_ACTIVE_TEXTURE ( unit, force )
				
				bound_texture [ unit ]				=	texture
				
				glBindTexture ( GL_TEXTURE_2D, bound_texture [ unit ] )
			
			EndIf
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_BLEND_EQUATION ( mode:Int, force:Byte = False )
	
			If	force Or mode <> blend_equation
			
				blend_equation					=	mode
				glBlendEquation ( blend_equation )
			
			EndIf
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_BLEND_FUNC ( func:Int [ ], force:Byte = False )
	
			If	Not ( func.length = 2 Or func.length = 4 )
			
				Return
			
			EndIf
			
			If	force = False
			
				If	func.length = blendfunc.length

					For	Local i:Int = 0 Until func.length
					
						If	func [ i ] <> blendfunc [ i ]
						
							Exit
						
						EndIf
					
						If	i + 1 = func.length
						
							Return
						
						EndIf
						
					Next
					
				EndIf
			
			EndIf
			
			blendfunc							=	func
			
			Select blendfunc.length
			
				Case	2	glBlendFunc ( blendfunc [ 0 ], blendfunc [ 1 ] )
				Case	4	glBlendFuncSeparate ( blendfunc [ 0 ], blendfunc [ 1 ], blendfunc [ 2 ], blendfunc [ 3 ] )			
			
			EndSelect
						
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_COLOR ( r:Float, g:Float, b:Float, a:Float, force:Byte = False )

			If	force Or r <> color [ 0 ] Or g <> color [ 1 ] Or b <> color [ 2 ] Or a <> color [ 3 ]

				color [ 0 ]						=	r
				color [ 1 ]						=	g
				color [ 2 ]						=	b
				color [ 3 ]						=	a

				glColor4fv ( Varptr color [ 0 ] )
				
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_SEC_COLOR ( r:Float, g:Float, b:Float, force:Byte = False )

			If	force Or r <> sec_color [ 0 ] Or g <> sec_color [ 1 ] Or b <> sec_color [ 2 ]

				sec_color [ 0 ]					=	r
				sec_color [ 1 ]					=	g
				sec_color [ 2 ]					=	b

				glSecondaryColor3fv ( Varptr sec_color [ 0 ] )
				
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_CLS_COLOR ( r:Float, g:Float, b:Float, a:Float, force:Byte = False )

			If	force Or r <> cls_color [ 0 ] Or g <> cls_color [ 1 ] Or b <> cls_color [ 2 ] Or a <> cls_color [ 3 ]

				cls_color [ 0 ]					=	r
				cls_color [ 1 ]					=	g
				cls_color [ 2 ]					=	b
				cls_color [ 3 ]					=	a
				
				glClearColor ( cls_color [ 0 ], cls_color [ 1 ], cls_color [ 2 ], cls_color [ 3 ] )
			
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_POLYGONMODE ( state:Int, force:Byte = False )
	
			If	force Or state <> polygonmode
			
				polygonmode						=	state
				
				glPolygonMode ( GL_FRONT_AND_BACK, polygonmode )
			
			EndIf
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_LINEWIDTH ( w:Float, force:Byte = False )
	
			If	force Or w <> linewidth
			
				linewidth						=	w
				
				glLineWidth ( linewidth )
			
			EndIf
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_POINTSIZE ( s:Float, force:Byte = False )
	
			If	force Or s <> pointsize
			
				pointsize						=	s
				
				glPointSize ( pointsize )
			
			EndIf
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_SCISSOR ( x:Int, y:Int, width:Int, height:Int, force:Byte = False )
	
			If	force Or x <> scissor [ 0 ] Or y <> scissor [ 1 ] Or width <> scissor [ 2 ] Or height <> scissor [ 3 ]
	
				scissor [ 0 ]					=	x
				scissor [ 1 ]					=	y
				scissor [ 2 ]					=	width
				scissor [ 3 ]					=	height
					
				glScissor ( scissor [ 0 ], scissor [ 1 ], scissor [ 2 ], scissor [ 3 ] )
	
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_ORTHO ( x:Float, y:Float, width:Float, height:Float, force:Byte = False )
	
			If	force Or display_mode <> 1 Or x <> display [ 0 ] Or y <> display [ 1 ] Or width <> display [ 2 ] Or height <> display [ 3 ]
	
				display [ 0 ]					=	x
				display [ 1 ]					=	y
				display [ 2 ]					=	width
				display [ 3 ]					=	height
				display_mode					=	1
				
				glMatrixMode ( GL_PROJECTION )
				glLoadIdentity ( )
					
				glOrtho ( display [ 0 ], display [ 1 ], display [ 2 ], display [ 3 ], depthrange [ 0 ], depthrange [ 1 ] )

				glMatrixMode ( GL_MODELVIEW )
				glLoadIdentity ( )

			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_FRUSTUM ( x:Float, y:Float, width:Float, height:Float, near:Float, far:Float, force:Byte = False )
	
			If	force Or display_mode <> 2 Or x <> display [ 0 ] Or y <> display [ 1 ] Or width <> display [ 2 ] Or height <> display [ 3 ] Or near <> displayrange [ 0 ] Or far <> displayrange [ 1 ]
	
				display [ 0 ]					=	x
				display [ 1 ]					=	y
				display [ 2 ]					=	width
				display [ 3 ]					=	height
				displayrange [ 0 ]				=	near
				displayrange [ 1 ]				=	far
				display_mode					=	2
				
				glMatrixMode ( GL_PROJECTION )
				glLoadIdentity ( )

				glFrustum ( display [ 0 ], display [ 1 ], display [ 2 ], display [ 3 ], displayrange [ 0 ], displayrange [ 1 ] )

				glMatrixMode ( GL_MODELVIEW )
				glLoadIdentity ( )
	
			EndIf
			
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_DEPTH_RANGE ( near:Float, far:Float, force:Byte = False )
	
			If	force Or near <> depthrange [ 0 ] Or far <> depthrange [ 1 ]
			
				depthrange [ 0 ]					=	near
				depthrange [ 1 ]					=	far
				
				glDepthRange ( depthrange [ 0 ], depthrange [ 1 ] )
				
				Select display_mode
				
					Case	1	_ORTHO ( display [ 0 ], display [ 1 ], display [ 2 ], display [ 3 ], True )
				'	Case	2	_FRUSTUM ( display [ 0 ], display [ 1 ], display [ 2 ], display [ 3 ], near, far, True )				
				
				EndSelect
			
			EndIf
	
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_DEPTH_FUNC ( func:Int, force:Byte = False )
	
			If	force Or func <> depthfunc
			
				depthfunc						=	func
				
				glDepthFunc ( depthfunc )
			
			EndIf
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_ALPHA_FUNC ( func:Int, value:Float, force:Byte = False )
	
			If	force Or func <> alphafunc Or value <> alphavalue
			
				alphafunc						=	func
				alphavalue						=	value
				
				glAlphaFunc ( alphafunc, alphavalue )
			
			EndIf
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_ENABLE ( state:Int, force:Byte = False )
	
			If	state = GL_TEXTURE_2D
			
				If	active_texture >= enabled_texture.length
				
					enabled_texture				=	enabled_texture [ .. active_texture + 1 ]
				
				EndIf
			
				If	force Or enabled_texture [ active_texture ] <> 1
					
					enabled_texture [ active_texture ]	=	1
					glEnable ( state )
	
				EndIf
			
			Else
			
				If	state >= enabled.length
	
					enabled					=	enabled [ .. state + 1 ]
	
				EndIf
				
				If	force Or enabled [ state ] <> 1
					
					enabled [ state ]				=	1
					glEnable ( state )
	
				EndIf
			
			EndIf
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_DISABLE ( state:Int, force:Byte = False )

			If	state = GL_TEXTURE_2D
			
				If	active_texture >= enabled_texture.length
				
					enabled_texture				=	enabled_texture [ .. active_texture + 1 ]
				
				EndIf
			
				If	force Or enabled_texture [ active_texture ] <> -1
					
					enabled_texture [ active_texture ]	=	-1
					glDisable ( state )
	
				EndIf
			
			Else

				If	state >= enabled.length
	
					enabled					=	enabled [ .. state + 1 ]
	
				EndIf
				
				If	force Or enabled [ state ] <> -1
	
					enabled [ state ]				=	-1
					glDisable ( state )
	
				EndIf
			
			EndIf
			
	EndMethod
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	_MATERIAL_COLOR ( Target:Int, Color:Float [ ], Force:Byte = False )

	Local		Index:Int							=	0

			Select Target
			
				Case	GL_AMBIENT			Index		=	0
				Case	GL_DIFFUSE			Index		=	1
				Case	GL_SPECULAR			Index		=	2			
				Case	GL_EMISSION			Index		=	3
			
			EndSelect
			
			If	Force ..
			Or	Material_Color [ Index, 0 ] <> Color [ 0 ] ..
			Or	Material_Color [ Index, 1 ] <> Color [ 1 ] ..
			Or	Material_Color [ Index, 2 ] <> Color [ 2 ] ..
			Or	Material_Color [ Index, 3 ] <> Color [ 3 ]
			
				Material_Color [ Index, 0 ]			=	Color [ 0 ]
				Material_Color [ Index, 1 ]			=	Color [ 1 ]
				Material_Color [ Index, 2 ]			=	Color [ 2 ]
				Material_Color [ Index, 3 ]			=	Color [ 3 ]
			
				glMaterialFV ( GL_FRONT, Target, Color )
			
			EndIf

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	_MATERIAL_SHININESS ( Value:Float, Force:Byte = False )

	Local		Index:Int							=	0
			
			If	Force ..
			Or	Material_Shininess <> Value
			
				Material_Shininess				=	Value
			
				glMaterialF ( GL_FRONT, GL_SHININESS, Value )
			
			EndIf

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	_LIGHT_COLOR ( Light:Int, Target:Int, Color:Float [ ], Force:Byte = False )

	Local		Index:Int							=	0

			Select Target
			
				Case	GL_AMBIENT			Index		=	0
				Case	GL_DIFFUSE			Index		=	1
				Case	GL_SPECULAR			Index		=	2			
			
			EndSelect
			
			If	Force ..
			Or	Light_Color [ Light, Index, 0 ] <> Color [ 0 ] ..
			Or	Light_Color [ Light, Index, 1 ] <> Color [ 1 ] ..
			Or	Light_Color [ Light, Index, 2 ] <> Color [ 2 ] ..
			Or	Light_Color [ Light, Index, 3 ] <> Color [ 3 ]
			
				Light_Color [ Light, Index, 0 ]		=	Color [ 0 ]
				Light_Color [ Light, Index, 1 ]		=	Color [ 1 ]
				Light_Color [ Light, Index, 2 ]		=	Color [ 2 ]
				Light_Color [ Light, Index, 3 ]		=	Color [ 3 ]
			
				glLightFV ( GL_LIGHT0 + Light, Target, Color )
			
			EndIf

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Method	_LIGHT_POSITION ( Light:Int, Position:Float [ ], Force:Byte = False )

			
			If	Force ..
			Or	Light_Position [ Light, 0 ] <> Position [ 0 ] ..
			Or	Light_Position [ Light, 1 ] <> Position [ 1 ] ..
			Or	Light_Position [ Light, 2 ] <> Position [ 2 ] ..
			Or	Light_Position [ Light, 3 ] <> Position [ 3 ]
			
				Light_Position [ Light, 0 ]			=	Position [ 0 ]
				Light_Position [ Light, 1 ]			=	Position [ 1 ]
				Light_Position [ Light, 2 ]			=	Position [ 2 ]
				Light_Position [ Light, 3 ]			=	Position [ 3 ]
			
				glLightFV ( GL_LIGHT0 + Light, GL_POSITION, Position )
			
			EndIf

	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	_NORMAL ( nx:Float, ny:Float, nz:Float, Force:Byte = False )
	
			If	Force Or nx <> normal [ 0 ] Or ny <> normal [ 1 ] Or nz <> normal [ 2 ]
			
				normal [ 0 ]					=	nx
				normal [ 1 ]					=	ny
				normal [ 2 ]					=	nz
			
				glNormal3f ( nx, ny, nz )
			
			EndIf
	
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	_GEN_TEXTURE:Int ( Pixmap:TPixmap, Flags:Int, CALLBACK ( texture:Int ) )
	
	Local		Texture:Int							=	-1

			glGenTextures ( 1, Varptr Texture )
			CheckGLError ( )
						
			If	CALLBACK
			
				CALLBACK ( texture )
			
			EndIf

			If	Flags & 1 ' FilteredImage

				If	Flags & 2 ' MipmappedImage
				
					glTexParameteri ( GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR )
				
				Else
				
					glTexParameteri ( GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR )
				
				EndIf			

				glTexParameteri ( GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_LINEAR )

			Else
						
				glTexParameteri ( GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_NEAREST )
				glTexParameteri ( GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_NEAREST )
				
			EndIf
			
			If	Flags & 2 ' MipmappedImage
			
				glTexParameteri ( GL_TEXTURE_2D, GL_GENERATE_MIPMAP, True )
			
			EndIf

			If	Flags & 4 ' ClampedImage
			
				glTexParameteri GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP_TO_EDGE
				glTexParameteri GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP_TO_EDGE
		
			EndIf
						
			glPixelStorei ( GL_UNPACK_ROW_LENGTH, Pixmap.pitch / BytesPerPixel [ Pixmap.format ] )
			CheckGLError ( )
			
			glActiveTexture ( GL_TEXTURE0 )
			CheckGLError ( )
			glBindTexture ( GL_TEXTURE_2D, Texture )
			CheckGLError ( )
			
			glTexImage2D ( GL_TEXTURE_2D, 0, GL_RGBA, PixmapWidth ( Pixmap ), PixmapHeight ( Pixmap ), 0, GL_RGBA, GL_UNSIGNED_BYTE, Null )
			CheckGLError ( )

			glTexSubImage2D ( GL_TEXTURE_2D, 0, 0, 0, PixmapWidth ( Pixmap ), PixmapHeight ( Pixmap ), GL_RGBA, GL_UNSIGNED_BYTE, Pixmap.pixels )
			CheckGLError ( )
			
	Return	( Texture )
	
	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	_GEN_FRAMEBUFFER:Byte ( Width:Int, Height:Int, Texture:Int, Frame_Buffer:Int Var, Render_Buffer:Int Var )

			glGenFramebuffersEXT ( 1, Varptr frame_buffer )
			glGenRenderbuffersEXT ( 1, Varptr render_buffer )

			If	frame_buffer = 0 Or render_buffer = 0
				
				Return ( False )
					
			EndIf

				glBindFramebufferEXT ( GL_FRAMEBUFFER_EXT, frame_buffer )
				CheckGLError ( )

				glFramebufferTexture2DEXT ( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_TEXTURE_2D, texture, 0 )
				CheckGLError ( )

				glBindRenderbufferEXT ( GL_RENDERBUFFER_EXT, render_buffer )
				CheckGLError ( )

				glRenderbufferStorageEXT ( GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT24, width, height )
				CheckGLError ( )

				glFramebufferRenderbufferEXT ( GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, render_buffer )
				CheckGLError ( )
		
				?debug
				
					Local FBO_ERROR:String			=		""
					
					Select glCheckFramebufferStatusEXT ( GL_FRAMEBUFFER_EXT )
					
						Case	GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT
						
							FBO_ERROR			=		"GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT"
							
						Case	GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT
						
							FBO_ERROR			=		"GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT"
							
						Case	GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT
						
							FBO_ERROR			=		"GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT"	
										
						Case	GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT
						
							FBO_ERROR			=		"GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT"	
										
						Case	GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT
						
							FBO_ERROR			=		"GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT"	
										
						Case	GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT
						
							FBO_ERROR			=		"FGL_RAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT"
											
						Case	GL_FRAMEBUFFER_UNSUPPORTED_EXT
						
							FBO_ERROR			=		"GL_FRAMEBUFFER_UNSUPPORTED_EXT"
							
					EndSelect
					
					If	FBO_ERROR
					
						Error ( "[ GL_FBO_ERROR : " + FBO_ERROR + " ]" )
					
					EndIf	
					
				?
							
			Return ( True )
							
	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

