'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	SETTINGS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

SuperStrict

Rem
bbdoc: AVA.IncludeCreator
about: 
End Rem
Module AVA.IncludeCreator

ModuleInfo	"Version: 0.00"
ModuleInfo	"Authors: Ava Vanessa Poldrack"
ModuleInfo	"License: NA"
ModuleInfo	"Copyright: Ava Vanessa Poldrack"

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Import AVA.Core
Import BRL.FileSystem

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
about:
End Rem
Function CreateIncludeFile ( File:String, Folders:String [ ], FileExtensions:String [ ], SubFolders:Byte = True )

		Local	Stream:TStream						=	WriteFile ( File )
		
		Select True
		
			Case	Stream = Null						Error ( "CreateIncludeFile : Datei ~q" + File + "~q konnte nicht erstellt werden." )
		
		EndSelect

		WriteLine ( Stream, "'---------------------------------------------------------------------------------------------------------------------------------------------------------" )
		WriteLine ( Stream, "'	INCLUDE" )
		WriteLine ( Stream, "'---------------------------------------------------------------------------------------------------------------------------------------------------------" )
		WriteLine ( Stream, "" )

		For	Local Folder:String = EachIn Folders
		
			WriteLine ( Stream, "" )
			
			RunFolder ( Stream, Folder, FileExtensions, SubFolders )
			
			WriteLine ( Stream, "" )
			
		Next

		Function RunFolder ( Stream:TStream, Folder:String, FileExtensions:String [ ], SubFolders:Byte )
			
			Print ( "" )
			Print ( "[ Run Folder ~q" + Folder + "~q ]" )
			Print ( "" )

			Local Content:String [ ]				=	LoadDir ( Folder )
			
			For	Local File:String = EachIn Content
			
				If	FileType ( Folder + "/" + File ) = 2 And SubFolders
				
					WriteLine ( Stream, "" )
					
					RunFolder ( Stream, Folder + "/" + File, FileExtensions, SubFolders )
					
					WriteLine ( Stream, "" )
				
				Else
				
					If	CheckExtension ( File, FileExtensions )

						Print ( "  ->  ~q" + File + "~q ]" )
					
						WriteLine ( Stream, "	Include ~q" + Folder + "/" + File + "~q" )
					
					EndIf
				
				EndIf
			
			Next
		
		EndFunction
		
		Function CheckExtension:Byte ( File:String, FileExtensions:String [ ] )
		
			Local	Extension:String					=	Upper ( ExtractExt ( File ) )
			
			For	Local Ext:String = EachIn FileExtensions
		
				If	Upper ( Ext ) = Extension
				
					Return ( True )
				
				EndIf
		
			Next
		
			Return ( False )
			
		EndFunction

		WriteLine ( Stream, "" )
		WriteLine ( Stream, "'---------------------------------------------------------------------------------------------------------------------------------------------------------" )
		WriteLine ( Stream, "'" )
		WriteLine ( Stream, "'---------------------------------------------------------------------------------------------------------------------------------------------------------" )
				
		CloseFile ( Stream )
		
EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

