'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TYPE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TMediaLoader

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	GLOBALS
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Global	FileExtMap:TMap						=	CreateMap ( )
	Global	MediaMap:TMap						=	CreateMap ( )

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Global	Handle:String [ ]						=	Null
	Global	File:String [ ]						=	Null
	Global	Ext:String [ ]						=	Null
	Global	Flags:Int [ ]						=	Null
	Global	Tag:String [ ]						=	Null
	Global	FloatValues:Float [ ] [ ]				=	Null
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Global	ProgressFunc ( )						=	Null
	
	Global	Progress:Float						=	0.00
	Global	Progress_State:String					=	""
	Global	Progress_FileIndex:Int					=	0
	Global	Progress_FileCount:Int					=	0
		
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Function	Load ( FileExt:String [ ] )
			
			Progress							=	0.00
			Progress_State						=	""
			Progress_FileIndex					=	0
			Progress_FileCount					=	0

			?debug
					
				Print ( "" )
				Print ( "[ LOAD MEDIA ] " )
				Print ( "" )
									
			?
			
			For	Local i:Int = 0 Until Handle.Length
			
				If	FileExt = Null Or InExt ( Ext [ i ], FileExt )
					
					Progress_FileCount			:+	1
				
				EndIf
			
			Next
			
			Local	Loader:TMediaLoader				=	Null

			For	Local i:Int = 0 Until Handle.Length
			
				If	FileExt = Null Or InExt ( Ext [ i ], FileExt )

					Progress_State				=	Replace ( File [ i ], "incbin::", "" )
					Progress_FileIndex			:+	1
					Progress					=	( Progress_FileIndex / Float ( Progress_FileCount ) )
					
					?debug
					
						Print ( "  " + Handle [ i ] + "			~q" + File [ i ] + "~q" )
					
					?
					
					If	ProgressFunc <> Null
					
						ProgressFunc ( )
					
					EndIf
									
					Loader					=	TMediaLoader ( MapValueForKey ( FileExtMap, Ext [ i ] ) )
					
					If	Loader
					
						Loader.LoadFile ( i )					
					
					EndIf
				
				EndIf
			
			Next
			
			?debug
			
				Print ( "" )
			
			?
			
	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	InExt:Byte ( Ext:String, FileExt:String [ ] )

			For	Local CheckExt:String = EachIn FileExt
			
				If	Ext = CheckExt
				
					Return ( True )
				
				EndIf
			
			Next

			Return ( False )
			
	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	METHODS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Method	LoadFile ( Index:Int )
	EndMethod

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FINISHED
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	EXTERNAL FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function RegisterMediaLoader ( MediaLoader:TMediaLoader, FileExt:String [ ] )

		For	Local Ext:String = EachIn FileExt
		
			MapInsert ( TMediaLoader.FileExtMap, Upper ( Ext ), MediaLoader )
		
		Next

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function LoadMedia ( FileExt:String [ ] = Null )

		TMediaLoader.Load ( FileExt )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetMediaProgressFunc ( Func ( ) )

		TMediaLoader.ProgressFunc					=	Func

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function AddMedia ( Handle:String, File:String, Flags:Int = -1, Tag:String = "", FloatValues:Float [ ] = Null )

		TMediaLoader.Handle						:+	[ Handle ]
		TMediaLoader.File							:+	[ Lower ( File ) ]
		TMediaLoader.Ext							:+	[ Upper ( ExtractExt ( File ) ) ]
		TMediaLoader.Flags						:+	[ Flags ]
		TMediaLoader.Tag							:+	[ Tag ]
		TMediaLoader.FloatValues					:+	[ FloatValues ]

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetMedia:Object ( Handle:String )
		
		Local	n:Object							=	MapValueForKey ( TMediaLoader.MediaMap, Handle )
		
		If	n = Null
		
			Error ( "GetMedia : Objekt ~q" + Handle + "~q existiert nicht." )
		
		EndIf
		
		Return ( n )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
