'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	TMOUSE
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Type TMouse

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	GLOBALS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Global	x:Int								=	0
	Global	y:Int								=	0
	Global	z:Int								=	0
	Global	moved_x:Int							=	0
	Global	moved_y:Int							=	0
	Global	moved_z:Int							=	0

	Global	hit2:Byte [ 3 ]
	Global	hit:Byte [ 3 ]
	Global	up:Byte [ 3 ]
	Global	down:Byte [ 3 ]
	
	Global	hit2_time:Int						=	200
	Global	hit_timer:Int [ 3 ]
	
	Global	f_draw ( )							=	Null
	Global	image:TImage						=	Null
	Global	visible:Byte						=	True
	Global	pointer_size:Float					=	1.00
	Global	full_display:Byte						=	True
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	update (  )

			moved_x							=	MouseX ( ) - x
			moved_y							=	MouseY ( ) - y
			moved_z							=	MouseZ ( ) - z
			x								:+	moved_x
			y								:+	moved_y
			z								:+	moved_z
			
			For	Local i:Int = 0 To 2
				
				hit [ i ]						=	MouseHit ( i + 1 )
				hit2 [ i ]						=	False
				
				If	hit [ i ]
					
					If	hit_timer [ i ] > MilliSecs ( )
					
						hit2 [ i ]				=	True
					
					EndIf
					
					hit_timer [ i ]				=	MilliSecs ( ) + hit2_time				
					
				EndIf
	
				If	MouseDown ( i + 1 )
				
					up [ i ]					=	False
					down [ i ]					=	True
				
				Else
				
					up [ i ]					=	down [ i ]
					down [ i ]					=	False
				
				EndIf
						
			Next			
			
	EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	move ( to_x:Int, to_y:Int )

			x								=	to_x
			y								=	to_y
			
			MoveMouse ( x, y )			

	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Function	SHOW ( )

			visible							=	True

	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
	
	Function	HIDE ( )

			visible							=	False

	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	DRAW ( )
	
	Local		X:Float							=	Self.x
	Local		Y:Float							=	Self.y

			If	visible = False
				
				Return
			
			EndIf
			
			PushOrigin ( 0, 0, 0, False )
			
				If	Full_Display
				
					PushDisplay ( GraphicsWidth ( ), GraphicsHeight ( ) )
				
				Else
													
					x						=	GetMouseX ( )
					y						=	GetMouseY ( )
				
				EndIf
		
				If	IMAGE
					
					PushScale ( pointer_size, pointer_size )
					
						DrawImage ( IMAGE, x, y )
				
					PopScale ( )
					
				Else
				
					StartDraw ( GL_TRIANGLES )
					
						PushOrigin ( 1.00 * pointer_size, 3.00 * pointer_size )
						DrawVertex ( x, y, 0, 0, 0, 0.00, 0.00, 0.00, 0.50 )
						DrawVertex ( x + 28.00 * pointer_size, y + 16.00 * pointer_size, 0, 0, 0, 0.00, 0.00, 0.00, 0.25 )
						DrawVertex ( x + 8.00 * pointer_size, y + 32.00 * pointer_size, 0, 0, 0, 0.00, 0.00, 0.00, 0.25 )
						PopOrigin ( )
											
						DrawVertex ( x, y, 0, 0, 0, 1.00, 1.00, 1.00, 1.00 )
						DrawVertex ( x + 28.00 * pointer_size, y + 16.00 * pointer_size, 0, 0, 0, 0.50, 0.50, 0.50, 0.75 )
						DrawVertex ( x + 8.00 * pointer_size, y + 32.00 * pointer_size, 0, 0, 0, 0.50, 0.50, 0.50, 0.75 )
	
					EndDraw ( )					
					
					PushLineWidth ( 1.50 * pointer_size )	
	
					StartDraw ( GL_LINE_STRIP )
						
						DrawVertex ( x + 28.00 * pointer_size, y + 16.00 * pointer_size, 0, 0, 0, 1, 1, 1, 0 )
						DrawVertex ( x, y, 0, 0, 0, 1, 1, 1 )
						DrawVertex ( x + 8.00 * pointer_size, y + 32.00 * pointer_size, 0, 0, 0, 1, 1, 1, 0 )
	
					EndDraw ( )	
					
					PopLineWidth ( )			
					
				EndIf
	
				If	Full_Display
				
					PopDisplay ( )
				
				EndIf
				
			PopOrigin ( )
							
	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FLIP HOOK
'---------------------------------------------------------------------------------------------------------------------------------------------------------

	Function	_FLIP_HOOK:Object ( id:Int, data:Object, context:Object ) 
		
			TMouse.UPDATE
			TMouse.DRAW
						
	EndFunction
	
'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FINISHED
'---------------------------------------------------------------------------------------------------------------------------------------------------------

EndType

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	EXTERNAL FUNCTIONS
'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetMouseX:Int ( )

		Return ( TMouse.X * _AVA_GFX_DISPLAY_WFACTOR )

EndFunction

Rem
bbdoc:
End Rem
Function GetMouseY:Int ( )

		Return ( TMouse.Y * _AVA_GFX_DISPLAY_HFACTOR )

EndFunction

Rem
bbdoc:
End Rem
Function GetMouseZ:Int ( )

		Return ( TMouse.Z )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function MouseMovedX:Int ( )

		Return ( TMouse.Moved_X * _AVA_GFX_DISPLAY_WFACTOR )

EndFunction

Rem
bbdoc:
End Rem
Function MouseMovedY:Int ( )

		Return ( TMouse.Moved_Y * _AVA_GFX_DISPLAY_HFACTOR )

EndFunction

Rem
bbdoc:
End Rem
Function MouseMovedZ:Int ( )

		Return ( TMouse.Moved_Z )

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function FlushMouseHit ( Index:Int )

		If	IndeX > 0 And Index < 4
		
			TMouse.Hit [ Index - 1 ] = False
			TMouse.Hit2 [ Index - 1 ] = False
			
		EndIf

EndFunction

Rem
bbdoc:
End Rem
Function SetMouseHit ( Index:Int, Value:Byte )

		If	IndeX > 0 And Index < 4
			
			TMouse.Hit [ Index - 1 ] = ( Value > 0 )
			TMouse.Hit2 [ Index - 1 ] = ( Value = 2 )
						
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetMouseHit:Byte ( Index:Int )

		If	IndeX > 0 And Index < 4
		
			Return ( TMouse.Hit [ Index - 1 ] )
		
		Else
		
			Return ( False )
			
		EndIf

EndFunction

Rem
bbdoc:
End Rem
Function GetMouseDoubleHit:Byte ( Index:Int )

		If	IndeX > 0 And Index < 4
		
			Return ( TMouse.Hit2 [ Index - 1 ] )
		
		Else
		
			Return ( False )
			
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetMouseDown:Byte ( Index:Int )

		If	IndeX > 0 And Index < 4
		
			Return ( TMouse.Down [ Index - 1 ] )
		
		Else
		
			Return ( False )
			
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function GetMouseUp:Byte ( Index:Int )

		If	IndeX > 0 And Index < 4
		
			Return ( TMouse.Up [ Index - 1 ] )
		
		Else
		
			Return ( False )
			
		EndIf

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetMouseImage ( Image:TImage )

		TMouse.Image							=	Image

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------

Rem
bbdoc:
End Rem
Function SetMouseSize ( Scale:Float )

		TMouse.Pointer_Size						=	Scale

EndFunction

'---------------------------------------------------------------------------------------------------------------------------------------------------------
'	FINISHED
'---------------------------------------------------------------------------------------------------------------------------------------------------------

